DROP TABLE IF EXISTS `#__banner`;
CREATE TABLE `#__banner` (
  `bid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` varchar(30) NOT NULL DEFAULT 'banner',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `imageurl` varchar(100) NOT NULL DEFAULT '',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `date` datetime DEFAULT NULL,
  `showBanner` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor` varchar(50) DEFAULT NULL,
  `custombannercode` text,
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `tags` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`bid`),
  KEY `viewbanner` (`showBanner`),
  KEY `idx_banner_catid` (`catid`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
INSERT INTO `#__banner` VALUES
(1,1,'banner','OSM 1','osm-1',0,43,0,'osmbanner1.png','http://www.opensourcematters.org','2004-07-07 15:31:29',1,0,'0000-00-00 00:00:00','','',13,'',0,1,'0000-00-00 00:00:00','0000-00-00 00:00:00','',''),
(2,1,'banner','OSM 2','osm-2',0,49,0,'osmbanner2.png','http://www.opensourcematters.org','2004-07-07 15:31:29',1,0,'0000-00-00 00:00:00','','',13,'',0,2,'0000-00-00 00:00:00','0000-00-00 00:00:00','',''),
(3,1,'','Joomla!','joomla',0,4580,0,'','http://www.joomla.org','2010-01-16 04:40:28',1,0,'0000-00-00 00:00:00','','<a href=\"{CLICKURL}\" target=\"_blank\" class=\"name_acticle\">{NAME}</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.',14,'',0,1,'0000-00-00 00:00:00','0000-00-00 00:00:00','','width=0\nheight=0'),
(4,1,'','JoomlaCode','joomlacode',0,4580,0,'','http://joomlacode.org','2010-01-16 04:40:48',1,0,'0000-00-00 00:00:00','','<a href=\"{CLICKURL}\" target=\"_blank\" class=\"name_acticle\">{NAME}</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.',14,'',0,2,'0000-00-00 00:00:00','0000-00-00 00:00:00','','width=0\nheight=0'),
(5,1,'','Joomla! Extensions','joomla-extensions',0,266,0,'','http://extensions.joomla.org','2006-05-29 14:23:21',1,0,'0000-00-00 00:00:00','','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomla! Components, Modules, Plugins and Languages by the bucket load.',14,'',0,3,'0000-00-00 00:00:00','0000-00-00 00:00:00','',''),
(6,1,'','Joomla! Shop','joomla-shop',0,266,0,'','http://shop.joomla.org','2006-05-29 14:23:21',1,0,'0000-00-00 00:00:00','','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nFor all your Joomla! merchandise.',14,'',0,4,'0000-00-00 00:00:00','0000-00-00 00:00:00','',''),
(7,1,'','Joomla! Promo Shop','joomla-promo-shop',0,130,1,'shop-ad.jpg','http://shop.joomla.org','2007-09-19 17:26:24',1,0,'0000-00-00 00:00:00','','',33,'',0,3,'0000-00-00 00:00:00','0000-00-00 00:00:00','',''),
(8,1,'','Joomla! Promo Books','joomla-promo-books',0,110,0,'shop-ad-books.jpg','http://shop.joomla.org/amazoncom-bookstores.html','2007-09-19 17:28:01',1,0,'0000-00-00 00:00:00','','',33,'',0,4,'0000-00-00 00:00:00','0000-00-00 00:00:00','','');


DROP TABLE IF EXISTS `#__bannerclient`;
CREATE TABLE `#__bannerclient` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `checked_out` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out_time` time DEFAULT NULL,
  `editor` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
INSERT INTO `#__bannerclient` VALUES
(1,'Open Source Matters','Administrator','admin@opensourcematters.org','',0,'00:00:00',null);


DROP TABLE IF EXISTS `#__bannertrack`;
CREATE TABLE `#__bannertrack` (
  `track_date` date NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `image` varchar(255) NOT NULL DEFAULT '',
  `section` varchar(50) NOT NULL DEFAULT '',
  `image_position` varchar(30) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor` varchar(50) DEFAULT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`section`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`)
) ENGINE=MyISAM AUTO_INCREMENT=40 DEFAULT CHARSET=utf8;
INSERT INTO `#__categories` VALUES
(1,0,'Latest','','latest-news','taking_notes.jpg','1','left','The latest news from the Joomla! Team',1,62,'2010-01-14 03:14:23','',1,0,1,''),
(2,0,'Joomla! Specific Links','','joomla-specific-links','clock.jpg','com_weblinks','left','A selection of links that are all related to the Joomla! Project.',1,0,'0000-00-00 00:00:00',null,1,0,0,''),
(3,0,'Newsflash','','newsflash','','1','left','',1,0,'0000-00-00 00:00:00','',2,0,0,''),
(4,0,'Joomla!','','joomla','','com_newsfeeds','left','',1,0,'0000-00-00 00:00:00',null,2,0,0,''),
(5,0,'Free and Open Source Software','','free-and-open-source-software','','com_newsfeeds','left','Read the latest news about free and open source software from some of its leading advocates.',1,0,'0000-00-00 00:00:00',null,3,0,0,''),
(6,0,'Related Projects','','related-projects','','com_newsfeeds','left','Joomla builds on and collaborates with many other free and open source projects. Keep up with the latest news from some of them.',1,0,'0000-00-00 00:00:00',null,4,0,0,''),
(12,0,'Contacts','','contacts','','com_contact_details','left','Contact Details for this Web site',1,0,'0000-00-00 00:00:00',null,0,0,0,''),
(13,0,'Joomla','','joomla','','com_banner','left','',1,0,'0000-00-00 00:00:00',null,0,0,0,''),
(14,0,'Text Ads','','text-ads','','com_banner','left','',1,0,'0000-00-00 00:00:00',null,0,0,0,''),
(15,0,'Features','','features','','com_content','left','',0,0,'0000-00-00 00:00:00',null,6,0,0,''),
(17,0,'Benefits','','benefits','','com_content','left','',0,0,'0000-00-00 00:00:00',null,4,0,0,''),
(18,0,'Platforms','','platforms','','com_content','left','',0,0,'0000-00-00 00:00:00',null,3,0,0,''),
(19,0,'Other Resources','','other-resources','','com_weblinks','left','',1,0,'0000-00-00 00:00:00',null,2,0,0,''),
(29,0,'The CMS','','the-cms','','4','left','Information about the software behind Joomla!<br />',1,0,'0000-00-00 00:00:00',null,2,0,0,''),
(28,0,'Current Users','','current-users','','3','left','Questions that users migrating to Joomla! 1.5 are likely to raise<br />',1,0,'0000-00-00 00:00:00',null,2,0,0,''),
(25,0,'The Project','','the-project','','4','left','General facts about Joomla!<br />',1,62,'2010-01-18 17:40:26',null,1,0,0,''),
(27,0,'New to Joomla!','','new-to-joomla','','3','left','Questions for new users of Joomla!',1,0,'0000-00-00 00:00:00',null,3,0,0,''),
(30,0,'The Community','','the-community','','4','left','About the millions of Joomla! users and Web sites<br />',1,0,'0000-00-00 00:00:00',null,3,0,0,''),
(31,0,'General','','general','','3','left','General questions about the Joomla! CMS',1,0,'0000-00-00 00:00:00',null,1,0,0,''),
(32,0,'Languages','','languages','','3','left','Questions related to localisation and languages',1,0,'0000-00-00 00:00:00',null,4,0,0,''),
(33,0,'Joomla! Promo','','joomla-promo','','com_banner','left','',1,0,'0000-00-00 00:00:00',null,1,0,0,''),
(34,0,'Random Posts','Copy of ','random-posts','','1','left','',1,0,'0000-00-00 00:00:00',null,1,0,0,''),
(35,0,'Demo category','','demo-category','','5','left','Id habitasse neque Ut leo mauris turpis feugiat Nam Aenean lacus. Tempus orci morbi sit risus nulla Nullam parturient ut nibh ut. Risus massa Cum massa dictum felis rutrum sit Praesent hac neque. A eros risus urna tincidunt.',1,0,'0000-00-00 00:00:00',null,1,0,0,''),
(36,0,'SlideShow','','slideshow','','5','left','',1,0,'0000-00-00 00:00:00',null,2,0,0,''),
(37,0,'Blog category','','blog-category','','5','left','Blog category',1,0,'0000-00-00 00:00:00',null,3,0,0,''),
(38,0,'Testimonials','','testimonials','','5','left','',1,0,'0000-00-00 00:00:00',null,4,0,0,'');


DROP TABLE IF EXISTS `#__components`;
CREATE TABLE `#__components` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `link` varchar(255) NOT NULL DEFAULT '',
  `menuid` int(11) unsigned NOT NULL DEFAULT '0',
  `parent` int(11) unsigned NOT NULL DEFAULT '0',
  `admin_menu_link` varchar(255) NOT NULL DEFAULT '',
  `admin_menu_alt` varchar(255) NOT NULL DEFAULT '',
  `option` varchar(50) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `admin_menu_img` varchar(255) NOT NULL DEFAULT '',
  `iscore` tinyint(4) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `enabled` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `parent_option` (`parent`,`option`(32))
) ENGINE=MyISAM AUTO_INCREMENT=52 DEFAULT CHARSET=utf8;
INSERT INTO `#__components` VALUES
(1,'Banners','',0,0,'','Banner Management','com_banners',0,'js/ThemeOffice/component.png',0,'track_impressions=0\ntrack_clicks=0\ntag_prefix=\n\n',1),
(2,'Banners','',0,1,'option=com_banners','Active Banners','com_banners',1,'js/ThemeOffice/edit.png',0,'',1),
(3,'Clients','',0,1,'option=com_banners&c=client','Manage Clients','com_banners',2,'js/ThemeOffice/categories.png',0,'',1),
(4,'Web Links','option=com_weblinks',0,0,'','Manage Weblinks','com_weblinks',0,'js/ThemeOffice/component.png',0,'show_comp_description=1\ncomp_description=\nshow_link_hits=1\nshow_link_description=1\nshow_other_cats=1\nshow_headings=1\nshow_page_title=1\nlink_target=0\nlink_icons=\n\n',1),
(5,'Links','',0,4,'option=com_weblinks','View existing weblinks','com_weblinks',1,'js/ThemeOffice/edit.png',0,'',1),
(6,'Categories','',0,4,'option=com_categories&section=com_weblinks','Manage weblink categories','',2,'js/ThemeOffice/categories.png',0,'',1),
(7,'Contacts','option=com_contact',0,0,'','Edit contact details','com_contact',0,'js/ThemeOffice/component.png',1,'contact_icons=0\nicon_address=\nicon_email=\nicon_telephone=\nicon_fax=\nicon_misc=\nshow_headings=1\nshow_position=1\nshow_email=0\nshow_telephone=1\nshow_mobile=1\nshow_fax=1\nbannedEmail=\nbannedSubject=\nbannedText=\nsession=1\ncustomReply=0\n\n',1),
(8,'Contacts','',0,7,'option=com_contact','Edit contact details','com_contact',0,'js/ThemeOffice/edit.png',1,'',1),
(9,'Categories','',0,7,'option=com_categories&section=com_contact_details','Manage contact categories','',2,'js/ThemeOffice/categories.png',1,'contact_icons=0\nicon_address=\nicon_email=\nicon_telephone=\nicon_fax=\nicon_misc=\nshow_headings=1\nshow_position=1\nshow_email=0\nshow_telephone=1\nshow_mobile=1\nshow_fax=1\nbannedEmail=\nbannedSubject=\nbannedText=\nsession=1\ncustomReply=0\n\n',1),
(10,'Polls','option=com_poll',0,0,'option=com_poll','Manage Polls','com_poll',0,'js/ThemeOffice/component.png',0,'',1),
(11,'News Feeds','option=com_newsfeeds',0,0,'','News Feeds Management','com_newsfeeds',0,'js/ThemeOffice/component.png',0,'',1),
(12,'Feeds','',0,11,'option=com_newsfeeds','Manage News Feeds','com_newsfeeds',1,'js/ThemeOffice/edit.png',0,'show_headings=1\nshow_name=1\nshow_articles=1\nshow_link=1\nshow_cat_description=1\nshow_cat_items=1\nshow_feed_image=1\nshow_feed_description=1\nshow_item_description=1\nfeed_word_count=0\n\n',1),
(13,'Categories','',0,11,'option=com_categories&section=com_newsfeeds','Manage Categories','',2,'js/ThemeOffice/categories.png',0,'',1),
(14,'User','option=com_user',0,0,'','','com_user',0,'',1,'',1),
(15,'Search','option=com_search',0,0,'option=com_search','Search Statistics','com_search',0,'js/ThemeOffice/component.png',1,'enabled=0\n\n',1),
(16,'Categories','',0,1,'option=com_categories&section=com_banner','Categories','',3,'',1,'',1),
(17,'Wrapper','option=com_wrapper',0,0,'','Wrapper','com_wrapper',0,'',1,'',1),
(18,'Mail To','',0,0,'','','com_mailto',0,'',1,'',1),
(19,'Media Manager','',0,0,'option=com_media','Media Manager','com_media',0,'',1,'upload_extensions=bmp,csv,doc,epg,gif,ico,jpg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,EPG,GIF,ICO,JPG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\nupload_maxsize=10000000\nfile_path=images\nimage_path=images/stories\nrestrict_uploads=1\nallowed_media_usergroup=3\ncheck_mime=1\nimage_extensions=bmp,gif,jpg,png\nignore_extensions=\nupload_mime=image/jpeg,image/gif,image/png,image/bmp,application/x-shockwave-flash,application/msword,application/excel,application/pdf,application/powerpoint,text/plain,application/x-zip\nupload_mime_illegal=text/html\nenable_flash=0\n\n',1),
(20,'Articles','option=com_content',0,0,'','','com_content',0,'',1,'show_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=0\n\n',1),
(21,'Configuration Manager','',0,0,'','Configuration','com_config',0,'',1,'',1),
(22,'Installation Manager','',0,0,'','Installer','com_installer',0,'',1,'',1),
(23,'Language Manager','',0,0,'','Languages','com_languages',0,'',1,'',1),
(24,'Mass mail','',0,0,'','Mass Mail','com_massmail',0,'',1,'mailSubjectPrefix=\nmailBodySuffix=\n\n',1),
(25,'Menu Editor','',0,0,'','Menu Editor','com_menus',0,'',1,'',1),
(27,'Messaging','',0,0,'','Messages','com_messages',0,'',1,'',1),
(28,'Modules Manager','',0,0,'','Modules','com_modules',0,'',1,'',1),
(29,'Plugin Manager','',0,0,'','Plugins','com_plugins',0,'',1,'',1),
(30,'Template Manager','',0,0,'','Templates','com_templates',0,'',1,'',1),
(31,'User Manager','',0,0,'','Users','com_users',0,'',1,'allowUserRegistration=1\nnew_usertype=Registered\nuseractivation=1\nfrontend_userparams=1\n\n',1),
(32,'Cache Manager','',0,0,'','Cache','com_cache',0,'',1,'',1),
(33,'Control Panel','',0,0,'','Control Panel','com_cpanel',0,'',1,'',1),
(40,'K2','option=com_k2',0,0,'option=com_k2','K2','com_k2',0,'components/com_k2/images/system/k2-icon.png',0,'enable_css=1\nimagesQuality=100\nitemImageXS=100\nitemImageS=200\nitemImageM=400\nitemImageL=600\nitemImageXL=900\nitemImageGeneric=300\ncatImageWidth=100\ncatImageDefault=1\nuserImageWidth=100\nuserImageDefault=1\ncommenterImgWidth=48\nuserName=1\nuserImage=1\nuserDescription=1\nuserURL=1\nuserEmail=1\nuserFeed=1\nuserItemCount=10\nuserItemTitle=1\nuserItemTitleLinked=1\nuserItemDateCreated=1\nuserItemImage=1\nuserItemIntroText=1\nuserItemCategory=1\nuserItemTags=1\nuserItemCommentsAnchor=1\nuserItemReadMore=1\nuserItemK2Plugins=1\ngenericItemCount=10\ngenericItemTitle=1\ngenericItemTitleLinked=1\ngenericItemDateCreated=1\ngenericItemImage=1\ngenericItemIntroText=1\ngenericItemCategory=1\ngenericItemReadMore=1\ncomments=1\ncommentsOrdering=DESC\ncommentsLimit=10\ncommentsFormPosition=below\ncommentsPublishing=1\ngravatar=1\ntinyURL=1\nfeedLimit=10\nfeedItemImage=1\nfeedImgSize=S\nfeedItemIntroText=1\nfeedItemFullText=1\nlinkPopupWidth=900\nlinkPopupHeight=600\nfrontendEditing=1\nshowImageTab=1\nshowImageGalleryTab=1\nshowVideoTab=1\nshowExtraFieldsTab=1\nshowAttachmentsTab=1\nshowK2Plugins=1\nmergeEditors=1\nsideBarDisplay=1\ntaggingSystem=1\ngoogleSearchContainer=k2Container\nK2UserProfile=1\nadminSearch=simple\nshowItemsCounterAdmin=1\nshowChildCatItems=1\nsh404SefLabelUser=blog\n',1);


DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
INSERT INTO `#__contact_details` VALUES
(1,'Name','name','Position','Street','Suburb','State','Country','Zip Code','Telephone','Fax','Miscellanous info','powered_by.png','top','email@email.com',1,1,0,'0000-00-00 00:00:00',1,'show_name=1\r\nshow_position=1\r\nshow_email=0\r\nshow_street_address=1\r\nshow_suburb=1\r\nshow_state=1\r\nshow_postcode=1\r\nshow_country=1\r\nshow_telephone=1\r\nshow_mobile=1\r\nshow_fax=1\r\nshow_webpage=1\r\nshow_misc=1\r\nshow_image=1\r\nallow_vcard=0\r\ncontact_icons=0\r\nicon_address=\r\nicon_email=\r\nicon_telephone=\r\nicon_fax=\r\nicon_misc=\r\nshow_email_form=1\r\nemail_description=1\r\nshow_email_copy=1\r\nbanned_email=\r\nbanned_subject=\r\nbanned_text=',0,12,0,'','');


DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `title_alias` varchar(255) NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(11) unsigned NOT NULL DEFAULT '0',
  `mask` int(11) unsigned NOT NULL DEFAULT '0',
  `catid` int(11) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(11) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` text NOT NULL,
  `version` int(11) unsigned NOT NULL DEFAULT '1',
  `parentid` int(11) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(11) unsigned NOT NULL DEFAULT '0',
  `hits` int(11) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_section` (`sectionid`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`)
) ENGINE=MyISAM AUTO_INCREMENT=72 DEFAULT CHARSET=utf8;
INSERT INTO `#__content` VALUES
(1,'Welcome to Joomla!','welcome-to-joomla','','<div align=\"left\"><strong>Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. <br /></strong></div><p><img src=\"images/stories/powered_by.png\" class=\"caption\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla! provides an easy-to-use graphical user interface that simplifies the management and publishing of large volumes of content including HTML, documents, and rich media.  Joomla! is used by organisations of all sizes for intranets and extranets and is supported by a community of tens of thousands of users. </p>','With a fully documented library of developer resources, Joomla! allows the customisation of every aspect of a Web site including presentation, layout, administration, and the rapid integration with third-party applications.<p>Joomla! now provides more developer power while making the user experience all the more friendly. For those who always wanted increased extensibility, Joomla! 1.5 can make this happen.</p><p>A new framework, ground-up refactoring, and a highly-active development team brings the excitement of \'the next generation CMS\' to your fingertips.  Whether you are a systems architect or a complete \'noob\' Joomla! can take you to the next level of content delivery. \'More than a CMS\' is something we have been playing with as a catchcry because the new Joomla! API has such incredible power and flexibility, you are free to take whatever direction your creative mind takes you and Joomla! can help you get there so much more easily than ever before.</p><p>Thinking Web publishing? Think Joomla!</p>',1,1,0,1,'2008-08-12 10:00:00',62,'','2010-03-25 20:47:54',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',31,0,1,'','',0,95,'robots=\nauthor='),
(2,'Newsflash 1','newsflash-1','','<p>Joomla! makes it easy to launch a Web site of any kind. Whether you want a brochure site or you are building a large online community, Joomla! allows you to deploy a new site in minutes and add extra functionality as you need it. The hundreds of available Extensions will help to expand your site and allow you to deliver new services that extend your reach into the Internet.</p>','',1,1,0,3,'2008-08-10 06:30:34',62,'','2008-08-10 06:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,3,'','',0,1,'robots=\nauthor='),
(3,'Newsflash 2','newsflash-2','','<p>The one thing about a Web site, it always changes! Joomla! makes it easy to add Articles, content, images, videos, and more. Site administrators can edit and manage content \'in-context\' by clicking the \'Edit\' link. Webmasters can also edit content through a graphical Control Panel that gives you complete control over your site.</p>','',1,1,0,3,'2008-08-09 22:30:34',62,'','2008-08-09 22:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,4,'','',0,0,'robots=\nauthor='),
(4,'Newsflash 3','newsflash-3','','<p>With a library of thousands of free <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"The Joomla! Extensions Directory\">Extensions</a>, you can add what you need as your site grows. Don\'t wait, look through the <a href=\"http://extensions.joomla.org/\" target=\"_blank\" title=\"Joomla! Extensions\">Joomla! Extensions</a>  library today. </p>','',1,1,0,3,'2008-08-10 06:30:34',62,'','2008-08-10 06:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,5,'','',0,1,'robots=\nauthor='),
(5,'Joomla! License Guidelines','joomla-license-guidelines','joomla-license-guidelines','<p>This Web site is powered by <a href=\"http://joomla.org/\" target=\"_blank\" title=\"Joomla!\">Joomla!</a> The software and default templates on which it runs are Copyright 2005-2008 <a href=\"http://www.opensourcematters.org/\" target=\"_blank\" title=\"Open Source Matters\">Open Source Matters</a>. The sample content distributed with Joomla! is licensed under the <a href=\"http://docs.joomla.org/JEDL\" target=\"_blank\" title=\"Joomla! Electronic Document License\">Joomla! Electronic Documentation License.</a> All data entered into this Web site and templates added after installation, are copyrighted by their respective copyright owners.</p> ','<p>If you want to distribute, copy, or modify Joomla!, you are welcome to do so under the terms of the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC1\" target=\"_blank\" title=\"GNU General Public License\"> GNU General Public License</a>. If you are unfamiliar with this license, you might want to read <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC4\" target=\"_blank\" title=\"How To Apply These Terms To Your Program\">\'How To Apply These Terms To Your Program\'</a> and the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0-faq.html\" target=\"_blank\" title=\"GNU General Public License FAQ\">\'GNU General Public License FAQ\'</a>.</p> <p>The Joomla! licence has always been GPL.</p>',1,4,0,25,'2008-08-20 10:11:07',62,'','2010-01-16 21:17:09',62,0,'0000-00-00 00:00:00','2004-08-19 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,2,'','',0,124,'robots=\nauthor='),
(6,'We are Volunteers','we-are-volunteers','','<p>The Joomla Core Team and Working Group members are volunteer developers, designers, administrators and managers who have worked together to take Joomla! to new heights in its relatively short life. Joomla! has some wonderfully talented people taking Open Source concepts to the forefront of industry standards.  Joomla! 1.5 is a major leap forward and represents the most exciting Joomla! release in the history of the project. </p>','',1,1,0,1,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',10,0,4,'','',0,54,'robots=\nauthor='),
(9,'Millions of Smiles','millions-of-smiles','','<p>The Joomla! team has millions of good reasons to be smiling about the Joomla! 1.5. In its current incarnation, it\'s had millions of downloads, taking it to an unprecedented level of popularity.  The new code base is almost an entire re-factor of the old code base.  The user experience is still extremely slick but for developers the API is a dream.  A proper framework for real PHP architects seeking the best of the best.</p><p>If you\'re a former Mambo User or a 1.0 series Joomla! User, 1.5 is the future of CMSs for a number of reasons.  It\'s more powerful, more flexible, more secure, and intuitive.  Our developers and interface designers have worked countless hours to make this the most exciting release in the content management system sphere.</p><p>Go on ... get your FREE copy of Joomla! today and spread the word about this benchmark project. </p>','',1,1,0,1,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,5,'','',0,23,'robots=\nauthor='),
(10,'How do I localise Joomla! to my language?','how-do-i-localise-joomla-to-my-language','','<h4>General<br /></h4><p>In Joomla! 1.5 all User interfaces can be localised. This includes the installation, the Back-end Control Panel and the Front-end Site.</p><p>The core release of Joomla! 1.5 is shipped with multiple language choices in the installation but, other than English (the default), languages for the Site and Administration interfaces need to be added after installation. Links to such language packs exist below.</p>','<p>Translation Teams for Joomla! 1.5 may have also released fully localised installation packages where site, administrator and sample data are in the local language. These localised releases can be found in the specific team projects on the <a href=\"http://extensions.joomla.org/component/option,com_mtree/task,listcats/cat_id,1837/Itemid,35/\" target=\"_blank\" title=\"JED\">Joomla! Extensions Directory</a>.</p><h4>How do I install language packs?</h4><ul><li>First download both the admin and the site language packs that you require.</li><li>Install each pack separately using the Extensions-&gt;Install/Uninstall Menu selection and then the package file upload facility.</li><li>Go to the Language Manager and be sure to select Site or Admin in the sub-menu. Then select the appropriate language and make it the default one using the Toolbar button.</li></ul><h4>How do I select languages?</h4><ul><li>Default languages can be independently set for Site and for Administrator</li><li>In addition, users can define their preferred language for each Site and Administrator. This takes affect after logging in.</li><li>While logging in to the Administrator Back-end, a language can also be selected for the particular session.</li></ul><h4>Where can I find Language Packs and Localised Releases?</h4><p><em>Please note that Joomla! 1.5 is new and language packs for this version may have not been released at this time.</em> </p><ul><li><a href=\"http://joomlacode.org/gf/project/jtranslation/\" target=\"_blank\" title=\"Accredited Translations\">The Joomla! Accredited Translations Project</a>  - This is a joint repository for language packs that were developed by teams that are members of the Joomla! Translations Working Group.</li><li><a href=\"http://extensions.joomla.org/component/option,com_mtree/task,listcats/cat_id,1837/Itemid,35/\" target=\"_blank\" title=\"Translations\">The Joomla! Extensions Site - Translations</a>  </li><li><a href=\"http://community.joomla.org/translations.html\" target=\"_blank\" title=\"Translation Work Group Teams\">List of Translation Teams and Translation Partner Sites for Joomla! 1.5</a> </li></ul>',1,3,0,32,'2008-07-30 14:06:37',62,'','2008-07-30 14:06:37',62,0,'0000-00-00 00:00:00','2006-09-29 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',9,0,5,'','',0,10,'robots=\nauthor='),
(11,'How do I upgrade to Joomla! 1.5 ?','how-do-i-upgrade-to-joomla-15','','<p>Joomla! 1.5 does not provide an upgrade path from earlier versions. Converting an older site to a Joomla! 1.5 site requires creation of a new empty site using Joomla! 1.5 and then populating the new site with the content from the old site. This migration of content is not a one-to-one process and involves conversions and modifications to the content dump.</p> <p>There are two ways to perform the migration:</p>',' <div id=\"post_content-107\"><li>An automated method of migration has been provided which uses a migrator Component to create the migration dump out of the old site (Mambo 4.5.x up to Joomla! 1.0.x) and a smart import facility in the Joomla! 1.5 Installation that performs required conversions and modifications during the installation process.</li> <li>Migration can be performed manually. This involves exporting the required tables, manually performing required conversions and modifications and then importing the content to the new site after it is installed.</li>  <p><!--more--></p> <h2><strong> Automated migration</strong></h2>  <p>This is a two phased process using two tools. The first tool is a migration Component named <font face=\"courier new,courier\">com_migrator</font>. This Component has been contributed by Harald Baer and is based on his <strong>eBackup </strong>Component. The migrator needs to be installed on the old site and when activated it prepares the required export dump of the old site\'s data. The second tool is built into the Joomla! 1.5 installation process. The exported content dump is loaded to the new site and all conversions and modification are performed on-the-fly.</p> <h3><u> Step 1 - Using com_migrator to export data from old site:</u></h3> <li>Install the <font face=\"courier new,courier\">com_migrator</font> Component on the <u><strong>old</strong></u> site. It can be found at the <a href=\"http://joomlacode.org/gf/project/pasamioprojects/frs/\" target=\"_blank\" title=\"JoomlaCode\">JoomlaCode developers forge</a>.</li> <li>Select the Component in the Component Menu of the Control Panel.</li> <li>Click on the <strong>Dump it</strong> icon. Three exported <em>gzipped </em>export scripts will be created. The first is a complete backup of the old site. The second is the migration content of all core elements which will be imported to the new site. The third is a backup of all 3PD Component tables.</li> <li>Click on the download icon of the particular exports files needed and store locally.</li> <li>Multiple export sets can be created.</li> <li>The exported data is not modified in anyway and the original encoding is preserved. This makes the <font face=\"courier new,courier\">com_migrator</font> tool a recommended tool to use for manual migration as well.</li> <h3><u> Step 2 - Using the migration facility to import and convert data during Joomla! 1.5 installation:</u></h3><p>Note: This function requires the use of the <em><font face=\"courier new,courier\">iconv </font></em>function in PHP to convert encodings. If <em><font face=\"courier new,courier\">iconv </font></em>is not found a warning will be provided.</p> <li>In step 6 - Configuration select the \'Load Migration Script\' option in the \'Load Sample Data, Restore or Migrate Backed Up Content\' section of the page.</li> <li>Enter the table prefix used in the content dump. For example: \'jos_\' or \'site2_\' are acceptable values.</li> <li>Select the encoding of the dumped content in the dropdown list. This should be the encoding used on the pages of the old site. (As defined in the _ISO variable in the language file or as seen in the browser page info/encoding/source)</li> <li>Browse the local host and select the migration export and click on <strong>Upload and Execute</strong></li> <li>A success message should appear or alternately a listing of database errors</li> <li>Complete the other required fields in the Configuration step such as Site Name and Admin details and advance to the final step of installation. (Admin details will be ignored as the imported data will take priority. Please remember admin name and password from the old site)</li> <p><u><br /></u></p></div>',1,3,0,28,'2008-07-30 20:27:52',62,'','2008-07-30 20:27:52',62,0,'0000-00-00 00:00:00','2006-09-29 12:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',10,0,3,'','',0,14,'robots=\nauthor='),
(12,'Why does Joomla! 1.5 use UTF-8 encoding?','why-does-joomla-15-use-utf-8-encoding','','<p>Well... how about never needing to mess with encoding settings again?</p><p>Ever needed to display several languages on one page or site and something always came up in Giberish?</p><p>With utf-8 (a variant of Unicode) glyphs (character forms) of basically all languages can be displayed with one single encoding setting. </p>','',1,3,0,31,'2008-08-05 01:11:29',62,'','2008-08-05 01:11:29',62,0,'0000-00-00 00:00:00','2006-10-03 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,8,'','',0,34,'robots=\nauthor='),
(13,'What happened to the locale setting?','what-happened-to-the-locale-setting','','This is now defined in the Language [<em>lang</em>].xml file in the Language metadata settings. If you are having locale problems such as dates do not appear in your language for example, you might want to check/edit the entries in the locale tag. Note that multiple locale strings can be set and the host will usually accept the first one recognised.','',1,3,0,28,'2008-08-06 16:47:35',62,'','2008-08-06 16:47:35',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,2,'','',0,11,'robots=\nauthor='),
(14,'What is the FTP layer for?','what-is-the-ftp-layer-for','','<p>The FTP Layer allows file operations (such as installing Extensions or updating the main configuration file) without having to make all the folders and files writable. This has been an issue on Linux and other Unix based platforms in respect of file permissions. This makes the site admin\'s life a lot easier and increases security of the site.</p><p>You can check the write status of relevent folders by going to \'\'Help-&gt;System Info\" and then in the sub-menu to \"Directory Permissions\". With the FTP Layer enabled even if all directories are red, Joomla! will operate smoothly.</p><p>NOTE: the FTP layer is not required on a Windows host/server. </p>','',1,3,0,31,'2008-08-06 21:27:49',62,'','2008-08-06 21:27:49',62,0,'0000-00-00 00:00:00','2006-10-05 16:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=',6,0,6,'','',0,23,'robots=\nauthor='),
(15,'Can Joomla! 1.5 operate with PHP Safe Mode On?','can-joomla-15-operate-with-php-safe-mode-on','','<p>Yes it can! This is a significant security improvement.</p><p>The <em>safe mode</em> limits PHP to be able to perform actions only on files/folders who\'s owner is the same as PHP is currently using (this is usually \'apache\'). As files normally are created either by the Joomla! application or by FTP access, the combination of PHP file actions and the FTP Layer allows Joomla! to operate in PHP Safe Mode.</p>','',1,3,0,31,'2008-08-06 19:28:35',62,'','2008-08-06 19:28:35',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,4,'','',0,8,'robots=\nauthor='),
(16,'Only one edit window! How do I create \"Read more...\"?','only-one-edit-window-how-do-i-create-read-more','','<p>This is now implemented by inserting a <strong>Read more...</strong> tag (the button is located below the editor area) a dotted line appears in the edited text showing the split location for the <em>Read more....</em> A new Plugin takes care of the rest.</p><p>It is worth mentioning that this does not have a negative effect on migrated data from older sites. The new implementation is fully backward compatible.</p>','<p>This is now implemented by inserting a <strong>Read more...</strong> tag (the button is located below the editor area) a dotted line appears in the edited text showing the split location for the <em>Read more....</em> A new Plugin takes care of the rest.</p><p>It is worth mentioning that this does not have a negative effect on migrated data from older sites. The new implementation is fully backward compatible.</p>',1,3,0,28,'2008-08-06 19:29:28',62,'','2010-01-16 20:59:55',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,4,'','',0,22,'robots=\nauthor='),
(17,'My MySQL database does not support UTF-8. Do I have a problem?','my-mysql-database-does-not-support-utf-8-do-i-have-a-problem','','No you don\'t. Versions of MySQL lower than 4.1 do not have built in UTF-8 support. However, Joomla! 1.5 has made provisions for backward compatibility and is able to use UTF-8 on older databases. Let the installer take care of all the settings and there is no need to make any changes to the database (charset, collation, or any other).','',1,3,0,31,'2008-08-07 09:30:37',62,'','2008-08-07 09:30:37',62,0,'0000-00-00 00:00:00','2006-10-05 20:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',10,0,7,'','',0,11,'robots=\nauthor='),
(18,'Joomla! Features','joomla-features','','<h4><font color=\"#ff6600\">Joomla! features:</font></h4> <ul><li>Completely database driven site engines </li><li>News, products, or services sections fully editable and manageable</li><li>Topics sections can be added to by contributing Authors </li><li>Fully customisable layouts including <em>left</em>, <em>center</em>, and <em>right </em>Menu boxes </li><li>Browser upload of images to your own library for use anywhere in the site </li><li>Dynamic Forum/Poll/Voting booth for on-the-spot results </li><li>Runs on Linux, FreeBSD, MacOSX server, Solaris, and AIX','  </li></ul> <h4>Extensive Administration:</h4> <ul><li>Change order of objects including news, FAQs, Articles etc. </li><li>Random Newsflash generator </li><li>Remote Author submission Module for News, Articles, FAQs, and Links </li><li>Object hierarchy - as many Sections, departments, divisions, and pages as you want </li><li>Image library - store all your PNGs, PDFs, DOCs, XLSs, GIFs, and JPEGs online for easy use </li><li>Automatic Path-Finder. Place a picture and let Joomla! fix the link </li><li>News Feed Manager. Easily integrate news feeds into your Web site.</li><li>E-mail a friend and Print format available for every story and Article </li><li>In-line Text editor similar to any basic word processor software </li><li>User editable look and feel </li><li>Polls/Surveys - Now put a different one on each page </li><li>Custom Page Modules. Download custom page Modules to spice up your site </li><li>Template Manager. Download Templates and implement them in seconds </li><li>Layout preview. See how it looks before going live </li><li>Banner Manager. Make money out of your site.</li></ul>',1,4,0,29,'2008-08-08 23:32:45',62,'','2008-08-08 23:32:45',62,0,'0000-00-00 00:00:00','2006-10-07 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',11,0,4,'','',0,68,'robots=\nauthor='),
(19,'Joomla! Overview','joomla-overview','','<p>If you\'re new to Web publishing systems, you\'ll find that Joomla! delivers sophisticated solutions to your online needs. It can deliver a robust enterprise-level Web site, empowered by endless extensibility for your bespoke publishing needs. Moreover, it is often the system of choice for small business or home users who want a professional looking site that\'s simple to deploy and use. <em>We do content right</em>.<br /> </p>','<p>So what\'s the catch? How much does this system cost?</p><p> Well, there\'s good news ... and more good news! Joomla! 1.5 is free, it is released under an Open Source license - the GNU/General Public License v 2.0. Had you invested in a mainstream, commercial alternative, there\'d be nothing but moths left in your wallet and to add new functionality would probably mean taking out a second mortgage each time you wanted something adding!</p><p>Joomla! changes all that ... <br />Joomla! is different from the normal models for content management software. For a start, it\'s not complicated. Joomla! has been developed for everybody, and anybody can develop it further. It is designed to work (primarily) with other Open Source, free, software such as PHP, MySQL, and Apache. </p><p>It is easy to install and administer, and is reliable. </p><p>Joomla! doesn\'t even require the user or administrator of the system to know HTML to operate it once it\'s up and running.</p><p>To get the perfect Web site with all the functionality that you require for your particular application may take additional time and effort, but with the Joomla! Community support that is available and the many Third Party Developers actively creating and releasing new Extensions for the 1.5 platform on an almost daily basis, there is likely to be something out there to meet your needs. Or you could develop your own Extensions and make these available to the rest of the community. </p>',1,4,0,29,'2008-08-09 07:49:20',62,'','2010-01-16 21:34:08',62,0,'0000-00-00 00:00:00','2006-10-07 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',14,0,2,'','',0,161,'robots=\nauthor='),
(20,'Support and Documentation','support-and-documentation','','<h1>Support </h1><p>Support for the Joomla! CMS can be found on several places. The best place to start would be the <a href=\"http://docs.joomla.org/\" target=\"_blank\" title=\"Joomla! Official Documentation Wiki\">Joomla! Official Documentation Wiki</a>. Here you can help yourself to the information that is regularly published and updated as Joomla! develops. There is much more to come too!</p> <p>Of course you should not forget the Help System of the CMS itself. On the <em>topmenu </em>in the Back-end Control panel you find the Help button which will provide you with lots of explanation on features.</p> <p>Another great place would of course be the <a href=\"http://forum.joomla.org/\" target=\"_blank\" title=\"Forum\">Forum</a> . On the Joomla! Forum you can find help and support from Community members as well as from Joomla! Core members and Working Group members. The forum contains a lot of information, FAQ\'s, just about anything you are looking for in terms of support.</p> <p>Two other resources for Support are the <a href=\"http://developer.joomla.org/\" target=\"_blank\" title=\"Joomla! Developer Site\">Joomla! Developer Site</a> and the <a href=\"http://extensions.joomla.org/\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla! Extensions Directory</a> (JED). The Joomla! Developer Site provides lots of technical information for the experienced Developer as well as those new to Joomla! and development work in general. The JED whilst not a support site in the strictest sense has many of the Extensions that you will need as you develop your own Web site.</p> <p>The Joomla! Developers and Bug Squad members are regularly posting their blog reports about several topics such as programming techniques and security issues.</p> <h1>Documentation</h1> <p>Joomla! Documentation can of course be found on the <a href=\"http://docs.joomla.org/\" target=\"_blank\" title=\"Joomla! Official Documentation Wiki\">Joomla! Official Documentation Wiki</a>. You can find information for beginners, installation, upgrade, Frequently Asked Questions, developer topics, and a lot more. The Documentation Team helps oversee the wiki but you are invited to contribute content, as well.</p> <p>There are also books written about Joomla! You can find a listing of these books in the <a href=\"http://shop.joomla.org/\" target=\"_blank\" title=\"Joomla! Shop\">Joomla! Shop</a>.</p>','',1,4,0,25,'2008-08-09 08:33:57',62,'','2008-08-09 08:33:57',62,0,'0000-00-00 00:00:00','2006-10-07 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',13,0,3,'','',0,198,'robots=\nauthor='),
(21,'Joomla! Facts','joomla-facts','','<p>Here are some interesting facts about Joomla!</p><ul><li><span>Over 210,000 active registered Users on the <a href=\"http://forum.joomla.org\" target=\"_blank\" title=\"Joomla Forums\">Official Joomla! community forum</a> and more on the many international community sites.</span><ul><li><span>over 1,000,000 posts in over 200,000 topics</span></li><li>over 1,200 posts per day</li><li>growing at 150 new participants each day!</li></ul></li><li><span>1168 Projects on the JoomlaCode (<a href=\"http://joomlacode.org/\" target=\"_blank\" title=\"JoomlaCode\">joomlacode.org</a> ). All for open source addons by third party developers.</span><ul><li><span>Well over 6,000,000 downloads of Joomla! since the migration to JoomlaCode in March 2007.<br /></span></li></ul></li><li><span>Nearly 4,000 extensions for Joomla! have been registered on the <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"http://extensions.joomla.org\">Joomla! Extension Directory</a>  </span></li><li><span>Joomla.org exceeds 2 TB of traffic per month!</span></li></ul>','',1,4,0,30,'2008-08-09 16:46:37',62,'','2008-08-09 16:46:37',62,0,'0000-00-00 00:00:00','2006-10-07 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',13,0,1,'','',0,50,'robots=\nauthor='),
(22,'What\'s New in 1.5?','whats-new-in-15','','<p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>','<p style=\"margin-bottom: 0in\">In Joomla! 1.5, you\'ll notice: </p>    <ul><li>     <p style=\"margin-bottom: 0in\">       Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Extended integration of external applications through Web services and remote authentication such as the Lightweight Directory Access Protocol (LDAP)</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</p>   </li><li>     <p style=\"margin-bottom: 0in\">       A more sustainable and flexible framework for Component and Extension developers</p>   </li><li>     <p style=\"margin-bottom: 0in\">Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</p></li></ul>',1,4,0,29,'2008-08-11 22:13:58',62,'','2008-08-11 22:13:58',62,0,'0000-00-00 00:00:00','2006-10-10 18:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',10,0,1,'','',0,111,'robots=\nauthor='),
(23,'Platforms and Open Standards','platforms-and-open-standards','','<p class=\"MsoNormal\">Joomla! runs on any platform including Windows, most flavours of Linux, several Unix versions, and the Apple OS/X platform.  Joomla! depends on PHP and the MySQL database to deliver dynamic content.  </p>            <p class=\"MsoNormal\">The minimum requirements are:</p>      <ul><li>Apache 1.x, 2.x and higher</li><li>PHP 4.3 and higher</li><li>MySQL 3.23 and higher</li></ul>It will also run on alternative server platforms such as Windows IIS - provided they support PHP and MySQL - but these require additional configuration in order for the Joomla! core package to be successful installed and operated.','',1,4,0,25,'2008-08-11 04:22:14',62,'','2008-08-11 04:22:14',62,0,'0000-00-00 00:00:00','2006-10-10 08:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,4,'','',0,12,'robots=\nauthor='),
(24,'Content Layouts','content-layouts','','<p>Joomla! provides plenty of flexibility when displaying your Web content. Whether you are using Joomla! for a blog site, news or a Web site for a company, you\'ll find one or more content styles to showcase your information. You can also change the style of content dynamically depending on your preferences. Joomla! calls how a page is laid out a <strong>layout</strong>. Use the guide below to understand which layouts are available and how you might use them. </p>',' <h2>Content </h2> <p>Joomla! makes it extremely easy to add and display content. All content  is placed where your mainbody tag in your template is located. There are three main types of layouts available in Joomla! and all of them can be customised via parameters. The display and parameters are set in the Menu Item used to display the content your working on. You create these layouts by creating a Menu Item and choosing how you want the content to display.</p> <h3>Blog Layout<br /> </h3> <p>Blog layout will show a listing of all Articles of the selected blog type (Section or Category) in the mainbody position of your template. It will give you the standard title, and Intro of each Article in that particular Category and/or Section. You can customise this layout via the use of the Preferences and Parameters, (See Article Parameters) this is done from the Menu not the Section Manager!</p> <h3>Blog Archive Layout<br /> </h3> <p>A Blog Archive layout will give you a similar output of Articles as the normal Blog Display but will add, at the top, two drop down lists for month and year plus a search button to allow Users to search for all Archived Articles from a specific month and year.</p> <h3>List Layout<br /> </h3> <p>Table layout will simply give you a <em>tabular </em>list<em> </em>of all the titles in that particular Section or Category. No Intro text will be displayed just the titles. You can set how many titles will be displayed in this table by Parameters. The table layout will also provide a filter Section so that Users can reorder, filter, and set how many titles are listed on a single page (up to 50)</p> <h2>Wrapper</h2> <p>Wrappers allow you to place stand alone applications and Third Party Web sites inside your Joomla! site. The content within a Wrapper appears within the primary content area defined by the \"mainbody\" tag and allows you to display their content as a part of your own site. A Wrapper will place an IFRAME into the content Section of your Web site and wrap your standard template navigation around it so it appears in the same way an Article would.</p> <h2>Content Parameters</h2> <p>The parameters for each layout type can be found on the right hand side of the editor boxes in the Menu Item configuration screen. The parameters available depend largely on what kind of layout you are configuring.</p>',1,4,0,29,'2008-08-12 22:33:10',62,'','2010-01-16 21:32:26',62,0,'0000-00-00 00:00:00','2006-10-11 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',12,0,5,'','',0,93,'robots=\nauthor='),
(25,'What are the requirements to run Joomla! 1.5?','what-are-the-requirements-to-run-joomla-15','','<p>Joomla! runs on the PHP pre-processor. PHP comes in many flavours, for a lot of operating systems. Beside PHP you will need a Web server. Joomla! is optimized for the Apache Web server, but it can run on different Web servers like Microsoft IIS it just requires additional configuration of PHP and MySQL. Joomla! also depends on a database, for this currently you can only use MySQL. </p>Many people know from their own experience that it\'s not easy to install an Apache Web server and it gets harder if you want to add MySQL, PHP and Perl. XAMPP, WAMP, and MAMP are easy to install distributions containing Apache, MySQL, PHP and Perl for the Windows, Mac OSX and Linux operating systems. These packages are for localhost installations on non-public servers only.<br />The minimum version requirements are:<br /><ul><li>Apache 1.x or 2.x</li><li>PHP 4.3 or up</li><li>MySQL 3.23 or up</li></ul>For the latest minimum requirements details, see <a href=\"http://www.joomla.org/about-joomla/technical-requirements.html\" target=\"_blank\" title=\"Joomla! Technical Requirements\">Joomla! Technical Requirements</a>.','',1,3,0,31,'2008-08-11 00:42:31',62,'','2008-08-11 00:42:31',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,5,'','',0,26,'robots=\nauthor='),
(26,'Extensions','extensions','','<p>Out of the box, Joomla! does a great job of managing the content needed to make your Web site sing. But for many people, the true power of Joomla! lies in the application framework that makes it possible for developers all around the world to create powerful add-ons that are called <strong>Extensions</strong>. An Extension is used to add capabilities to Joomla! that do not exist in the base core code. Here are just some examples of the hundreds of available Extensions:</p> <ul>   <li>Dynamic form builders</li>   <li>Business or organisational directories</li>   <li>Document management</li>   <li>Image and multimedia galleries</li>   <li>E-commerce and shopping cart engines</li>   <li>Forums and chat software</li>   <li>Calendars</li>   <li>E-mail newsletters</li>   <li>Data collection and reporting tools</li>   <li>Banner advertising systems</li>   <li>Paid subscription services</li>   <li>and many, many, more</li> </ul> <p>You can find more examples over at our ever growing <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla! Extensions Directory</a>. Prepare to be amazed at the amount of exciting work produced by our active developer community!</p><p>A useful guide to the Extension site can be found at:<br /><a href=\"http://extensions.joomla.org/content/view/15/63/\" target=\"_blank\" title=\"Guide to the Joomla! Extension site\">http://extensions.joomla.org/content/view/15/63/</a> </p> <h3>Types of Extensions </h3><p>There are five types of extensions:</p> <ul>   <li>Components</li>   <li>Modules</li>   <li>Templates</li>   <li>Plugins</li>   <li>Languages</li> </ul> <p>You can read more about the specifics of these using the links in the Article Index - a Table of Contents (yet another useful feature of Joomla!) - at the top right or by clicking on the <strong>Next </strong>link below.<br /> </p> <hr title=\"Components\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_com.png\" border=\"0\" alt=\"Component - Joomla! Extension Directory\" title=\"Component - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Components</h3> <p>A Component is the largest and most complex of the Extension types.  Components are like mini-applications that render the main body of the  page. An analogy that might make the relationship easier to understand  would be that Joomla! is a book and all the Components are chapters in  the book. The core Article Component (<font face=\"courier new,courier\">com_content</font>), for example, is the  mini-application that handles all core Article rendering just as the  core registration Component (<font face=\"courier new,courier\">com_user</font>) is the mini-application  that handles User registration.</p> <p>Many of Joomla!\'s core features are provided by the use of default Components such as:</p> <ul>   <li>Contacts</li>   <li>Front Page</li>   <li>News Feeds</li>   <li>Banners</li>   <li>Mass Mail</li>   <li>Polls</li></ul><p>A Component will manage data, set displays, provide functions, and in general can perform any operation that does not fall under the general functions of the core code.</p> <p>Components work hand in hand with Modules and Plugins to provide a rich variety of content display and functionality aside from the standard Article and content display. They make it possible to completely transform Joomla! and greatly expand its capabilities.</p>  <hr title=\"Modules\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_mod.png\" border=\"0\" alt=\"Module - Joomla! Extension Directory\" title=\"Module - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Modules</h3> <p>A more lightweight and flexible Extension used for page rendering is a Module. Modules are used for small bits of the page that are generally  less complex and able to be seen across different Components. To  continue in our book analogy, a Module can be looked at as a footnote  or header block, or perhaps an image/caption block that can be rendered  on a particular page. Obviously you can have a footnote on any page but  not all pages will have them. Footnotes also might appear regardless of  which chapter you are reading. Simlarly Modules can be rendered  regardless of which Component you have loaded.</p> <p>Modules are like little mini-applets that can be placed anywhere on your site. They work in conjunction with Components in some cases and in others are complete stand alone snippets of code used to display some data from the database such as Articles (Newsflash) Modules are usually used to output data but they can also be interactive form items to input data for example the Login Module or Polls.</p> <p>Modules can be assigned to Module positions which are defined in your Template and in the back-end using the Module Manager and editing the Module Position settings. For example, \"left\" and \"right\" are common for a 3 column layout. </p> <h4>Displaying Modules</h4> <p>Each Module is assigned to a Module position on your site. If you wish it to display in two different locations you must copy the Module and assign the copy to display at the new location. You can also set which Menu Items (and thus pages) a Module will display on, you can select all Menu Items or you can pick and choose by holding down the control key and selecting multiple locations one by one in the Modules [Edit] screen</p> <p>Note: Your Main Menu is a Module! When you create a new Menu in the Menu Manager you are actually copying the Main Menu Module (<font face=\"courier new,courier\">mod_mainmenu</font>) code and giving it the name of your new Menu. When you copy a Module you do not copy all of its parameters, you simply allow Joomla! to use the same code with two separate settings.</p> <h4>Newsflash Example</h4> <p>Newsflash is a Module which will display Articles from your site in an assignable Module position. It can be used and configured to display one Category, all Categories, or to randomly choose Articles to highlight to Users. It will display as much of an Article as you set, and will show a <em>Read more...</em> link to take the User to the full Article.</p> <p>The Newsflash Component is particularly useful for things like Site News or to show the latest Article added to your Web site.</p>  <hr title=\"Plugins\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_plugin.png\" border=\"0\" alt=\"Plugin - Joomla! Extension Directory\" title=\"Plugin - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Plugins</h3> <p>One  of the more advanced Extensions for Joomla! is the Plugin. In previous  versions of Joomla! Plugins were known as Mambots. Aside from changing their name their  functionality has been expanded. A Plugin is a section of code that  runs when a pre-defined event happens within Joomla!. Editors are Plugins, for example, that execute when the Joomla! event <font face=\"courier new,courier\">onGetEditorArea</font> occurs. Using a Plugin allows a developer to change  the way their code behaves depending upon which Plugins are installed  to react to an event.</p>  <hr title=\"Languages\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_lang.png\" border=\"0\" alt=\"Language - Joomla! Extensions Directory\" title=\"Language - Joomla! Extensions Directory\" width=\"17\" height=\"17\" /> Languages</h3> <p>New  to Joomla! 1.5 and perhaps the most basic and critical Extension is a Language. Joomla! is released with multiple Installation Languages but the base Site and Administrator are packaged in just the one Language <strong>en-GB</strong> - being English with GB spelling for example. To include all the translations currently available would bloat the core package and make it unmanageable for uploading purposes. The Language files enable all the User interfaces both Front-end and Back-end to be presented in the local preferred language. Note these packs do not have any impact on the actual content such as Articles. </p> <p>More information on languages is available from the <br />   <a href=\"http://community.joomla.org/translations.html\" target=\"_blank\" title=\"Joomla! Translation Teams\">http://community.joomla.org/translations.html</a></p>','',1,4,0,29,'2008-08-11 06:00:00',62,'','2008-08-11 06:00:00',62,0,'0000-00-00 00:00:00','2006-10-10 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',24,0,3,'About Joomla!, General, Extensions','',0,198,'robots=\nauthor='),
(27,'The Joomla! Community','the-joomla-community','','<p><strong>Got a question? </strong>With more than 210,000 members, the Joomla! Discussion Forums at <a href=\"http://forum.joomla.org/\" target=\"_blank\" title=\"Forums\">forum.joomla.org</a> are a great resource for both new and experienced users. Ask your toughest questions the community is waiting to see what you\'ll do with your Joomla! site.</p><p><strong>Do you want to show off your new Joomla! Web site?</strong> Visit the <a href=\"http://forum.joomla.org/viewforum.php?f=514\" target=\"_blank\" title=\"Site Showcase\">Site Showcase</a>section of our forum.</p><p><strong>Do you want to contribute?</strong></p><p>If you think working with Joomla is fun, wait until you start working on it. We\'re passionate about helping Joomla users become contributors. There are many ways you can help Joomla\'s development:</p><ul>	<li>Submit news about Joomla. We syndicate Joomla-related news on <a href=\"http://news.joomla.org\" target=\"_blank\" title=\"JoomlaConnect\">JoomlaConnect<sup>TM</sup></a>. If you have Joomla news that you would like to share with the community, find out how to get connected<a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">here</a>.</li>	<li>Report bugs and request features in our <a href=\"http://joomlacode.org/gf/project/joomla/tracker/\" target=\"_blank\" title=\"Joomla! developement trackers\">trackers</a>. Please read <a href=\"http://docs.joomla.org/Filing_bugs_and_issues\" target=\"_blank\" title=\"Reporting Bugs\">Reporting Bugs</a>, for details on how we like our bug reports served up</li><li>Submit patches for new and/or fixed behaviour. Please read <a href=\"http://docs.joomla.org/Patch_submission_guidelines\" target=\"_blank\" title=\"Submitting Patches\">Submitting Patches</a>, for details on how to submit a patch.</li><li>Join the <a href=\"http://forum.joomla.org/viewforum.php?f=509\" target=\"_blank\" title=\"Joomla! development forums\">developer forums</a> and share your ideas for how to improve Joomla. We\'re always open to suggestions, although we\'re likely to be sceptical of large-scale suggestions without some code to back it up.</li><li>Join any of the <a href=\"http://www.joomla.org/about-joomla/the-project/working-groups.html\" target=\"_blank\" title=\"Joomla! working groups\">Joomla Working Groups</a> and bring your personal expertise to the Joomla community.</li></ul><p>These are just a few ways you can contribute. See<a href=\"http://www.joomla.org/about-joomla/contribute-to-joomla.html\" target=\"_blank\" title=\"Contribute\">Contribute to Joomla</a>for many more ways.</p>','',1,4,0,30,'2008-08-12 16:50:48',62,'','2008-08-12 16:50:48',62,62,'2010-03-09 04:41:09','2006-10-11 02:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',12,0,2,'','',0,59,'robots=\nauthor='),
(28,'How do I install Joomla! 1.5?','how-do-i-install-joomla-15','','<p>Installing of Joomla! 1.5 is pretty easy. We assume you have set-up your Web site, and it is accessible with your browser.<br /><br />Download Joomla! 1.5, unzip it and upload/copy the files into the directory you Web site points to, fire up your browser and enter your Web site address and the installation will start.  </p><p>For full details on the installation processes check out the <a href=\"http://help.joomla.org/content/category/48/268/302\" target=\"_blank\" title=\"Joomla! 1.5 Installation Manual\">Installation Manual</a> on the <a href=\"http://help.joomla.org\" target=\"_blank\" title=\"Joomla! Help Site\">Joomla! Help Site</a> where you will also find download instructions for a PDF version too. </p>','',1,3,0,31,'2008-08-11 01:10:59',62,'','2008-08-11 01:10:59',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,3,'','',0,7,'robots=\nauthor='),
(29,'What is the purpose of the collation selection in the installation screen?','what-is-the-purpose-of-the-collation-selection-in-the-installation-screen','','The collation option determines the way ordering in the database is done. In languages that use special characters, for instance the German umlaut, the database collation determines the sorting order. If you don\'t know which collation you need, select the \"utf8_general_ci\" as most languages use this. The other collations listed are exceptions in regards to the general collation. If your language is not listed in the list of collations it most likely means that \"utf8_general_ci is suitable.','',1,3,0,32,'2008-08-11 03:11:38',62,'','2008-08-11 03:11:38',62,0,'0000-00-00 00:00:00','2006-10-10 08:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=',4,0,4,'','',0,6,'robots=\nauthor='),
(30,'What languages are supported by Joomla! 1.5?','what-languages-are-supported-by-joomla-15','','Within the Installer you will find a wide collection of languages. The installer currently supports the following languages: Arabic, Bulgarian, Bengali, Czech, Danish, German, Greek, English, Spanish, Finnish, French, Hebrew, Devanagari(India), Croatian(Croatia), Magyar (Hungary), Italian, Malay, Norwegian bokmal, Dutch, Portuguese(Brasil), Portugues(Portugal), Romanian, Russian, Serbian, Svenska, Thai and more are being added all the time.<br />By default the English language is installed for the Back and Front-ends. You can download additional language files from the <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla!Extensions Directory</a>. ','',1,3,0,32,'2008-08-11 01:12:18',62,'','2010-01-16 20:53:56',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,2,'','',0,8,'robots=\nauthor='),
(31,'Is it useful to install the sample data?','is-it-useful-to-install-the-sample-data','','Well you are reading it right now! This depends on what you want to achieve. If you are new to Joomla! and have no clue how it all fits together, just install the sample data. If you don\'t like the English sample data because you - for instance - speak Chinese, then leave it out.','',1,3,0,27,'2008-08-11 09:12:55',62,'','2008-08-11 09:12:55',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,3,'','',0,3,'robots=\nauthor='),
(32,'Where is the Static Content Item?','where-is-the-static-content','','<p>In Joomla! versions prior to 1.5 there were separate processes for creating a Static Content Item and normal Content Items. The processes have been combined now and whilst both content types are still around they are renamed as Articles for Content Items and Uncategorized Articles for Static Content Items. </p><p>If you want to create a static item, create a new Article in the same way as for standard content and rather than relating this to a particular Section and Category just select <span style=\"font-style: italic\">Uncategorized</span> as the option in the Section and Category drop down lists.</p>','',1,3,0,28,'2008-08-10 23:13:33',62,'','2008-08-10 23:13:33',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,6,'','',0,5,'robots=\nauthor='),
(33,'What is an Uncategorised Article?','what-is-uncategorised-article','','Most Articles will be assigned to a Section and Category. In many cases, you might not know where you want it to appear so put the Article in the <em>Uncategorized </em>Section/Category. The Articles marked as <em>Uncategorized </em>are handled as static content.','',1,3,0,31,'2008-08-11 15:14:11',62,'','2008-08-11 15:14:11',62,0,'0000-00-00 00:00:00','2006-10-10 12:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,2,'','',0,6,'robots=\nauthor='),
(34,'Does the PDF icon render pictures and special characters?','does-the-pdf-icon-render-pictures-and-special-characters','','Yes! Prior to Joomla! 1.5, only the text values of an Article and only for ISO-8859-1 encoding was allowed in the PDF rendition. With the new PDF library in place, the complete Article including images is rendered and applied to the PDF. The PDF generator also handles the UTF-8 texts and can handle any character sets from any language. The appropriate fonts must be installed but this is done automatically during a language pack installation.','',1,3,0,32,'2008-08-11 17:14:57',62,'','2008-08-11 17:14:57',62,0,'0000-00-00 00:00:00','2006-10-10 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,3,'','',0,6,'robots=\nauthor='),
(35,'Is it possible to change A Menu Item\'s Type?','is-it-possible-to-change-the-types-of-menu-entries','','<p>You indeed can change the Menu Item\'s Type to whatever you want, even after they have been created. </p><p>If, for instance, you want to change the Blog Section of a Menu link, go to the Control Panel-&gt;Menus Menu-&gt;[menuname]-&gt;Menu Item Manager and edit the Menu Item. Select the <strong>Change Type</strong> button and choose the new style of Menu Item Type from the available list. Thereafter, alter the Details and Parameters to reconfigure the display for the new selection  as you require it.</p>','',1,3,0,31,'2008-08-10 23:15:36',62,'','2008-08-10 23:15:36',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,1,'','',0,18,'robots=\nauthor='),
(36,'Where did the Installers go?','where-did-the-installer-go','','The improved Installer can be found under the Extensions Menu. With versions prior to Joomla! 1.5 you needed to select a specific Extension type when you wanted to install it and use the Installer associated with it, with Joomla! 1.5 you just select the Extension you want to upload, and click on install. The Installer will do all the hard work for you.','',1,3,0,28,'2008-08-10 23:16:20',62,'','2008-08-10 23:16:20',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,1,'','',0,4,'robots=\nauthor='),
(37,'Where did the Mambots go?','where-did-the-mambots-go','','<p>Mambots have been renamed as Plugins. </p><p>Mambots were introduced in Mambo and offered possibilities to add plug-in logic to your site mainly for the purpose of manipulating content. In Joomla! 1.5, Plugins will now have much broader capabilities than Mambots. Plugins are able to extend functionality at the framework layer as well.</p>','',1,3,0,28,'2008-08-11 09:17:00',62,'','2008-08-11 09:17:00',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,5,'','',0,7,'robots=\nauthor='),
(38,'I installed with my own language, but the Back-end is still in English','i-installed-with-my-own-language-but-the-back-end-is-still-in-english','','<p>A lot of different languages are available for the Back-end, but by default this language may not be installed. If you want a translated Back-end, get your language pack and install it using the Extension Installer. After this, go to the Extensions Menu, select Language Manager and make your language the default one. Your Back-end will be translated immediately.</p><p>Users who have access rights to the Back-end may choose the language they prefer in their Personal Details parameters. This is of also true for the Front-end language.</p><p> A good place to find where to download your languages and localised versions of Joomla! is <a href=\"http://extensions.joomla.org/index.php?option=com_mtree&task=listcats&cat_id=1837&Itemid=35\" target=\"_blank\" title=\"Translations for Joomla!\">Translations for Joomla!</a> on JED.</p>','',1,3,0,32,'2008-08-11 17:18:14',62,'','2008-08-11 17:18:14',62,0,'0000-00-00 00:00:00','2006-10-10 14:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,1,'','',0,7,'robots=\nauthor='),
(39,'How do I remove an Article?','how-do-i-remove-an-article','','<p>To completely remove an Article, select the Articles that you want to delete and move them to the Trash. Next, open the Article Trash in the Content Menu and select the Articles you want to delete. After deleting an Article, it is no longer available as it has been deleted from the database and it is not possible to undo this operation.  </p>','',1,3,0,27,'2008-08-11 09:19:01',62,'','2008-08-11 09:19:01',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,2,'','',0,4,'robots=\nauthor='),
(40,'What is the difference between Archiving and Trashing an Article? ','what-is-the-difference-between-archiving-and-trashing-an-article','','<p>When you <em>Archive </em>an Article, the content is put into a state which removes it from your site as published content. The Article is still available from within the Control Panel and can be <em>retrieved </em>for editing or republishing purposes. Trashed Articles are just one step from being permanently deleted but are still available until you Remove them from the Trash Manager. You should use Archive if you consider an Article important, but not current. Trash should be used when you want to delete the content entirely from your site and from future search results.  </p>','',1,3,0,27,'2008-08-11 05:19:43',62,'','2008-08-11 05:19:43',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,1,'','',0,5,'robots=\nauthor='),
(41,'Newsflash 5','newsflash-5','','Joomla! 1.5 - \'Experience the Freedom\'!. It has never been easier to create your own dynamic Web site. Manage all your content from the best CMS admin interface and in virtually any language you speak.','',1,1,0,3,'2008-08-12 00:17:31',62,'','2008-08-12 00:17:31',62,0,'0000-00-00 00:00:00','2006-10-11 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,2,'','',0,4,'robots=\nauthor='),
(42,'Newsflash 4','newsflash-4','','Yesterday all servers in the U.S. went out on strike in a bid to get more RAM and better CPUs. A spokes person said that the need for better RAM was due to some fool increasing the front-side bus speed. In future, buses will be told to slow down in residential motherboards.','',1,1,0,3,'2008-08-12 00:25:50',62,'','2008-08-12 00:25:50',62,62,'2010-01-16 18:48:30','2006-10-11 06:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,1,'','',0,5,'robots=\nauthor='),
(43,'Example Pages and Menu Links','example-pages-and-menu-links','','<p>This page is an example of content that is <em>Uncategorized</em>; that is, it does not belong to any Section or Category. You will see there is a new Menu in the left column. It shows links to the same content presented in 4 different page layouts.</p><ul><li>Section Blog</li><li>Section Table</li><li> Blog Category</li><li>Category Table</li></ul><p>Follow the links in the <strong>Example Pages</strong> Menu to see some of the options available to you to present all the different types of content included within the default installation of Joomla!.</p><p>This includes Components and individual Articles. These links or Menu Item Types (to give them their proper name) are all controlled from within the <strong><font face=\"courier new,courier\">Menu Manager-&gt;[menuname]-&gt;Menu Items Manager</font></strong>. </p>','',1,0,0,0,'2008-08-12 09:26:52',62,'','2008-08-12 09:26:52',62,0,'0000-00-00 00:00:00','2006-10-11 10:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,2,'Uncategorized, Uncategorized, Example Pages and Menu Links','',0,48,'robots=\nauthor='),
(44,'Joomla! Security Strike Team','joomla-security-strike-team','','<p>The Joomla! Project has assembled a top-notch team of experts to form the new Joomla! Security Strike Team. This new team will solely focus on investigating and resolving security issues. Instead of working in relative secrecy, the JSST will have a strong public-facing presence at the <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a>.</p>','<p>The new JSST will call the new <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a> their home base. The Security Center provides a public presence for <a href=\"http://developer.joomla.org/security/news.html\" target=\"_blank\" title=\"Joomla! Security News\">security issues</a> and a platform for the JSST to <a href=\"http://developer.joomla.org/security/articles-tutorials.html\" target=\"_blank\" title=\"Joomla! Security Articles\">help the general public better understand security</a> and how it relates to Joomla!. The Security Center also offers users a clearer understanding of how security issues are handled. There\'s also a <a href=\"http://feeds.joomla.org/JoomlaSecurityNews\" target=\"_blank\" title=\"Joomla! Security News Feed\">news feed</a>, which provides subscribers an up-to-the-minute notification of security issues as they arise.</p>',1,1,0,1,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',1,0,3,'','',0,9,'robots=\nauthor='),
(45,'Joomla! Community Portal','joomla-community-portal','','<p>The <a href=\"http://community.joomla.org/\" target=\"_blank\" title=\"Joomla! Community Portal\">Joomla! Community Portal</a> is now online. There, you will find a constant source of information about the activities of contributors powering the Joomla! Project. Learn about <a href=\"http://community.joomla.org/events.html\" target=\"_blank\" title=\"Joomla! Events\">Joomla! Events</a> worldwide, and see if there is a <a href=\"http://community.joomla.org/user-groups.html\" target=\"_blank\" title=\"Joomla! User Groups\">Joomla! User Group</a> nearby.</p><p>The <a href=\"http://community.joomla.org/magazine.html\" target=\"_blank\" title=\"Joomla! Community Magazine\">Joomla! Community Magazine</a> promises an interesting overview of feature articles, community accomplishments, learning topics, and project updates each month. Also, check out <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">JoomlaConnect&#0153;</a>. This aggregated RSS feed brings together Joomla! news from all over the world in your language. Get the latest and greatest by clicking <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">here</a>.</p>','',1,1,0,1,'2007-07-07 09:54:06',62,'','2010-01-16 18:59:02',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',4,0,2,'','',0,5,'robots=\nauthor='),
(47,'Molestie innonummy Libero','molestie-innonummy-libero','','<img src=\"images/stories/demo/sam-5.jpg\" alt=\"Source: joomlart.com\" align=\"left\" class=\"caption\" />\r\n\r\n<p>In id, mauris viverra asperiores, bibendum in id. Eu molestie. Uc sit eu. Id iaculis id, pulvinar ut imperdiet. Vestibulum convallis. Gravida vivamus adipiscing, vitae ut ac, neque venenatis cras tincidunt, ut tellus et. Gravida scelerisque, ipsum sed iaculis, nunc non nam.</p>\r\n\r\n','\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n\r\n<h3>This is an Heading 3</h3>\r\n<ul>\r\n<li>Laoreet magnis in Proin felis</li>\r\n<li>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt.</li>\r\n<li>Tortor turpis justo nulla tempus sem consequat</li>\r\n<li>Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi.</li>\r\n</ul>\r\n\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>',1,5,0,35,'2008-08-12 10:00:00',62,'','2010-03-03 06:59:02',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',12,0,4,'','',0,12,'robots=\nauthor='),
(48,'Amazing blog design','amazing-blog-design','','<img src=\"images/stories/demo/sam-2.jpg\" alt=\"Source: psdtuts.com\" align=\"left\" class=\"caption\" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus <a href=\"#\" title=\"Sample link\">adipiscing faucibus amet sed</a></p>\r\n\r\n','\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n\r\n<h3>Pharetra commodo elit nulla suscipit</h3>\r\n\r\n<ul>\r\n<li><strong>Step 1: </strong>Nam in sed ultrices tristique</li>\r\n<li><strong>Step 2: </strong>Tortor turpis justo nulla tempus</li>\r\n<li><strong>Step 3: </strong>Dolor orci In Aenean Aenean Sed tellus</li>\r\n<li><strong>Step 4: </strong>Lorem vitae quis gravida dapibus nibh felis malesuada non tristique.</li>\r\n<li><strong>Step 5: </strong>At penatibus leo laoreet tempus.</li>\r\n</ul>\r\n\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>',1,5,0,35,'2008-08-12 10:00:00',62,'','2010-01-28 07:14:23',62,62,'2010-02-01 21:44:42','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',11,0,2,'','',0,97,'robots=\nauthor='),
(49,'You know when youve arrived','you-know-when-youve-arrived','','<img src=\"images/stories/demo/sam-4.jpg\" alt=\"Source: psdtuts.com\" align=\"left\" class=\"caption\" />\r\n\r\n<p>Even knowing the technique is important in this kind of design, is more about creativity and experimentation. You will learn how to use the Art History Brush and combine it with watercolor custom...</p>\r\n\r\n','\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>',1,5,0,35,'2008-08-12 10:00:00',62,'','2010-01-28 07:14:06',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',11,0,1,'','',0,46,'robots=\nauthor='),
(50,'Marketing Solutions Company','marketing-solutions-company','','<img class=\"caption\" src=\"images/stories/demo/sam-3.jpg\" border=\"0\" alt=\"Source: psdtuts.com\" align=\"left\" />\r\n<p>Lorem ipsum dolor sit amet consectetuer urna quis vel convallis tincidunt. Nam in sed ultrices tristique mi non ut facilisi id non. Et Sed egestas tristique lacinia nibh ridiculus adipiscing faucibus amet sed. Lacinia consectetuer Donec Vestibulum dui Duis ligula at amet Morbi nonummy. Laoreet Lorem sapien tincidunt auctor In mauris id Suspendisse risus id. Et non gravida vel nibh.</p>\r\n\r\n','\r\n\r\n<p>Laoreet magnis in Proin felis in venenatis Sed nunc sapien condimentum. Vestibulum Morbi id Nam tellus Quisque nunc nunc ut Morbi Aenean. Suspendisse et tellus vitae In Nam platea aliquet tincidunt nisl vitae. Suscipit felis orci dui Nam Sed orci wisi vitae velit urna. Sagittis nunc id Aliquam Vivamus cursus consectetuer vel quis sed pellentesque. Justo Aliquam risus Nam tellus risus Quisque Quisque augue.</p>\r\n\r\n<p>Sed dui Praesent nibh Curabitur ipsum nunc facilisi risus elit eget. Pharetra commodo elit nulla suscipit nunc eros nec lacus odio tortor. Suscipit semper felis Integer dui porttitor ac eu consequat id metus. Dui Cras congue ac ante et Nam nunc tempus habitant quis. Tincidunt elit sollicitudin risus ut libero In justo fames elit facilisi. Lorem Aenean vitae lacus vel semper laoreet aliquet turpis.</p>\r\n\r\n<p>Tortor turpis justo nulla tempus sem consequat id sed elit tincidunt. Dolor orci In Aenean Aenean Sed tellus Pellentesque Pellentesque mauris Cum. Lorem lacinia felis Quisque elit Vestibulum pellentesque amet wisi Curabitur In. Aliquam Lorem vitae quis gravida dapibus nibh felis malesuada non tristique. Elit Phasellus dui feugiat mauris dictum hendrerit tincidunt volutpat purus id. At penatibus leo laoreet tempus.</p>',1,5,0,35,'2008-08-12 10:00:00',62,'','2010-03-27 21:45:25',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',36,0,3,'','',0,971,'robots=\nauthor='),
(51,'Joomla! Community Portal','joomla-community-portal','','<p>The <a href=\"http://community.joomla.org/\" target=\"_blank\" title=\"Joomla! Community Portal\">Joomla! Community Portal</a> is now online. There, you will find a constant source of information about the activities of contributors powering the Joomla! Project. Learn about <a href=\"http://community.joomla.org/events.html\" target=\"_blank\" title=\"Joomla! Events\">Joomla! Events</a> worldwide, and see if there is a <a href=\"http://community.joomla.org/user-groups.html\" target=\"_blank\" title=\"Joomla! User Groups\">Joomla! User Group</a> nearby.</p><p>The <a href=\"http://community.joomla.org/magazine.html\" target=\"_blank\" title=\"Joomla! Community Magazine\">Joomla! Community Magazine</a> promises an interesting overview of feature articles, community accomplishments, learning topics, and project updates each month. Also, check out <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">JoomlaConnect&#0153;</a>. This aggregated RSS feed brings together Joomla! news from all over the world in your language. Get the latest and greatest by clicking <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">here</a>.</p>','',1,1,0,34,'2007-07-07 09:54:06',62,'','2010-01-16 18:59:02',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',4,0,5,'','',0,0,'robots=\nauthor='),
(52,'Joomla! Security Strike Team','joomla-security-strike-team','','<p>The Joomla! Project has assembled a top-notch team of experts to form the new Joomla! Security Strike Team. This new team will solely focus on investigating and resolving security issues. Instead of working in relative secrecy, the JSST will have a strong public-facing presence at the <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a>.</p>','<p>The new JSST will call the new <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a> their home base. The Security Center provides a public presence for <a href=\"http://developer.joomla.org/security/news.html\" target=\"_blank\" title=\"Joomla! Security News\">security issues</a> and a platform for the JSST to <a href=\"http://developer.joomla.org/security/articles-tutorials.html\" target=\"_blank\" title=\"Joomla! Security Articles\">help the general public better understand security</a> and how it relates to Joomla!. The Security Center also offers users a clearer understanding of how security issues are handled. There\'s also a <a href=\"http://feeds.joomla.org/JoomlaSecurityNews\" target=\"_blank\" title=\"Joomla! Security News Feed\">news feed</a>, which provides subscribers an up-to-the-minute notification of security issues as they arise.</p>',1,1,0,34,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',1,0,6,'','',0,0,'robots=\nauthor='),
(53,'Millions of Smiles','millions-of-smiles','','<p>The Joomla! team has millions of good reasons to be smiling about the Joomla! 1.5. In its current incarnation, it\'s had millions of downloads, taking it to an unprecedented level of popularity.  The new code base is almost an entire re-factor of the old code base.  The user experience is still extremely slick but for developers the API is a dream.  A proper framework for real PHP architects seeking the best of the best.</p><p>If you\'re a former Mambo User or a 1.0 series Joomla! User, 1.5 is the future of CMSs for a number of reasons.  It\'s more powerful, more flexible, more secure, and intuitive.  Our developers and interface designers have worked countless hours to make this the most exciting release in the content management system sphere.</p><p>Go on ... get your FREE copy of Joomla! today and spread the word about this benchmark project. </p>','',1,1,0,34,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,8,'','',0,0,'robots=\nauthor='),
(54,'We are Volunteers','we-are-volunteers','','<p>The Joomla Core Team and Working Group members are volunteer developers, designers, administrators and managers who have worked together to take Joomla! to new heights in its relatively short life. Joomla! has some wonderfully talented people taking Open Source concepts to the forefront of industry standards.  Joomla! 1.5 is a major leap forward and represents the most exciting Joomla! release in the history of the project. </p>','',1,1,0,34,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',10,0,7,'','',0,0,'robots=\nauthor='),
(55,'Welcome to Joomla!','welcome-to-joomla','','<div align=\"left\"><strong>Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. <br /></strong></div><p><img src=\"images/stories/powered_by.png\" class=\"caption\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla! provides an easy-to-use graphical user interface that simplifies the management and publishing of large volumes of content including HTML, documents, and rich media.  Joomla! is used by organisations of all sizes for intranets and extranets and is supported by a community of tens of thousands of users. </p>','With a fully documented library of developer resources, Joomla! allows the customisation of every aspect of a Web site including presentation, layout, administration, and the rapid integration with third-party applications.<p>Joomla! now provides more developer power while making the user experience all the more friendly. For those who always wanted increased extensibility, Joomla! 1.5 can make this happen.</p><p>A new framework, ground-up refactoring, and a highly-active development team brings the excitement of \'the next generation CMS\' to your fingertips.  Whether you are a systems architect or a complete \'noob\' Joomla! can take you to the next level of content delivery. \'More than a CMS\' is something we have been playing with as a catchcry because the new Joomla! API has such incredible power and flexibility, you are free to take whatever direction your creative mind takes you and Joomla! can help you get there so much more easily than ever before.</p><p>Thinking Web publishing? Think Joomla!</p>',1,1,0,34,'2008-08-12 10:00:00',62,'','2010-03-25 20:48:28',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',31,0,4,'','',0,0,'robots=\nauthor='),
(56,'42 Really Funny And Creative Print Ads','42-really-funny-and-creative-print-ads','','<p>Suscipit suspendisse sed pat um a, enim ut montes vulputate tortor luctus auctor.Lorem ipsum dolor sit amet consectetuer fringilla justo neque platea at. Metus elit semper turpis nec eu Integer Sed elit Vestibulum lacus. Nunc et condimentum nibh hendrerit quis laoreet et ut leo tristique. Mus mauris Aliquam et Suspendisse eros dolor Nam tincidunt hendrerit urna. Sed justo interdum est vitae pellentesque fames arcu Maecenas sed ac. Praesent ac netus Maecenas vel.</p>\r\n<p>Consequat velit feugiat hac ut justo lorem Curabitur nec id felis. Cum euismod congue vitae Nam magna et sem consectetuer tincidunt Morbi. Mauris dictum neque Sed id interdum porta felis suscipit semper laoreet. Lorem magna condimentum nec tincidunt Nulla facilisis pellentesque nec pede Nulla. Suspendisse risus Vestibulum neque sit velit.</p>\r\n<p>Et in Phasellus vitae wisi et dui mauris orci Curabitur ac. Ut Phasellus Phasellus hendrerit Phasellus Nulla mus ligula Nam Vivamus ut. Curabitur at justo nulla Curabitur nunc et lacus justo Donec molestie. Elit sapien vel elit condimentum vitae massa id consequat quis Donec. Nunc justo aliquam habitasse enim urna dolor Sed elit.</p>\r\n<p>Consequat condimentum Nulla ornare Nam eu non adipiscing porta malesuada quis. Magna id et elit sem tellus ipsum Maecenas adipiscing fringilla ac. Eu id senectus odio velit velit commodo Phasellus Praesent Integer Sed. Sapien lacinia Nunc vel pede platea urna senectus lacus Cras condimentum. Suscipit pretium eget quis semper sem est at at eu semper. Vestibulum Sed elit in congue justo pede Quisque sit.</p>','',1,1,0,34,'2010-01-18 17:42:57',62,'','2010-01-18 17:47:28',62,0,'0000-00-00 00:00:00','2010-01-18 17:42:57','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',4,0,3,'','',0,15,'robots=\nauthor='),
(57,'10 Amazing Typographic Poster Tutorials','10-amazing-typographic-poster-tutorials','','<p>Below are 10 amazing tutorials that teach you how to create typographic posters. </p>\r\n<p>Consequat velit feugiat hac ut justo lorem Curabitur nec id felis. Cum euismod congue vitae Nam magna et sem consectetuer tincidunt Morbi. Mauris dictum neque Sed id interdum porta felis suscipit semper laoreet. Lorem magna condimentum nec tincidunt Nulla facilisis pellentesque nec pede Nulla. Suspendisse risus Vestibulum neque sit velit.</p>\r\n<p>Et in Phasellus vitae wisi et dui mauris orci Curabitur ac. Ut Phasellus Phasellus hendrerit Phasellus Nulla mus ligula Nam Vivamus ut. Curabitur at justo nulla Curabitur nunc et lacus justo Donec molestie. Elit sapien vel elit condimentum vitae massa id consequat quis Donec. Nunc justo aliquam habitasse enim urna dolor Sed elit.</p>\r\n<p>Consequat condimentum Nulla ornare Nam eu non adipiscing porta malesuada quis. Magna id et elit sem tellus ipsum Maecenas adipiscing fringilla ac. Eu id senectus odio velit velit commodo Phasellus Praesent Integer Sed. Sapien lacinia Nunc vel pede platea urna senectus lacus Cras condimentum. Suscipit pretium eget quis semper sem est at at eu semper. Vestibulum Sed elit in congue justo pede Quisque sit.</p>','',1,1,0,34,'2010-01-18 17:42:57',62,'','2010-01-18 17:51:15',62,0,'0000-00-00 00:00:00','2010-01-18 17:42:57','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',4,0,2,'','',0,6,'robots=\nauthor='),
(58,'330 Free Letter Pressed Icons','330-free-letter-pressed-icons','','<p>Even knowing the technique is important in this kind of design, is more about creativity and experimentation. You will learn how to use the Art History Brush and combine it with watercolor custom...</p>\r\n<p>Consequat velit feugiat hac ut justo lorem Curabitur nec id felis. Cum euismod congue vitae Nam magna et sem consectetuer tincidunt Morbi. Mauris dictum neque Sed id interdum porta felis suscipit semper laoreet. Lorem magna condimentum nec tincidunt Nulla facilisis pellentesque nec pede Nulla. Suspendisse risus Vestibulum neque sit velit.</p>\r\n<p>Et in Phasellus vitae wisi et dui mauris orci Curabitur ac. Ut Phasellus Phasellus hendrerit Phasellus Nulla mus ligula Nam Vivamus ut. Curabitur at justo nulla Curabitur nunc et lacus justo Donec molestie. Elit sapien vel elit condimentum vitae massa id consequat quis Donec. Nunc justo aliquam habitasse enim urna dolor Sed elit.</p>\r\n<p>Consequat condimentum Nulla ornare Nam eu non adipiscing porta malesuada quis. Magna id et elit sem tellus ipsum Maecenas adipiscing fringilla ac. Eu id senectus odio velit velit commodo Phasellus Praesent Integer Sed. Sapien lacinia Nunc vel pede platea urna senectus lacus Cras condimentum. Suscipit pretium eget quis semper sem est at at eu semper. Vestibulum Sed elit in congue justo pede Quisque sit.</p>','',1,1,0,34,'2010-01-18 17:42:57',62,'','2010-01-18 17:52:15',62,0,'0000-00-00 00:00:00','2010-01-18 17:42:57','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',1,0,1,'','',0,0,'robots=\nauthor='),
(59,'JA Ores\'s Typography','ja-oress-typography','','<p>This page presents most of typographical aspects of JA Ores. <span class=\"highlight\">Make your readers happy</span> with great Typography and User Experience!</p>\r\n\r\n<h1>This is an Heading 1</h1>\r\n\r\n<p>Lorem tortor Curabitur urna interdum Maecenas ut felis Sed euismod id. Congue Quisque augue elit dolor nibh id lobortis egestas tristique fringilla. Laoreet elit.</p>\r\n\r\n<h2>This is an Heading 2</h2>\r\n\r\n<p>Wisi sed pede Phasellus Vestibulum elit consequat consequat eu pellentesque metus. Laoreet Vestibulum pharetra pede mattis nunc dapibus id magna a dictumst.</p>\r\n\r\n<h3>This is an Heading 3</h3>\r\n\r\n<p>Wisi sed pede Phasellus Vestibulum elit consequat consequat eu pellentesque metus. Laoreet Vestibulum pharetra pede mattis nunc dapibus id magna a dictumst. Nunc cursus sem et pretium sapien eget consectetuer malesuada Phasellus Curabitur.</p>\r\n\r\n<h4>This is an Heading 4</h4>\r\n\r\n<p>Wisi sed pede Phasellus Vestibulum elit consequat consequat eu pellentesque metus. Laoreet Vestibulum pharetra pede mattis nunc dapibus id magna a dictumst. Nunc cursus sem et pretium sapien eget consectetuer malesuada Phasellus Curabitur.</p>\r\n\r\n<h2>Special Content</h2>\r\n\r\n<p>Below is a sample of <strong>&lt;pre&gt;</strong> or <strong>&lt;div class=\"code\"&gt;</strong></p>\r\n\r\n<pre>#ja-rightcol {<br />  width: 180px;<br />  float: right;<br />  color: #EEEEEE;<br />}<br /></pre>\r\n\r\n<p>This is a <span class=\"highlight\">highlight phrase</span>. Use <strong>&lt;span class=\"highlight\"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n\r\n<p><span class=\"dropcap\">T</span>his is a Magazine Style Drop Cap. The first letter in this paragraph is big. JA Ores bring into your Jooomla template the magazine drop cap technique and CSS2 includes the first-letter pseudo class. In all fairness to the paragraph itself we probably should type enough to see how it looks when it is surrounded by its textual friends by using more words.</p>\r\n\r\n<blockquote><span class=\"open\">T</span>his is a sample Blockquote. Use <strong>&lt;blockquote&gt;Your quote goes here!&lt;/blockquote&gt;</strong> to form a quote!</blockquote>\r\n\r\n<blockquote><span class=\"open\">T</span>his is a sample Blockquote. Use <strong>&lt;blockquote&gt;&lt;span class=\"open\"&gt;Y&lt;/span&gt;our quote goes her&lt;span class=\"close\"&gt;e!&lt;/span&gt;&lt;/blockquote&gt;</strong> to form a quote<span class=\"close\">!</span></blockquote>\r\n\r\n<h2>Lists Style</h2>\r\n\r\n<div class=\"clearfix\">\r\n<div style=\"width: 48%; float: left;\"><ol>\r\n<li>This is a sample <strong>Ordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetuer.</li>\r\n<li>Condimentum quis.</li>\r\n<li>Congue Quisque augue elit dolor nibh.</li>\r\n</ol></div>\r\n<div style=\"width: 48%; float: right;\">\r\n<ul>\r\n<li>This is a sample <strong>Unordered List</strong>.</li>\r\n<li>Condimentum quis.</li>\r\n<li>Lorem ipsum dolor sit amet consectetuer.</li>\r\n<li>Congue Quisque augue elit dolor nibh.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n\r\n<div class=\"clearfix\">\r\n<div style=\"width: 48%; float: left;\">\r\n<ul class=\"arrow\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Arrow list</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"arrow\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Checklist.</li>\r\n</ul>\r\n<ul class=\"star\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Star List</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"star\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Star List.</li>\r\n</ul>\r\n<ul class=\"checklist\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Checklist</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"checklist\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Checklist.</li>\r\n</ul>\r\n</div>\r\n\r\n<div style=\"width: 48%; float: right;\">\r\n<ul class=\"phone\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Phone List</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"phone\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Phone List.</li>\r\n</ul>\r\n<ul class=\"address\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Address List</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"address\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Address List.</li>\r\n</ul>\r\n<ul class=\"email\">\r\n<li><span class=\"icon\"> </span>This is a sample <strong>Email List</strong>.</li>\r\n<li><span class=\"icon\"> </span>Use <strong>&lt;ul class=\"email\"&gt;&lt;li&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class=\"icon\"> </span>This is a sample Email List.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-1\">01</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-1\"&gt;&lt;span class=\"bignumber\"&gt;01.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-1\">02</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-1\"&gt;&lt;span class=\"bignumber\"&gt;02.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-1\">03</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-1\"&gt;&lt;span class=\"bignumber\"&gt;03.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-2\">01</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-2\"&gt;&lt;span class=\"bignumber\"&gt;01.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-2\">02</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-2\"&gt;&lt;span class=\"bignumber\"&gt;02.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-2\">03</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-2\"&gt;&lt;span class=\"bignumber\"&gt;03.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-3\">01</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-3\"&gt;&lt;span class=\"bignumber\"&gt;01.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-3\">02</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-3\"&gt;&lt;span class=\"bignumber\"&gt;02.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<p class=\"blocknumber\"><span class=\"bignumber-3\">03</span>This is a sample block number. Use <strong>&lt;p class=\"blocknumber-3\"&gt;&lt;span class=\"bignumber\"&gt;03.&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a block number!</p>\r\n\r\n<h2 style=\"margin: 0;\">Paragraph Style</h2>\r\n\r\n<div class=\"clearfix\" style=\"margin-bottom: 20px;\">\r\n\r\n<div style=\"width: 48%; float: left;\">\r\n<p class=\"error\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"error\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"message\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"message\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"tips\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"tips\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"key\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"key\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"tag\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"tag\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n</div>\r\n\r\n<div style=\"width: 48%; float: right;\">\r\n<p class=\"cart\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"cart\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"doc\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"doc\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"note\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"note\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class=\"photo\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"photo\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this</p>\r\n<p class=\"mobi\"><span class=\"icon\"> </span>Use <strong>&lt;p class=\"mobi\"&gt;&lt;span class=\"icon\"&gt;&amp;nbsp;&lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n</div>\r\n</div>\r\n\r\n<h2>Bubbles</h2>\r\n\r\n<div class=\"bubble bubble-l1 clearfix\">\r\n<div class=\"box-ct\">\r\n<div class=\"box tl\"></div>\r\n<div class=\"box tr\"></div>\r\n<div class=\"box bl\"></div>\r\n<div class=\"box br\"></div>\r\n&lt;div class=\"bubble <strong>bubble-l1</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> &lt;div class=\"box tl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box tr\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box bl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box br\"&gt;&amp;nbsp;&lt;/div&gt; <br /> Buble\'s content goes here! <br /> &lt;/div&gt; <br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt; &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n<div class=\"bubble bubble-l2 clearfix\">\r\n<div class=\"box-ct\">&lt;div class=\"bubble <strong>bubble-l2</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> Bubble\'s content goese here!<br /> &lt;/div&gt;<br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt;<br /> &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n<div class=\"bubble bubble-d1 clearfix\">\r\n<div class=\"box-ct\">\r\n<div class=\"box tl\"></div>\r\n<div class=\"box tr\"></div>\r\n<div class=\"box bl\"></div>\r\n<div class=\"box br\"></div>\r\n&lt;div class=\"bubble <strong>bubble-d1</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> &lt;div class=\"box tl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box tr\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box bl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box br\"&gt;&amp;nbsp;&lt;/div&gt; <br /> Buble\'s content goes here! <br /> &lt;/div&gt; <br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt; &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n<div class=\"bubble bubble-d2 clearfix\">\r\n<div class=\"box-ct\">&lt;div class=\"bubble <strong>bubble-d2</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> Bubble\'s content goese here!<br /> &lt;/div&gt;<br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt;<br /> &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n<div class=\"bubble bubble-hl1 clearfix\">\r\n<div class=\"box-ct\">\r\n<div class=\"box tl\"></div>\r\n<div class=\"box tr\"></div>\r\n<div class=\"box bl\"></div>\r\n<div class=\"box br\"></div>\r\n&lt;div class=\"bubble <strong>bubble-hl1</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> &lt;div class=\"box tl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box tr\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box bl\"&gt;&amp;nbsp;&lt;/div&gt; &lt;div class=\"box br\"&gt;&amp;nbsp;&lt;/div&gt; <br /> Buble\'s content goes here! <br /> &lt;/div&gt; <br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt; &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n\r\n<div class=\"bubble bubble-hl2 clearfix\">\r\n<div class=\"box-ct\">&lt;div class=\"bubble <strong>bubble-hl2</strong> clearfix\"&gt;<br /> &lt;div class=\"box-ct\"&gt;<br /> Bubble\'s content goese here!<br /> &lt;/div&gt;<br /> &lt;span class=\"arrow\"&gt;&amp;nbsp;&lt;/span&gt;<br /> &lt;span class=\"author\"&gt;Put author name here&lt;/span&gt;<br /> &lt;/div&gt;</div>\r\n<span class=\"arrow\"> </span> <span class=\"author\">Put author name here</span></div>\r\n\r\n<h2>Boxes and Legends Style</h2>\r\n\r\n<p class=\"box-sticky\">This is a sticky. Use <strong>&lt;p class=\"box-sticky\"&gt;Your clip note goes here!&lt;/p&gt;</strong> to create a clip note!</p>\r\n\r\n<p class=\"box-download\">This is a download box. Use <strong>&lt;p class=\"box-download\"&gt;Your download goes here!&lt;/p&gt;</strong> to create a download box!</p>\r\n\r\n<p class=\"box-grey\">This is a grey box. Use <strong>&lt;p class=\"box-grey\"&gt;Your content goes here!&lt;/p&gt;</strong> to create a grey box!</p>\r\n\r\n<p class=\"box-hilite\">This is a hilite box. Use <strong>&lt;p class=\"box-hilite\"&gt;Your content goes here!&lt;/p&gt;</strong> to create a hilite box!</p>\r\n<div class=\"legend\">\r\n\r\n<h3 class=\"legend-title\">Legend style</h3>\r\n\r\n<p>Use <strong>&lt;div class=\"legend\"&gt;&lt;h3 class=\"legend-title\"&gt;Your title&lt;/h3&gt;&lt;p&gt;</strong>Lorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae. A mauris risus consequat ac egestas netus est Vestibulum Curabitur consectetuer.<strong>&lt;/p&gt;&lt;/div&gt;</strong></p>\r\n</div>\r\n\r\n<div class=\"legend-hilite\">\r\n<h3 class=\"legend-title\">Legend style highlight</h3>\r\n<p>Use <strong>&lt;div class=\"legend-hilite\"&gt;&lt;h3 class=\"legend-title\"&gt;Your title&lt;/h3&gt;&lt;p&gt;</strong>Lorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae. A mauris risus consequat ac egestas netus est Vestibulum Curabitur consectetuer.<strong>&lt;/p&gt;&lt;/div&gt;</strong></p>\r\n</div>\r\n\r\n<h2>Special Module Style</h2>\r\n\r\n<div class=\"clearfix\">\r\n<div class=\"moduletable moduletable_badge badge-top\" style=\"border: 1px solid #303030; margin: 0pt 0pt 10px; padding: 0pt; width: 45%; float: left;\"><span class=\"badge\"> </span>\r\n<div class=\"ja-box-ct\" style=\"padding: 10px 25px;\">Use module suffix: <strong>_badge badge-top</strong> to put this badge on any module you like!</div>\r\n</div>\r\n\r\n<div class=\"moduletable moduletable_badge badge-new\" style=\"border: 1px solid #303030; margin: 0pt 0pt 10px; padding: 0pt; width: 45%; float: right;\"><span class=\"badge\"> </span>\r\n<div class=\"ja-box-ct\" style=\"padding: 10px 25px;\">Use module suffix: <strong>_badge badge-new</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"clearfix\">\r\n<div class=\"moduletable moduletable_badge badge-pick\" style=\"border: 1px solid #303030; margin: 0pt 0pt 10px; padding: 0pt; width: 45%; float: left;\"><span class=\"badge\"> </span>\r\n<div class=\"ja-box-ct\" style=\"padding: 10px 25px;\">Use module suffix: <strong>_badge badge-pick</strong> to put this badge on any module you like!</div>\r\n</div>\r\n<div class=\"moduletable moduletable_badge badge-hot\" style=\"border: 1px solid #303030; margin: 0pt 0pt 10px; padding: 0pt; width: 45%; float: right;\"><span class=\"badge\"> </span>\r\n<div class=\"ja-box-ct\" style=\"padding: 10px 25px;\">Use module suffix: <strong>_badge badge-hot</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>','',1,4,0,25,'2010-01-21 00:55:34',62,'','2010-03-18 17:05:47',62,0,'0000-00-00 00:00:00','2010-01-21 00:55:34','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',8,0,1,'','',0,305,'robots=\nauthor='),
(60,'Contact','contact','','<p>A quis fringilla In lacinia ligula nonummy dui Nam at feugiat. Metus ac ipsum convallis eleifend accumsan neque Aenean Suspendisse enim ut. Sed auctor Nunc Nam convallis justo sit a et tempor at. Id aliquam wisi</p>\r\n\r\n<div class=\"btlink clearfix\"><a href=\"#\" title=\"Sample link\">Take a Tour</a> <span>or</span> <a href=\"#\" class=\"Sample link\">Buy Now</a></div>\r\n\r\n','\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer vitae libero dui Vestibulum montes. Phasellus vitae tincidunt id fames Aliquam est accumsan leo lorem consectetuer. Consequat Curabitur at ullamcorper rutrum ipsum est mauris dolor a semper. Duis id hendrerit tempor semper cursus wisi tincidunt dictumst Sed netus. Lobortis augue Maecenas id dapibus tincidunt id et consequat Sed.</p>\r\n\r\n<p>Tincidunt velit fermentum sem Nullam dapibus justo id condimentum dui est. Sociis risus Vestibulum consequat congue scelerisque pretium nunc fermentum vitae leo. Ridiculus et consequat nec augue vitae pede interdum Praesent neque pede. Auctor Vestibulum dui eget velit dictumst tempor laoreet Ut amet accumsan. Ipsum lorem velit id quis Sed dui ipsum lorem eu Cum. Sed gravida felis vitae metus vitae id Aenean et libero et. </p>\r\n\r\n<p>Faucibus justo porta lacinia cursus nunc sollicitudin metus Pellentesque laoreet Vestibulum. Tempus pulvinar cursus iaculis mus condimentum laoreet Ut habitasse porta ante. Id Maecenas eget justo augue et convallis Donec Morbi interdum sem. Augue orci semper velit laoreet aliquam Morbi nonummy lorem at velit. Morbi consequat neque euismod congue Nulla Vestibulum Phasellus auctor senectus Donec. </p>\r\n\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>',1,5,0,36,'2010-02-25 16:08:50',62,'','2010-03-22 03:23:47',62,0,'0000-00-00 00:00:00','2010-02-25 00:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',12,0,4,'','',0,0,'robots=\nauthor='),
(62,'Work with Us','work-with-us','','<p>Vitae fringilla sapien Nulla ornare ut nisl scelerisque tortor wisi ut. Nec ipsum pede id magna Nulla sed Lorem leo semper consequat. Curabitur id id consectetuer auctor id ultrices Pellentesque ultrices Curabitur sem.</p>\r\n\r\n<div class=\"btlink clearfix\"><a href=\"#\" title=\"Sample link\">Take a Tour</a> <span>or</span> <a href=\"#\" class=\"Sample link\">Buy Now</a></div>\r\n\r\n','\r\n\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices. </p>\r\n\r\n<p>Pellentesque urna mauris semper nascetur Curabitur vitae eu Quisque libero interdum. Sagittis sit amet lacus tellus magna fringilla ac risus interdum velit. Nec eget tellus urna ante in pellentesque Mauris orci Phasellus metus. Feugiat Ut sed at Sed in mus metus nibh et interdum. Vitae quis lacus sem vitae at eget tempus tristique.</p>\r\n\r\n<p>Condimentum et convallis elit libero id Sed Vestibulum quis habitasse nunc. Id volutpat elit id mauris semper amet amet elit gravida vel. Vestibulum elit urna elit faucibus habitant In id at eget nibh. Tempus venenatis sapien quis rhoncus Nam orci nonummy purus Quisque orci. Pellentesque tortor arcu semper Donec Maecenas enim non Cum odio tortor. Sed cursus amet condimentum sed tempus.</p>',1,5,0,36,'2010-02-25 16:09:26',62,'','2010-03-22 03:23:24',62,0,'0000-00-00 00:00:00','2010-02-25 00:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=0\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',7,0,3,'','',0,2,'robots=\nauthor='),
(63,'Overview','overview','','<p>Mus congue tempus egestas sem in Suspendisse pretium orci suscipit semper. Curabitur pretium justo feugiat lacinia lacus Suspendisse eros nibh urna id. Vestibulum lacus lacinia justo enim sed cursus tellus id dis malesuada</p>\r\n\r\n<div class=\"btlink clearfix\"><a href=\"#\" title=\"Sample link\">Take a Tour</a> <span>or</span> <a href=\"#\" class=\"Sample link\">Buy Now</a></div>\r\n\r\n','\r\n\r\n<p>Tincidunt velit fermentum sem Nullam dapibus justo id condimentum dui est. Sociis risus Vestibulum consequat congue scelerisque pretium nunc fermentum vitae leo. Ridiculus et consequat nec augue vitae pede interdum Praesent neque pede. Auctor Vestibulum dui eget velit dictumst tempor laoreet Ut amet accumsan. Ipsum lorem velit id quis Sed dui ipsum lorem eu Cum. Sed gravida felis vitae metus vitae id Aenean et libero et. </p>\r\n\r\n<p>Faucibus justo porta lacinia cursus nunc sollicitudin metus Pellentesque laoreet Vestibulum. Tempus pulvinar cursus iaculis mus condimentum laoreet Ut habitasse porta ante. Id Maecenas eget justo augue et convallis Donec Morbi interdum sem. Augue orci semper velit laoreet aliquam Morbi nonummy lorem at velit. Morbi consequat neque euismod congue Nulla Vestibulum Phasellus auctor senectus Donec. </p>\r\n\r\n<p>Feugiat mauris turpis at Nullam tincidunt laoreet sem lobortis sagittis arcu. Penatibus eu a ridiculus at ac Aenean ipsum tristique Curabitur venenatis. Diam lorem malesuada sed Maecenas lacus nunc urna Curabitur egestas ligula. Massa Sed dolor orci justo lacinia auctor Aliquam Morbi id interdum. Nec neque augue Nulla Curabitur tellus cursus.</p>\r\n\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices. </p>',1,5,0,36,'2010-02-25 16:09:08',62,'','2010-03-22 03:23:32',62,0,'0000-00-00 00:00:00','2010-02-25 00:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=0\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,2,'','',0,0,'robots=\nauthor='),
(65,'Solutions and Ideas','solutions-a-ideas','','<p>Ut nullam leo imperdiet arcu aliquam, a id massa anim molestie at, amet libero tellus, fames nam erat pretium mattis volutpat leo, aliquam nulla. Neque eget ipsum suspendisse massa, ut tempor elit In id.</p>\r\n\r\n<div class=\"btlink clearfix\"><a href=\"#\" title=\"Sample link\">Take a Tour</a> <span>or</span> <a href=\"#\" class=\"Sample link\">Buy Now</a></div>\r\n\r\n','\r\n\r\n<p>Elit felis porttitor semper ipsum habitasse mauris congue vel lacinia iaculis. Mauris Fusce tellus velit mauris et dictum laoreet quis nulla ornare. Felis convallis consequat parturient gravida et et pede id rutrum et. Dui lacinia Suspendisse faucibus In justo nunc ac augue Phasellus sit. Lacus ullamcorper sit Vivamus ante quis elit tortor cursus ligula pretium. Vestibulum cursus.</p>\r\n\r\n<p>Accumsan turpis eros metus interdum et et neque amet et justo. Neque justo ipsum Morbi facilisi quis pretium cursus sagittis enim dapibus. Libero et et elit ut Sed Vestibulum condimentum semper ut ut. Sagittis velit ut volutpat eget convallis convallis tortor augue tincidunt congue. Gravida enim pretium Curabitur dui Nulla orci semper pede nibh nibh. Nam dictumst id Sed semper turpis Suspendisse risus convallis ut consectetuer. Rhoncus.</p>\r\n\r\n<p>Vestibulum nibh consectetuer amet lacus orci neque eros metus a augue. Adipiscing pulvinar Mauris amet nec ac Vivamus magnis tempus nunc ut. Interdum massa sagittis Mauris orci Nulla at feugiat Suspendisse ac cursus. Sit adipiscing Nulla nunc tellus wisi Praesent Nam sollicitudin Quisque Cum. Pretium ipsum nec felis Duis habitasse orci dapibus sapien hendrerit venenatis. Fringilla eget Integer ac vel gravida ante et mauris vel ultrices. </p>\r\n\r\n<p>Pellentesque urna mauris semper nascetur Curabitur vitae eu Quisque libero interdum. Sagittis sit amet lacus tellus magna fringilla ac risus interdum velit. Nec eget tellus urna ante in pellentesque Mauris orci Phasellus metus. Feugiat Ut sed at Sed in mus metus nibh et interdum. Vitae quis lacus sem vitae at eget tempus tristique.</p>\r\n\r\n<p>Condimentum et convallis elit libero id Sed Vestibulum quis habitasse nunc. Id volutpat elit id mauris semper amet amet elit gravida vel. Vestibulum elit urna elit faucibus habitant In id at eget nibh. Tempus venenatis sapien quis rhoncus Nam orci nonummy purus Quisque orci. Pellentesque tortor arcu semper Donec Maecenas enim non Cum odio tortor. Sed cursus amet condimentum sed tempus.</p>',0,5,0,36,'2010-02-25 16:08:50',62,'','2010-03-22 03:22:56',62,0,'0000-00-00 00:00:00','2010-02-25 00:00:00','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=0\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',13,0,1,'','',0,13,'robots=\nauthor='),
(66,'Metus habitasse sed interdum Nulla','metus-habitasse-sed-interdum-nulla','','{jathumbnail off}\r\n\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n\r\n','\r\n\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis. </p>\r\n\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>',1,5,0,37,'2010-03-03 07:24:54',62,'','2010-03-11 09:35:28',62,0,'0000-00-00 00:00:00','2010-03-03 07:24:54','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',5,0,4,'','',0,1,'robots=\nauthor='),
(67,'Eget elit lacinia nunc consequat ullamcorper','eget-elit-lacinia-nunc-consequat-ullamcorper','','{jathumbnail off}\r\n<img src=\"images/stories/demo/sam-7.jpg\" alt=\"Source: psdtuts.com\" align=\"left\" class=\"caption\" title=\"Sample image\" />\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien.</p>\r\n\r\n','\r\n\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n\r\n<p>Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing. Aliquam Curabitur molestie dolor leo augue dui sagittis id id mauris. Ut Curabitur pharetra elit sodales at Nam dictum auctor est augue. Nunc orci urna dolor mollis in velit tincidunt justo nibh venenatis. Pretium tempus arcu In Nullam Aenean Lorem felis sollicitudin tristique magnis. </p>\r\n\r\n<p>Eget nibh id magna nascetur semper Integer venenatis mauris Curabitur enim. Lorem massa Vestibulum Integer nibh Sed Aenean sed metus pretium amet. Curabitur sit Pellentesque neque Phasellus dolor sed cursus accumsan venenatis condimentum. Sed tellus consequat nulla Ut convallis at lacinia consectetuer a ante. Augue semper feugiat eget et et eros semper Praesent nulla ipsum. Amet porttitor Praesent Nulla et felis ante eget eleifend senectus elit. Wisi.</p>\r\n\r\n<p>Rutrum id dui Mauris tincidunt Quisque et tortor orci Sed augue. Faucibus id dapibus congue hendrerit orci tellus ac convallis habitasse tellus. Libero auctor elit et venenatis natoque molestie convallis quis ac Curabitur. Mauris pede Vestibulum ac risus eget turpis elit adipiscing dolor nibh. Morbi felis at id elit urna montes gravida nibh nibh quis. Tellus.</p>\r\n\r\n<p>Eget elit lacinia nunc consequat ullamcorper In massa nibh malesuada lorem. Nam mollis feugiat tincidunt at semper hendrerit sit porttitor pellentesque senectus. Augue Nulla scelerisque quis vitae in porta faucibus elit vitae Morbi. Curabitur nibh magna wisi Nam Ut sem turpis ac faucibus Vestibulum. Auctor malesuada Nam non tortor condimentum et magna In convallis.</p>',1,5,0,37,'2010-03-03 07:25:11',62,'','2010-03-22 17:56:09',62,0,'0000-00-00 00:00:00','2010-03-03 07:25:11','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',6,0,3,'','',0,9,'robots=\nauthor='),
(68,'Libero purus tortor vel Mauris et nec Pellentesque','libero-purus-tortor-vel-mauris-et-nec-pellentesque','','{jathumbnail off}\r\n<img src=\"images/stories/demo/sam-6.jpg\" alt=\"Source: psdtuts.com\" align=\"left\" class=\"caption\" title=\"Sample image\" />\r\n<p>Lorem ipsum dolor sit amet consectetuer mattis sociis Phasellus tellus ac. Lorem tristique pretium ornare facilisis Aenean lorem justo at Phasellus pede. Amet amet sed suscipit vel porta non dui tempus Aenean libero. Cursus Suspendisse orci egestas tincidunt vel auctor Nam facilisi id risus. Lorem nibh vitae iaculis nibh scelerisque Vivamus.</p>\r\n\r\n','\r\n\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Cursus mi vel ipsum ante tincidunt diam in id Aliquam tristique. Nam quis est massa tellus Nam Curabitur rutrum quis volutpat sed. Scelerisque et leo Pellentesque purus sit nibh cursus Nulla.</p>\r\n\r\n<ul class=\"star\">\r\n<li><span class=\"icon\">&nbsp;</span>Metus habitasse sed interdum Nulla Donec</li>\r\n<li><span class=\"icon\">&nbsp;</span>Justo ipsum dolor dui Donec.</li>\r\n<li><span class=\"icon\">&nbsp;</span>Non Donec aliquam at hac Curabitur</li>\r\n<li><span class=\"icon\">&nbsp;</span>Maecenas Sed sed euismod nibh.</li>\r\n</ul>\r\n\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n\r\n<p class=\"box-download\">Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus.</p>',1,5,0,37,'2010-03-09 07:25:32',62,'','2010-03-22 17:55:15',62,0,'0000-00-00 00:00:00','2010-03-09 07:25:32','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=1\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=Read the full story',16,0,2,'','',0,77,'robots=\nauthor='),
(70,'K2 Showcase','k2-showcase','','<p>K2 is a content component for Joomla! with CCK-like features developed by JoomlaWorks.</p>\r\n\r\n<p>It allows you to manage your content in a more fashionable manner. You can publish blog, catalog, directory and magazine using a single component. Its development was started in 2006 but up to now no documentation was published. There\'s a video tutorial but I wasn\'t able to watch it because of my slow connection.</p>\r\n\r\n<p>I wrote this tutorial for those who want to use and explore K2 but have no idea where to start.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 1.</span> Download the latest version of K2 from the <a href=\"http://extensions.joomla.org/extensions/news-production/content-construction/8061/reviews2?utm_source=feedburner&amp;utm_medium=feed&amp;utm_campaign=Feed%3A+JoomlaExtensionsUpdated+%28JED+-+Updated+Extensions%29\" target=\"_blank\">JED</a> or from <a href=\"http://k2.joomlaworks.gr/\" target=\"_blank\">JoomlaWorks</a>.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 2.</span> Install K2 using the Joomla EXTENSION MANAGER.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 3.</span> Open K2 dashboard from the COMPONENT MENU.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 4.</span> Create EXTRA FIELD GROUPS. Name your field groups Blog, Catalog, Directory or anything you want. Extra Field Groups are used as root for your categories.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 5.</span> Add EXTRA FIELDS for your extra field groups.</p>\r\n\r\n<p>Default: Title, Text and Image are the default fields. This could be readily used for your Articles, Blogs or News groups. Add extra field for Directories, Catalogs, and other extra field groups.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 6.</span> Add CATEGORIES. Associate extra field group for your categories. You can create categories for your Blog, Catalog or Directory. Configure your desired parameters.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 7.</span> Add USER GROUPS. Defaults are Registered and Site Owner. If you want certain user group to be able to add item at the frontend, select yes for FRONT-END ITEM EDITING, yes for ADD ITEMS, yes on how they edit an item: OWN or ALL, and yes for PUBLISH, if you want users to publish their own articles.</p>\r\n\r\n<p>DO NOT FORGET TO ASSIGN CATEGORIES for your user group. Options are all, none, and select from list.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 8.</span> Assign your existing users their own K2 USER GROUP. Set their gender, add description, and upload an image for their avatar. These details will appear as authors detail at the bottom of their articles if enabled in your category parameters.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 9.</span> Add tags.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 10.</span> Assign menus using the Menu Manager.</p>\r\n\r\n<h3>Options:</h3>\r\n\r\n<h3>Copy or form layout</h3>\r\n<ul>\r\n<li>Item  create a menu item directly to an item in K2</li>\r\n<li>Categories  displays a list of items from one or more categories.</li>\r\n<li>Tag  create a menu linking to a tag in K2</li>\r\n<li>User Page (blog)  create a menu item linking to a user page (blog layout)</li>\r\n</ul>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 11.</span> Publish K2 LOGIN module in module manager.</p>\r\n\r\n<p>You can also publish K2 COMMENTS and K2 CONTENTS if you want certain contents and comments appear in your module positions.</p>\r\n\r\n<p><span style=\"font-weight: bold;\">STEP 12.</span> Add an item for each category. If you followed Step 7, an ADD AN ITEM menu will appear in K2 login module. This allows certain users to add an item at the frontend.</p>\r\n\r\n<p>Frontend editing is a little off because the creator of K2 used a squeezebox instead of a standard form. The save and cancel button can\'t be seen (or hidden) if you are using desktops or laptops with small screen.</p>\r\n\r\n<p>There are other parameters that need to be configured. I\'ll leave that to you for experimenting and exploring capabilities of K2.</p>\r\n\r\n<p><strong>Author: </strong>Florante Bautista</p>','',1,0,0,0,'2010-03-17 02:06:48',62,'','2010-03-24 23:10:06',62,0,'0000-00-00 00:00:00','2010-03-17 02:06:48','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=',4,0,1,'','',0,32,'robots=\nauthor='),
(69,'Convallis Maecenas Nam quis Sed venenatis','convallis-maecenas-nam-quis-sed-venenatis','','{jathumbnail off}\r\n<img src=\"images/stories/demo/sam-5.jpg\" alt=\"Source: psdtuts.com\" align=\"left\" class=\"caption\" title=\"Sample image\" />\r\n\r\n<p>Libero purus tortor vel Mauris et nec Pellentesque ut volutpat nec. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. Sem porta non Phasellus scelerisque vitae dolor tortor tellus et libero. Non et rhoncus Nulla Suspendisse dui ultrices in vel egestas ipsum. <a href=\"#\" title=\"Sample link\">Sem porta non Phasellus scelerisque</a> vitae dolor tortor tellus et libero.</p>\r\n\r\n','\r\n\r\n<p>Metus habitasse sed interdum Nulla Donec justo ipsum dolor dui Donec. Non Donec aliquam at hac Curabitur Maecenas Sed sed euismod nibh. Ut Ut lacinia mollis ullamcorper dui sem in ligula Morbi faucibus. Interdum Vestibulum nibh augue metus urna Curabitur eu Morbi vel et. Quam vitae ac Lorem at ante dolor mus Donec Maecenas elit. Nunc leo consequat.</p>\r\n\r\n<p>Sed ornare adipiscing enim felis sed elit Lorem quis lacinia urna. Condimentum tincidunt nibh adipiscing et volutpat a Nulla at Nulla eleifend. Tincidunt et dui In condimentum platea accumsan Nam lobortis tempus dui. Condimentum nonummy Curabitur nunc non tincidunt orci consequat libero laoreet sapien. Nulla convallis ligula et ornare fames commodo Aliquam mauris ipsum in. Metus suscipit senectus condimentum Maecenas lacus pellentesque Vestibulum.</p>\r\n\r\n<p>Convallis Maecenas Nam quis Sed venenatis Nullam Curabitur Morbi montes natoque. Wisi pretium laoreet ante quis quis tincidunt ut Ut Integer wisi. Facilisi nibh sed consectetuer commodo orci feugiat eros Maecenas habitasse sagittis. Ullamcorper mus ac nisl Curabitur aliquam sed lacinia mattis Vestibulum scelerisque. In eu nonummy Duis Morbi fringilla auctor est tincidunt.</p>\r\n\r\n<p>Augue cursus sit purus id vel Vivamus at dapibus pretium ridiculus. Praesent justo lacus malesuada faucibus faucibus tempus Nulla amet lobortis Phasellus. Dui orci fringilla natoque Lorem laoreet dui tempus pede enim fringilla. Dictumst pretium a Aenean tempus elit Nam Ut ligula Ut Sed. Elit nulla nibh id lacinia Morbi malesuada a tortor senectus eget. Nibh.</p>\r\n\r\n<p class=\"download\">Mi pellentesque augue pellentesque accumsan est odio ut Aliquam nulla eget. Condimentum Maecenas mi tempus convallis ac tellus mattis condimentum facilisis adipiscing.</p>',1,5,0,37,'2010-03-05 07:27:53',62,'','2010-03-22 17:55:56',62,0,'0000-00-00 00:00:00','2010-03-05 07:27:53','0000-00-00 00:00:00','','','show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=Read the full story',13,0,1,'','',0,35,'robots=\nauthor=');


DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__content_frontpage` VALUES
(50,1);


DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__content_rating` VALUES
(68,5,1,'10.0.0.199');


DROP TABLE IF EXISTS `#__core_acl_aro`;
CREATE TABLE `#__core_acl_aro` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `section_value` varchar(240) NOT NULL DEFAULT '0',
  `value` varchar(240) NOT NULL DEFAULT '',
  `order_value` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `hidden` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `j27aa0_section_value_value_aro` (`section_value`(100),`value`(100)),
  KEY `j27aa0_gacl_hidden_aro` (`hidden`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
INSERT INTO `#__core_acl_aro` VALUES
(10,'users','62',0,'Administrator',0);


DROP TABLE IF EXISTS `#__core_acl_aro_groups`;
CREATE TABLE `#__core_acl_aro_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `value` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `j27aa0_gacl_parent_id_aro_groups` (`parent_id`),
  KEY `j27aa0_gacl_lft_rgt_aro_groups` (`lft`,`rgt`)
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;
INSERT INTO `#__core_acl_aro_groups` VALUES
(17,0,'ROOT',1,22,'ROOT'),
(28,17,'USERS',2,21,'USERS'),
(29,28,'Public Frontend',3,12,'Public Frontend'),
(18,29,'Registered',4,11,'Registered'),
(19,18,'Author',5,10,'Author'),
(20,19,'Editor',6,9,'Editor'),
(21,20,'Publisher',7,8,'Publisher'),
(30,28,'Public Backend',13,20,'Public Backend'),
(23,30,'Manager',14,19,'Manager'),
(24,23,'Administrator',15,18,'Administrator'),
(25,24,'Super Administrator',16,17,'Super Administrator');


DROP TABLE IF EXISTS `#__core_acl_aro_map`;
CREATE TABLE `#__core_acl_aro_map` (
  `acl_id` int(11) NOT NULL DEFAULT '0',
  `section_value` varchar(230) NOT NULL DEFAULT '0',
  `value` varchar(100) NOT NULL,
  PRIMARY KEY (`acl_id`,`section_value`,`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__core_acl_aro_sections`;
CREATE TABLE `#__core_acl_aro_sections` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` varchar(230) NOT NULL DEFAULT '',
  `order_value` int(11) NOT NULL DEFAULT '0',
  `name` varchar(230) NOT NULL DEFAULT '',
  `hidden` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `j27aa0_gacl_value_aro_sections` (`value`),
  KEY `j27aa0_gacl_hidden_aro_sections` (`hidden`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
INSERT INTO `#__core_acl_aro_sections` VALUES
(10,'users',1,'Users',0);


DROP TABLE IF EXISTS `#__core_acl_groups_aro_map`;
CREATE TABLE `#__core_acl_groups_aro_map` (
  `group_id` int(11) NOT NULL DEFAULT '0',
  `section_value` varchar(240) NOT NULL DEFAULT '',
  `aro_id` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `group_id_aro_id_groups_aro_map` (`group_id`,`section_value`,`aro_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__core_acl_groups_aro_map` VALUES
(25,'',10);


DROP TABLE IF EXISTS `#__core_log_items`;
CREATE TABLE `#__core_log_items` (
  `time_stamp` date NOT NULL DEFAULT '0000-00-00',
  `item_table` varchar(50) NOT NULL DEFAULT '',
  `item_id` int(11) unsigned NOT NULL DEFAULT '0',
  `hits` int(11) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(11) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__groups`;
CREATE TABLE `#__groups` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `name` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__groups` VALUES
(0,'Public'),
(1,'Registered'),
(2,'Special');


DROP TABLE IF EXISTS `#__jacomment_configs`;
CREATE TABLE `#__jacomment_configs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group` varchar(100) DEFAULT NULL,
  `data` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;
INSERT INTO `#__jacomment_configs` VALUES
(22,'general','display_message=\nis_notify_admin=1\nnotify_admin_email=nghiatd@joomsolutions.com\nis_notify_author=1\nis_enabled_email=1\nfromname=Nghia Tran Dinh\nfromemail=nghiatd@joomsolutions.com\nccemail=\naccess=0\nis_comment_offline=0\nmail_view_only=0\nis_use_ja_login_form=0\n\n'),
(23,'comments','is_enable_threads=1\nis_allow_voting=1\nis_attach_image=1\ntotal_attach_file=5\nmax_size_attach_file=2\nattach_file_type=doc,docx,pdf,txt,zip,rar,jpg,bmp,gif,png\nis_enable_website_field=1\nis_enable_autoexpanding=1\nis_extra_fields_expand=1\nis_enable_email_subscription=1\nis_allow_report=1\nis_allow_approve_new_comment=1\nmaximum_comment_in_item=100\nis_enable_rss=1\n\n'),
(24,'spamfilters','is_enable_captcha=1\nis_enable_terms=1\nterms_of_usage=Registration to this forum is free! We do insist that you abide by the rules and policies detailed below. If you agree to the terms, please check the \'I agree\' checkbox and press the \'Register\' button below. If you would like to cancel the registration, click here to return to the forums index.\\n\\nForum Rules\\n\\nRegistration to this forum is free! We do insist that you abide by the rules and policies detailed below. If you agree to the terms, please check the \'I agree\' checkbox and press the \'Register\' button below. If you would like to cancel the registration, click here to return to the forums index.\nmin_length=10\nmax_length=1000\ncensored_words=\ncensored_words_replace=\nis_nofollow=1\nnumber_of_links=5\nis_enable_captcha_user=0\nis_use_akismet=0\n\n'),
(25,'blocked_word_list',''),
(26,'blacklist_word_list','\nfuck'),
(27,'permissions','view=all\npost=all\nvote=all\ntype_voting=1\nreport=all\ntotal_to_report_spam=10\ntype_editing=1\n\n'),
(28,'layout','theme=ja-ores-dark\nenable_avatar=1\ntype_avatar=0\navatar_size=3\nform_position=2\nenable_sorting_options=1\ndefault_sort=date\ndefault_sort_type=ASC\nenable_timestamp=1\nfooter_text=Copyright JAComment\ncustom_css=\nenable_login_rpx=1\nenable_addthis=0\ncustom_addthis=<!-- AddThis Button BEGIN -->\\n<a class=\"addthis_button\" href=\"http://addthis.com/bookmark.php?v=250&pub=xa-4af3e1272f178ef0\"><img src=\"http://s7.addthis.com/static/btn/v2/lg-share-en.gif\" width=\"125\" height=\"16\" alt=\"Bookmark and Share\" style=\"border:0\"/></a><script type=\"text/javascript\" src=\"http://s7.addthis.com/js/250/addthis_widget.js#pub=xa-4af3e1272f178ef0\"></script>\\n<!-- AddThis Button END -->\ncustom_addtoany=<a class=\"a2a_dd\" href=\"http://www.addtoany.com/share_save\"><img src=\"http://static.addtoany.com/buttons/share_save_171_16.png\" width=\"171\" height=\"16\" border=\"0\" alt=\"Share/Bookmark\"/></a><script type=\"text/javascript\">a2a_linkname=document.title;a2a_linkurl=location.href;</script><script type=\"text/javascript\" src=\"http://static.addtoany.com/menu/page.js\"></script>\nenable_smileys=1\nsmiley=default\ncustom_tweetmeme=<script type=\"text/javascript\">\\ntweetmeme_url = \'http://127.0.0.1/jacomment/trunk\';\\n</script>\\n<script type=\"text/javascript\" src=\"http://tweetmeme.com/i/scripts/button.js\"></script>\nenable_bbcode=1\nuse_default_avatar=0\nenable_login_button=0\nenable_subscribe_menu=0\nenable_user_rep_indicator=0\nenable_comment_form=0\nenable_addtoany=0\nenable_after_the_deadline=1\nenable_polldaddy=0\nenable_seesmic=0\nenable_tweetmeme=1\nenable_youtube=1\nenable_activity_stream=0\ninclude_bbcode_script=1\n\n'),
(33,'blocked_ip_list','\n10.0.0.1\n41.0.0.25');


DROP TABLE IF EXISTS `#__jacomment_email_templates`;
CREATE TABLE `#__jacomment_email_templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `title` varchar(525) DEFAULT NULL,
  `subject` varchar(525) DEFAULT NULL,
  `content` text,
  `email_from_address` varchar(255) DEFAULT NULL,
  `email_from_name` varchar(255) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '0',
  `group` int(11) DEFAULT '0',
  `language` varchar(20) DEFAULT NULL,
  `system` tinyint(2) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=36 DEFAULT CHARSET=utf8;
INSERT INTO `#__jacomment_email_templates` VALUES
(10,'mailheader','Header','Header','','','',1,1,'en-GB',1),
(11,'mailfooter','Footer','Footer','<p style=\"margin: 15px 5px 2px 0pt; text-align: right; color: #aaaaaa\"> powered by <span style=\"font-family: arial; font-style: normal; font-variant: normal; font-weight: normal; font-size: 16px; line-height: normal; font-size-adjust: none; font-stretch: normal; letter-spacing: -1px\"><strong>JA<font color=\"#f47414\">Comment</font></strong></span> </p>','','',1,1,'en-GB',1),
(35,'Jacommentconfirmation_sent_to_new_comment_creator_need_admin_approved','Confirmation sent to new comment creator - In cases where admin approval is Required','Your comment is pending approval...','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that you have just created a new comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} with the following details: </p><p><strong>Comment URL</strong>: {ITEM_LINK} </p><p><strong>Comment details</strong>: {ITEM_DETAILS}.</p><p> Your comment shall be posted after being approved by administrator. Please check your mailbox periodically for updated information. </p><p>Sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(12,'Jacommentnotify_to_user_new_voice_daily','Dailly NEW Comment statistics (to those who subscribe)','[JA Comment] Daily statistics','<p>Hi {USERS_USERNAME},</p><p>Here are a quick overview of what has been going on at JA Comment during the last 24 hours: </p>{ITEM_DETAILS}','','',1,0,'en-GB',1),
(19,'Jacommentnotify_when_new_item_was_post','Notify when new item was post','Have a new comment!','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that a comment has been newly added into the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} with the following details: </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p>Please click on the link above to view the full details. </p><p>Sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(22,'Jacommentnotifying_admin_on_a_new_comment_posted','Notifying admin on a new comment posted','A new comment has been newly added','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform you that a new comment on {ITEM_TITLE_WITH_LINK} has newly been added at {CONFIG.SITE_TITLE} with the following details: </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Comment creator:</strong> {ITEM_CREATE_BY} </p><p>Please review the above comments and take appropriate actions as soon as possible. </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(34,'Jacommentconfirmation_sent_to_new_comment_creator_dont_need_admin_approved','Confirmation sent to new comment creator - In cases where admin approval is NOT required','We confirm your comment','<p>Dear {USERS_USERNAME}, </p><p>This email is to confirm that you have successfully created a new comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} with the following details: </p><p> <strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS}.</p><p>Please check your mailbox periodically as we shall notify you if there is any new reply on this issue.</p><p> Sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(24,'Jacommentnotifying_comment_creator_if_there_is_a_new_reply_to_his_comment','Notifying comment creator if there is a new reply to his comment','A new reply has just been posted on your comment','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that a new reply has just been posted on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} with the following details: </p><p><strong>Reply URL</strong>: {ITEM_LINK} </p><p><strong>Reply details</strong>: {ITEM_DETAILS} </p><p><strong>Reply creator:</strong> {REPLY_OWNER} . </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(25,'Jacommentnotifying_those_whose_comment_has_been_deleted','Notifying those whose comment has been deleted','Your comment has been deleted','<p>Dear {USERS_USERNAME}, </p><p>We are sorry to inform that your comment on the issue \"{ITEM_TITLE_WITH_LINK}? at {CONFIG.SITE_TITLE} has been deleted by {SITE_ADMIN} with the following reasons: </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Moderate reasons:</strong> {MOD_REASONS} </p><p>Thank you for your understanding and do hope you carefully read the instructions and strictly follow the Terms of Use before posting any comments at {CONFIG.SITE_TITLE} in the time to come. </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(26,'Jacommentnotifying_those_whose_comment_has_been_approved','Notifying those whose comment has been approved','Your Comment has been approved','<p>Dear {USERS_USERNAME}, </p><p> This email is to inform that your comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} has been approved and published by {SITE_ADMIN} with the following details: </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p>Please check your mailbox periodically as we shall notify you if there is any reply on this issue Yours. sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(27,'Jacommentnotifying_admin_of_a_spam_report_on_a_comment','Notifying admin of a spam report on a comment','A comment has been reported as spam','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that the comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} has been reported as spam recently. </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Spam reporter:</strong> {SPAM_REPORTER} </p><p>Kindly review the above comment to see if it is a spam as report or not for further action at your soonest time. </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(28,'Jacommentnotifying_those_whose_comment_is_reported_as_spam','Notifying those whose comment is reported as spam','You have comment reported as spam','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that your comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} has been reported as spam by other user recently. </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Spam reporter:</strong> {SPAM_REPORTER} </p><p>The spam report shall be thoroughly and fairly reviewed by {SITE_ADMIN} before any further action. Kindly continue using our site normally and sorry for any inconveniences that may have caused. </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(29,'Jacommentnotifying_those_whose_comment_is_removed_as_spam_by_admin','Notifying those whose comment is removed as spam by admin','Your comment has been removed as spam by administrator','<p>Dear {USERS_USERNAME},</p><p>This email is to inform that your comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} has been removed as spam by {SITE_ADMIN}. </p><p><strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Moderate Reasons:</strong> {MOD_REASONS} </p><p> Thank you for your understanding and do hope you carefully read the instructions and strictly follow the Terms of Use before posting any comments at {CONFIG.SITE_TITLE} in the time to come.</p><p> Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(30,'Jacommentnotifying_those_whose_comment_has_been_unapproved','Notifying those whose comment has been unapproved','You have a comment unapproved','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that your comment on the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} has been unapproved by {SITE_ADMIN} due to the following reasons:</p><p> <strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p><strong>Unapproved reasons:</strong> {UNAPPROVE_REASONS} </p><p>Thank you for your understanding and do hope you carefully read the instructions and strictly follow the Terms of Use before posting any comments at {CONFIG.SITE_TITLE} in the time to come. </p><p>Yours sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0),
(32,'Jacommentnotifying_comment_creator_if_there_is_a_new_comment_on_the_issue','Notifying comment creator if there is a new comment on the issue','A new comment has been added','<p>Dear {USERS_USERNAME}, </p><p>This email is to inform that a comment has been newly added into the issue {ITEM_TITLE_WITH_LINK} at {CONFIG.SITE_TITLE} with the following details:</p><p> <strong>Comment URL:</strong> {ITEM_LINK} </p><p><strong>Comment details:</strong> {ITEM_DETAILS} </p><p>Please click on the link above to view the full details. </p><p>Sincerely, {CONFIG.SITE_TITLE}</p>','','',1,0,'en-GB',0);


DROP TABLE IF EXISTS `#__jacomment_items`;
CREATE TABLE `#__jacomment_items` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `parentid` int(11) NOT NULL DEFAULT '0',
  `contentid` int(10) NOT NULL DEFAULT '0',
  `ip` varchar(15) NOT NULL DEFAULT '',
  `name` varchar(200) DEFAULT NULL,
  `contenttitle` varchar(200) NOT NULL DEFAULT '',
  `comment` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `locked` tinyint(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `email` varchar(100) NOT NULL DEFAULT '',
  `website` varchar(100) NOT NULL DEFAULT '',
  `star` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `usertype` mediumtext NOT NULL,
  `option` varchar(50) NOT NULL DEFAULT 'com_content',
  `voted` smallint(6) NOT NULL DEFAULT '0',
  `report` smallint(6) NOT NULL DEFAULT '0',
  `subscription_type` tinyint(4) NOT NULL DEFAULT '0',
  `referer` varchar(255) NOT NULL DEFAULT '',
  `source` varchar(20) NOT NULL,
  `type` tinyint(4) DEFAULT NULL,
  `date_active` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `option` (`option`),
  KEY `contentid` (`contentid`),
  KEY `published` (`published`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
INSERT INTO `#__jacomment_items` VALUES
(1,0,50,'127.0.0.1','Tester@','Marketing Solutions Company','Hi !\n\nThis is a Test  Just Try something to post \n\nIts cool:-)','2010-03-18 14:51:56',1,0,0,'ores_tester@joomsolutions.com','',0,69,'','com_content',2,1,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:1','',1,'2010-03-18 15:08:05'),
(2,0,50,'127.0.0.1','OresTest','Marketing Solutions Company','Hello,\n\nWhen I login I can see the comment I recorded and play it back. Not sure why theres a disconnect.\n\nThanks for your help.','2010-03-18 15:05:12',1,0,0,'ores_test@joomsolutions.com','',0,70,'','com_content',2,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:2','',1,'2010-03-19 15:29:46'),
(5,2,50,'127.0.0.1','Coder','Marketing Solutions Company','Hmm Ok I will check that ','2010-03-19 09:31:08',1,0,0,'coder@joomsolutions.com','',0,0,'','com_content',1,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:5','',0,'2010-03-19 15:30:11'),
(3,2,50,'127.0.0.1','Test_Test','Marketing Solutions Company','Also, I got the Disconnected message several times even though the internet looked stable for my other programs. Any ideas?','2010-03-18 15:13:56',1,0,0,'test_test@joomsolutions.com','http://www.joomlart.com',0,0,'','com_content',1,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:3','',1,'2010-03-19 15:29:48'),
(4,0,50,'127.0.0.1','Tester_07_2003','Marketing Solutions Company','This is a great idea! Im hoping to use it on my blogger site, but I cant seem to get my comments to show up.','2010-03-18 15:16:15',1,0,0,'abc@joomsolutions.com','',0,0,'','com_content',1,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:4','',1,'2010-03-19 15:29:22'),
(6,2,50,'127.0.0.1','Designer','Marketing Solutions Company','i will test it','2010-03-19 09:56:51',1,0,0,'designer@joomsolutions.com','',0,0,'','com_content',1,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:6','',1,'2010-03-19 15:29:49'),
(7,0,50,'127.0.0.1','User','Marketing Solutions Company','Thanks alot for your feedback everybody!','2010-03-19 10:08:48',1,0,0,'user@joomsolution.com','',0,0,'','com_content',1,0,0,'index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95#jacommentid:7','',1,'2010-03-19 11:23:55');


DROP TABLE IF EXISTS `#__jacomment_logs`;
CREATE TABLE `#__jacomment_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) DEFAULT NULL,
  `itemid` int(11) DEFAULT NULL,
  `votes` int(4) NOT NULL DEFAULT '0',
  `reports` int(4) NOT NULL DEFAULT '0',
  `time_expired` int(11) DEFAULT NULL,
  `remote_addr` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=437 DEFAULT CHARSET=utf8;
INSERT INTO `#__jacomment_logs` VALUES
(428,62,1,1,0,null,'10.0.0.106'),
(429,62,6,1,0,null,'10.0.0.106'),
(430,62,7,1,0,null,'10.0.0.106'),
(431,62,8,1,1,null,'10.0.0.199'),
(432,62,3,1,1,null,'10.0.0.199'),
(433,62,2,1,0,null,'10.0.0.199'),
(434,62,4,1,0,null,'10.0.0.199'),
(435,69,1,1,0,null,'127.0.0.1'),
(436,70,2,1,0,null,'127.0.0.1');


DROP TABLE IF EXISTS `#__jarpx_mapid`;
CREATE TABLE `#__jarpx_mapid` (
  `user_id` int(11) NOT NULL,
  `rpxid` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__k2_attachments`;
CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__k2_categories`;
CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_categories` VALUES
(1,'Men\'s','men','World of man clothing',0,0,1,0,1,'','inheritFrom=0\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,''),
(2,'Company News','company-news','',0,0,1,0,1,'','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=0\nnum_leading_columns=1\nleadingImgSize=Medium\nnum_primary_items=0\nnum_primary_columns=1\nprimaryImgSize=Medium\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Medium\nnum_links=0\nnum_links_columns=1\nlinksImgSize=Medium\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=0\nsubCatImage=0\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=1\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(3,'Our products','our-products','Elit lacinia Sed sagittis metus Lorem id tincidunt Proin adipiscing elit. Et tempus feugiat wisi gravida pede rhoncus tristique semper Sed eu. Nam tellus magna eros vel nibh laoreet vel Curabitur neque et. Vel Vestibulum Morbi feugiat vitae id sed magna at tellus senectus. Malesuada.',0,0,1,0,2,'','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=0\nnum_leading_columns=1\nleadingImgSize=Medium\nnum_primary_items=0\nnum_primary_columns=1\nprimaryImgSize=Medium\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Medium\nnum_links=0\nnum_links_columns=1\nlinksImgSize=Medium\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=order\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=4\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=50\nitemImageS=100\nitemImageM=170\nitemImageL=200\nitemImageXL=400\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=150\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(4,'Shoes','shoes','Pretium rutrum auctor ut Vivamus nibh ante elit In sagittis eleifend. Elit lacinia Sed sagittis metus Lorem id tincidunt Proin adipiscing elit...',3,2,1,0,2,'4.jpg','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=9\nnum_leading_columns=3\nleadingImgSize=Medium\nnum_primary_items=0\nnum_primary_columns=1\nprimaryImgSize=Medium\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Medium\nnum_links=0\nnum_links_columns=1\nlinksImgSize=none\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=3\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=0\nsubCatImage=1\nitemImageXS=50\nitemImageS=100\nitemImageM=170\nitemImageL=200\nitemImageXL=400\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=0\ncatItemDateCreated=0\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=0\ncatItemIntroTextWordLimit=200\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(6,'Suit','suit','Curabitur et vel interdum tincidunt urna at feugiat eu ut urna. Sagittis ipsum a Donec quam Sed vitae Cum sed sagittis accumsan...',3,1,1,0,3,'6.jpg','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=0\nnum_leading_columns=1\nleadingImgSize=Medium\nnum_primary_items=6\nnum_primary_columns=3\nprimaryImgSize=Medium\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=0\nnum_links_columns=1\nlinksImgSize=Medium\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=0\nsubCategories=1\nsubCatColumns=3\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=50\nitemImageS=100\nitemImageM=170\nitemImageL=200\nitemImageXL=330\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=0\ncatItemDateCreated=0\ncatItemRating=1\ncatItemImage=1\ncatItemIntroText=0\ncatItemIntroTextWordLimit=\ncatItemExtraFields=1\ncatItemHits=0\ncatItemCategory=0\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=0\ncatItemCommentsAnchor=0\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(5,'Watch','watch','Dui adipiscing at in Proin diam In id enim venenatis ut. Mi Proin mauris laoreet metus hac turpis sit Nullam ante lacinia...',3,4,1,0,1,'5.jpg','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=9\nnum_leading_columns=3\nleadingImgSize=Medium\nnum_primary_items=0\nnum_primary_columns=1\nprimaryImgSize=Large\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Medium\nnum_links=0\nnum_links_columns=1\nlinksImgSize=Medium\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=0\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=50\nitemImageS=100\nitemImageM=170\nitemImageL=200\nitemImageXL=400\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=0\ncatItemDateCreated=0\ncatItemRating=1\ncatItemImage=1\ncatItemIntroText=0\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=1\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(7,'Bag','bag','Lorem ipsum dolor sit amet consectetuer mollis pretium nunc dolor interdum. Lacinia Suspendisse est augue auctor orci massa...',3,5,1,0,4,'7.jpg','inheritFrom=0\ntheme=ja_ores\nnum_leading_items=0\nnum_leading_columns=1\nleadingImgSize=Medium\nnum_primary_items=6\nnum_primary_columns=3\nprimaryImgSize=Medium\nnum_secondary_items=0\nnum_secondary_columns=1\nsecondaryImgSize=Medium\nnum_links=0\nnum_links_columns=1\nlinksImgSize=Medium\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=0\ncatFeedLink=0\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=50\nitemImageS=100\nitemImageM=170\nitemImageL=200\nitemImageXL=330\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=0\ncatItemDateCreated=0\ncatItemRating=1\ncatItemImage=1\ncatItemIntroText=0\ncatItemIntroTextWordLimit=\ncatItemExtraFields=1\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=0\ncatItemCommentsAnchor=0\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Medium\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(8,'Trends + Shopping','trends-+-shopping','',2,0,1,0,1,'','inheritFrom=0\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(9,'People + Parties','people-+-parties','',2,0,1,0,2,'','inheritFrom=0\ntheme=\nnum_leading_items=1\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(10,'Style file blog','style-file-blog','Ornare et vestibulum habitant et ut orci pellentesque Nunc sodales netus. Curabitur justo quis sed vitae Curabitur quis morbi quam Fusce felis. Quisque ante feugiat pede sed condimentum tellus Sed Sed commodo Maecenas.',2,0,1,0,3,'','inheritFrom=0\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,''),
(11,'Community','community','Tristique condimentum vestibulum adipiscing vel pretium semper lorem Vestibulum orci malesuada. Sed sagittis urna Pellentesque mauris Curabitur augue sagittis ante Aenean laoreet.',2,0,1,0,4,'','inheritFrom=0\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',0,'');


DROP TABLE IF EXISTS `#__k2_comments`;
CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_comments` VALUES
(4,46,0,'Hung Dinh','2010-03-11 07:47:51','Thank you very much \n\nSolutions & Ideas','hungdv@joomsolutions.com','http://www.joomlart.com',1),
(2,13,64,'Nguyet Nguyen Do','2010-03-08 04:00:53','Wow it\'s Very cool ! i love it.\n\nThanks','nguyetnd@joomsolutions.com','',1),
(3,13,65,'Hieu Nguyen','2010-03-08 04:05:40','Vitae neque quam ut ante nec eros auctor pellentesque sapien Phasellus. Nibh tincidunt porttitor congue turpis Curabitur a mi Aenean condimentum id.','hieunn@joomsolutions.com','http://www.nnth.info',1),
(5,16,0,'Test','2010-03-23 15:08:51','be the first one! its very useful!','test@joomsolutions.com','http://www.joomlart.com',1);


DROP TABLE IF EXISTS `#__k2_extra_fields`;
CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_extra_fields` VALUES
(1,'Title','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',3,1,1),
(2,'Description','[{\"name\":null,\"value\":\"\",\"target\":null}]','textarea',3,1,2),
(3,'Content','[{\"name\":null,\"value\":\"\",\"target\":null}]','textarea',3,1,3),
(4,'Author','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',3,1,4),
(5,'Name','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',2,1,1),
(6,'Price','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',2,1,3),
(7,'Item code','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',2,1,2),
(8,'Color','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',2,1,4),
(9,'Descripton','[{\"name\":null,\"value\":\"\",\"target\":null}]','textarea',2,1,5),
(10,'Name','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,1),
(11,'Code','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,3),
(21,'Collection','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,2),
(13,'Price','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',1,1,4),
(22,'Name','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',5,1,1),
(15,'Name','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',4,1,1),
(16,'Brand','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',4,1,2),
(17,'Style','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',4,1,3),
(18,'Color','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',4,1,4),
(19,'Price','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',4,1,5),
(20,'Description','[{\"name\":null,\"value\":\"\",\"target\":null}]','textarea',4,1,6),
(23,'Price','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',5,1,2),
(24,'Color','[{\"name\":null,\"value\":\"\",\"target\":null}]','textfield',5,1,3);


DROP TABLE IF EXISTS `#__k2_extra_fields_groups`;
CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_extra_fields_groups` VALUES
(1,'Suit'),
(2,'Shoses'),
(3,'Article news'),
(4,'Watch'),
(5,'Bag');


DROP TABLE IF EXISTS `#__k2_items`;
CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` text NOT NULL,
  `fulltext` text NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=48 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_items` VALUES
(1,'Black suite','black-suite',1,1,'Ut nullam leo imperdiet arcu aliquam, a id massa anim molestie at, amet libero tellus, fames nam erat pretium mattis volutpat leo, aliquam nulla. Neque eget ipsum suspendisse massa, ut tempor elit In id','',null,null,'[]','','2010-03-03 09:38:26',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-03 09:38:26','0000-00-00 00:00:00',1,0,1,1,1,'','','','',25,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(2,'Allen Edmonds Men\'s Grenwich Oxford','allen-edmonds-mens-grenwich-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Allen Edmonds Men\'s Grenwich Oxford\"},{\"id\":\"7\",\"value\":\"OX0092\"},{\"id\":\"6\",\"value\":\"$146.90\"},{\"id\":\"8\",\"value\":\"Black | Brown\"},{\"id\":\"9\",\"value\":\"Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin.\"}]','Allen Edmonds Men\'s Grenwich Oxford OX0092 $146.90 Black | Brown Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin. ','2010-03-05 07:48:24',62,'',0,'0000-00-00 00:00:00','2010-03-05 08:22:08',62,'2010-03-05 07:48:24','0000-00-00 00:00:00',0,0,1,0,0,'','','','',9,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(3,'Allen Edmonds Men\'s Jackson Oxford','allen-edmonds-mens-jackson-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Allen Edmonds Men\'s Jackson Oxford\"},{\"id\":\"7\",\"value\":\"OX0981\"},{\"id\":\"6\",\"value\":\"$139.98 - $146.90\"},{\"id\":\"8\",\"value\":\"Brown | Black | Tan\"},{\"id\":\"9\",\"value\":\"Parturient mattis ac Aenean Nunc in elit est vel vitae lacinia. Suscipit tincidunt ac sit urna et laoreet et tincidunt vitae Aenean.\"}]','Allen Edmonds Men\'s Jackson Oxford OX0981 $139.98 - $146.90 Brown | Black | Tan Parturient mattis ac Aenean Nunc in elit est vel vitae lacinia. Suscipit tincidunt ac sit urna et laoreet et tincidunt vitae Aenean. ','2010-03-05 08:02:19',62,'',0,'0000-00-00 00:00:00','2010-03-05 08:30:06',62,'2010-03-05 08:02:19','0000-00-00 00:00:00',0,0,2,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(4,'Moreschi Men\'s Abano Oxford','moreschi-mens-abano-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Moreschi Men\'s Abano Oxford\"},{\"id\":\"7\",\"value\":\"OF09834\"},{\"id\":\"6\",\"value\":\"$535.95\"},{\"id\":\"8\",\"value\":\"Black | Burgundy\"},{\"id\":\"9\",\"value\":\"Magnis adipiscing sed Vivamus purus tincidunt eget justo facilisis parturient arcu. Dui id accumsan volutpat vitae Vestibulum Vestibulum ante leo euismod eu.\"}]','Moreschi Men\'s Abano Oxford OF09834 $535.95 Black | Burgundy Magnis adipiscing sed Vivamus purus tincidunt eget justo facilisis parturient arcu. Dui id accumsan volutpat vitae Vestibulum Vestibulum ante leo euismod eu. ','2010-03-05 08:31:27',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 08:31:27','0000-00-00 00:00:00',0,0,3,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(5,'Allen Edmonds Men\'s Delray Moc Toe Oxford','allen-edmonds-mens-delray-moc-toe-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Allen Edmonds Men\'s Delray Moc Toe Oxford\"},{\"id\":\"7\",\"value\":\"OF09845\"},{\"id\":\"6\",\"value\":\"$149.99 - $327.00\"},{\"id\":\"8\",\"value\":\"Black | Brown | Chili\"},{\"id\":\"9\",\"value\":\"\"}]','Allen Edmonds Men\'s Delray Moc Toe Oxford OF09845 $149.99 - $327.00 Black | Brown | Chili  ','2010-03-05 08:34:21',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 08:34:21','0000-00-00 00:00:00',0,0,4,0,0,'','','','',2,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(6,'Esquivel Men\'s W.K. Dress Shoe','esquivel-mens-wk-dress-shoe',4,1,'<p>Vestibulum vel ligula Vestibulum nec Nunc platea magnis tellus Sed a. Ac risus at Nunc Phasellus Lorem sed id tincidunt auctor vitae. Semper et ante amet sit Maecenas a ipsum est wisi malesuada. Ut dui ac id Nunc nec interdum at velit consequat massa. Nullam faucibus rutrum fames tortor odio faucibus tincidunt tincidunt et habitant. Vivamus non Vestibulum sit netus sem mollis at fermentum Aenean Nam. </p>\r\n\r\n<p>Ipsum vel Phasellus tincidunt id facilisi lacinia congue risus Nunc consectetuer. Metus Nullam consequat quis sagittis id dui aliquam interdum risus ipsum. Augue Quisque sem dis tempus interdum at elit libero a nibh. Odio eu malesuada sed tellus et Curabitur id in Proin Nulla. Interdum augue et nibh Maecenas ante diam eget natoque Suspendisse nulla. </p>','',null,null,'[{\"id\":\"5\",\"value\":\"Esquivel Men\'s W.K. Dress Shoe\"},{\"id\":\"7\",\"value\":\"OF09856\"},{\"id\":\"6\",\"value\":\"$888.90\"},{\"id\":\"8\",\"value\":\"Borwn\"},{\"id\":\"9\",\"value\":\"Morbi ornare platea turpis faucibus aliquam a quam fermentum est auctor. Odio nibh nibh pede Ut semper malesuada iaculis est Nam suscipit. Maecenas eu Pellentesque Phasellus pretium et tincidunt consectetuer velit sodales eget. Eros lorem et fringilla massa id convallis risus purus justo at.\"}]','Esquivel Men\'s W.K. Dress Shoe OF09856 $888.90 Borwn Morbi ornare platea turpis faucibus aliquam a quam fermentum est auctor. Odio nibh nibh pede Ut semper malesuada iaculis est Nam suscipit. Maecenas eu Pellentesque Phasellus pretium et tincidunt consectetuer velit sodales eget. Eros lorem et fringilla massa id convallis risus purus justo at. ','2010-03-05 08:36:05',62,'',0,'0000-00-00 00:00:00','2010-03-13 07:39:20',62,'2010-03-05 08:36:05','0000-00-00 00:00:00',0,0,5,1,0,'','','','',11,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(7,'Donald J Pliner Men\'s Primo Lace-Up','donald-j-pliner-mens-primo-lace-up',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Donald J Pliner Men\'s Primo Lace-Up\"},{\"id\":\"7\",\"value\":\"OF09823\"},{\"id\":\"6\",\"value\":\"$199.99\"},{\"id\":\"8\",\"value\":\"Brown\"},{\"id\":\"9\",\"value\":\"Nunc Aenean tristique et nunc interdum Curabitur sagittis Vestibulum lorem vestibulum. Nec Curabitur urna tempor lacinia dapibus justo massa nulla In elit. Lacus.\"}]','Donald J Pliner Men\'s Primo Lace-Up OF09823 $199.99 Brown Nunc Aenean tristique et nunc interdum Curabitur sagittis Vestibulum lorem vestibulum. Nec Curabitur urna tempor lacinia dapibus justo massa nulla In elit. Lacus. ','2010-03-05 08:42:26',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 08:42:26','0000-00-00 00:00:00',0,0,6,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(8,'Mezlan Men\'s Tyson Oxford','mezlan-mens-tyson-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Mezlan Men\'s Tyson Oxford\"},{\"id\":\"7\",\"value\":\"OF09821\"},{\"id\":\"6\",\"value\":\"$215.00 - $258.28\"},{\"id\":\"8\",\"value\":\"Black | Burgundy\"},{\"id\":\"9\",\"value\":\"Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin.\"}]','Mezlan Men\'s Tyson Oxford OF09821 $215.00 - $258.28 Black | Burgundy Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin. ','2010-03-05 09:08:05',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 09:08:05','0000-00-00 00:00:00',0,0,7,0,0,'','','','',2,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(9,'Mezlan Men\'s Agostino Oxford','mezlan-mens-agostino-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Mezlan Men\'s Agostino Oxford\"},{\"id\":\"7\",\"value\":\"OF09834\"},{\"id\":\"6\",\"value\":\"$179.99 - $324.95\"},{\"id\":\"8\",\"value\":\"Brown | Black\"},{\"id\":\"9\",\"value\":\"Magnis adipiscing sed Vivamus purus tincidunt eget justo facilisis parturient arcu. Dui id accumsan volutpat vitae Vestibulum Vestibulum ante leo euismod eu. Semper hendrerit tincidunt consequat Aenean penatibus ut sed aliquam Praesent nibh. Pulvinar eleifend nunc ut amet Cum montes amet tortor nec urna.\"}]','Mezlan Men\'s Agostino Oxford OF09834 $179.99 - $324.95 Brown | Black Magnis adipiscing sed Vivamus purus tincidunt eget justo facilisis parturient arcu. Dui id accumsan volutpat vitae Vestibulum Vestibulum ante leo euismod eu. Semper hendrerit tincidunt consequat Aenean penatibus ut sed aliquam Praesent nibh. Pulvinar eleifend nunc ut amet Cum montes amet tortor nec urna. ','2010-03-05 09:10:03',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 09:10:03','0000-00-00 00:00:00',0,0,8,0,0,'','','','',21,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(10,'Mezlan Men\'s Santana Oxford','mezlan-mens-santana-oxford',4,1,'','',null,null,'[{\"id\":\"5\",\"value\":\"Mezlan Men\'s Santana Oxford\"},{\"id\":\"7\",\"value\":\"OF09765\"},{\"id\":\"6\",\"value\":\"$169.99\"},{\"id\":\"8\",\"value\":\"Tan\"},{\"id\":\"9\",\"value\":\"Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin.\"}]','Mezlan Men\'s Santana Oxford OF09765 $169.99 Tan Orci arcu malesuada tincidunt Fusce quis turpis egestas sagittis consequat pede. Magna justo felis purus pellentesque nibh tincidunt orci vel quis sollicitudin. ','2010-03-05 09:12:20',62,'',0,'0000-00-00 00:00:00','2010-03-17 02:28:34',68,'2010-03-05 09:12:20','0000-00-00 00:00:00',0,0,9,0,0,'','','','',48,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(11,'Men\'s Invicta Sapphire Automatic Diver 7046','mens-invicta-sapphire-automatic-diver-7046',5,1,'','',null,null,'[{\"id\":\"15\",\"value\":\"Men\'s Invicta Sapphire Automatic Diver 7046\"},{\"id\":\"16\",\"value\":\"Invicta\"},{\"id\":\"17\",\"value\":\" Invicta Sapphire Automatic Diver 7046 \"},{\"id\":\"18\",\"value\":\"Blue\\/TT Stainless Steel  \"},{\"id\":\"19\",\"value\":\"$209.00 \"},{\"id\":\"20\",\"value\":\"This sleek watch features automatic twenty-one jewel movement, 18kt yellow gold plating, a solid steel case, unidirectional turning bezel, screw down stainless steel exhibition case back, screw down crown, anti-reflective sapphire crystal, Tritnite\\u00ae hands and markers, and day and date display. It is shock resistant and has a solid stainless steel band with diver buckle and safety clasp. This watch is water resistant to two hundred meters. \"}]','Men\'s Invicta Sapphire Automatic Diver 7046 Invicta  Invicta Sapphire Automatic Diver 7046  Blue/TT Stainless Steel   $209.00  This sleek watch features automatic twenty-one jewel movement, 18kt yellow gold plating, a solid steel case, unidirectional turning bezel, screw down stainless steel exhibition case back, screw down crown, anti-reflective sapphire crystal, Tritnite hands and markers, and day and date display. It is shock resistant and has a solid stainless steel band with diver buckle and safety clasp. This watch is water resistant to two hundred meters.  ','2010-03-05 10:05:55',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 10:05:55','0000-00-00 00:00:00',0,0,1,0,0,'','','','',59,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(12,'Men\'s Dakota Watches Mini Clip Microlight','mens-dakota-watches-mini-clip-microlight',5,1,'','',null,null,'[{\"id\":\"15\",\"value\":\"Men\'s Dakota Watches Mini Clip Microlight\"},{\"id\":\"16\",\"value\":\"Dakota Watches  \"},{\"id\":\"17\",\"value\":\" Dakota Watches Mini Clip Microlight   \"},{\"id\":\"18\",\"value\":\"Orange\\/Cream  \"},{\"id\":\"19\",\"value\":\"$39.95 \"},{\"id\":\"20\",\"value\":\"Powerful LED microlight, 100 feet water resistant, Integrated carabiner clip. Miyota movement, Luminescent hands and hour markers.\\r\\n\"}]','Men\'s Dakota Watches Mini Clip Microlight Dakota Watches    Dakota Watches Mini Clip Microlight    Orange/Cream   $39.95  Powerful LED microlight, 100 feet water resistant, Integrated carabiner clip. Miyota movement, Luminescent hands and hour markers.\r\n ','2010-03-05 10:07:34',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-05 10:07:34','0000-00-00 00:00:00',0,0,2,0,0,'','','','',46,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(13,'Military Sealander Chronograph','military-sealander-chronograph',5,1,'','',null,null,'[{\"id\":\"15\",\"value\":\"Men\'s Swiss Military Sealander Chronograph\"},{\"id\":\"16\",\"value\":\"Swiss Military  \"},{\"id\":\"17\",\"value\":\" Swiss Military Sealander Chronograph   \"},{\"id\":\"18\",\"value\":\"Green\\/Rubber  \"},{\"id\":\"19\",\"value\":\"$269.95 \"},{\"id\":\"20\",\"value\":\"It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter. \"}]','Men\'s Swiss Military Sealander Chronograph Swiss Military    Swiss Military Sealander Chronograph    Green/Rubber   $269.95  It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter.  ','2010-03-05 10:11:30',62,'',0,'0000-00-00 00:00:00','2010-03-06 04:52:39',62,'2010-03-05 10:11:30','0000-00-00 00:00:00',0,0,3,0,0,'','','','',59,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(14,'Swiss Military Sealander','swiss-military-sealander',5,1,'<p>Euismod quis dolor gravida Nunc sodales Donec porta justo id felis. Dui id est nunc suscipit auctor et in Aenean Vivamus In. Consectetuer pede commodo pede mi iaculis eget Nulla velit id In. Id turpis consectetuer dis elit et dapibus vitae interdum consectetuer metus. Morbi at risus Donec mauris eget adipiscing adipiscing ut leo ut. Feugiat accumsan Vestibulum.</p>\r\n\r\n<p>Massa malesuada euismod Aenean Nam habitasse sit fermentum pretium nibh Mauris. Justo turpis sed metus faucibus vestibulum auctor eleifend egestas id vitae. Tellus volutpat eget Nam turpis nec lorem nulla Vestibulum urna eros. Id Quisque Curabitur accumsan orci urna convallis purus sed senectus malesuada. Facilisis vitae Proin scelerisque elit cursus et Nullam Vestibulum at dignissim. Commodo justo.</p>','',null,null,'[{\"id\":\"15\",\"value\":\"Swiss Military Sealander Chronograph \"},{\"id\":\"16\",\"value\":\"Swiss Military  \"},{\"id\":\"17\",\"value\":\" Swiss Military Sealander Chronograph   \"},{\"id\":\"18\",\"value\":\"Brown\\/Rubber  \"},{\"id\":\"19\",\"value\":\"$269.95 \"},{\"id\":\"20\",\"value\":\"It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter. \"}]','Swiss Military Sealander Chronograph  Swiss Military    Swiss Military Sealander Chronograph    Brown/Rubber   $269.95  It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter.  ','2010-03-05 10:21:33',62,'',0,'0000-00-00 00:00:00','2010-03-13 07:10:44',62,'2010-03-05 10:21:33','0000-00-00 00:00:00',0,0,4,1,0,'','','','',30,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(15,'Swiss Military Sealander Rubber  ','swiss-military-sealander-rubber',5,1,'','',null,null,'[{\"id\":\"15\",\"value\":\"Swiss Military Sealander Rubber  \"},{\"id\":\"16\",\"value\":\"Swiss Military  \"},{\"id\":\"17\",\"value\":\" Swiss Military Sealander Rubber   \"},{\"id\":\"18\",\"value\":\"Orange\\/Rubber  \"},{\"id\":\"19\",\"value\":\"Sale $173.95 \"},{\"id\":\"20\",\"value\":\"It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter. \"}]','Swiss Military Sealander Rubber   Swiss Military    Swiss Military Sealander Rubber    Orange/Rubber   Sale $173.95  It has all stainless steel,44MM,screw back and solid stainless steel or rubber. It has luminous index on dial and luminous hands for easy night reading. It has screw down crown and unidirectional revolving.It is water resistant for 200M. It functions tachymeter,small second ,accumulated timing,intermediate timing,date,centre stop second,12 hour counter,30 minute counter.  ','2010-03-05 10:23:54',62,'',0,'0000-00-00 00:00:00','2010-03-17 02:27:50',68,'2010-03-05 10:23:54','0000-00-00 00:00:00',0,0,5,0,0,'','','','',55,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(16,'Swiss Military Cervin Watch','swiss-military-cervin-watch',5,1,'<p>Lorem ipsum dolor sit amet consectetuer felis tempor commodo quam et. Vestibulum dui vitae Ut fermentum velit consectetuer nibh eu pretium nibh. Enim parturient faucibus eget Praesent gravida tincidunt ut enim accumsan habitant. Eros in sed consequat arcu mattis faucibus Cum Praesent Proin Quisque. Et hac enim Nulla porttitor Aliquam.</p>','',null,null,'[{\"id\":\"15\",\"value\":\"Swiss Military Cervin  \"},{\"id\":\"16\",\"value\":\"Swiss Military  \"},{\"id\":\"17\",\"value\":\"   Swiss Military Cervin   \"},{\"id\":\"18\",\"value\":\"Brown\\/Leather  \"},{\"id\":\"19\",\"value\":\"$288.95\"},{\"id\":\"20\",\"value\":\"It has all stainless steel, 42MM, screw back and genuine leather. It has scratch resistant sapphire. It has luminous hands and dots on dial for easy night reading. It is water resistant for 100M. It has Swiss precision quartz movement. It functions tachometer, small second, accumulated timing, intermediate timing, date, center stop second, 12 hour counter, 30 minute counter.     \"}]','Swiss Military Cervin   Swiss Military      Swiss Military Cervin    Brown/Leather   $288.95 It has all stainless steel, 42MM, screw back and genuine leather. It has scratch resistant sapphire. It has luminous hands and dots on dial for easy night reading. It is water resistant for 100M. It has Swiss precision quartz movement. It functions tachometer, small second, accumulated timing, intermediate timing, date, center stop second, 12 hour counter, 30 minute counter.      ','2010-03-05 10:26:45',62,'',62,'2010-03-22 17:37:10','2010-03-22 17:37:10',62,'2010-03-05 10:26:45','0000-00-00 00:00:00',0,0,6,0,0,'','','','',33,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(17,'Pinstripe Suit','pinstripe-suit',6,1,'Vitae neque quam ut ante nec eros auctor pellentesque sapien Phasellus. Nibh tincidunt porttitor congue turpis Curabitur a mi Aenean condimentum id. Justo Maecenas leo morbi auctor Nulla tristique ut Curabitur montes mollis.','',null,null,'[{\"id\":\"10\",\"value\":\"Pinstripe Suit\"},{\"id\":\"21\",\"value\":\"Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0LYC\"},{\"id\":\"13\",\"value\":\"$995.00\"}]','Pinstripe Suit Versace Collection NMS10_N0LYC $995.00 ','2010-03-08 07:56:32',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 07:56:32','0000-00-00 00:00:00',0,0,1,0,0,'','','','',3,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(18,'Pinstripe Suit','pinstripe-suit',6,1,'Aliquam tincidunt convallis condimentum non id Maecenas aliquam lacinia nulla netus. Leo ullamcorper consequat Nullam et Curabitur accumsan est elit faucibus malesuada. Lacus consequat tempor Aliquam tellus sit volutpat convallis Curabitur gravida libero. Enim dui tempus libero.','',null,null,'[{\"id\":\"10\",\"value\":\"Pinstripe Suit\"},{\"id\":\"21\",\"value\":\"Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0LYE\"},{\"id\":\"13\",\"value\":\"$995.00\"}]','Pinstripe Suit Versace Collection NMS10_N0LYE $995.00 ','2010-03-08 08:12:29',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 08:12:29','0000-00-00 00:00:00',0,0,2,0,0,'','','','',4,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(19,'Striped Shirt','striped-shirt',6,1,'Vitae neque quam ut ante nec eros auctor pellentesque sapien Phasellus. Nibh tincidunt porttitor congue turpis Curabitur a mi Aenean condimentum id. Justo Maecenas leo morbi auctor Nulla tristique ut Curabitur montes mollis. Congue Vivamus nibh vel mauris Nam adipiscing consequat turpis accumsan Curabitur. Metus dictum sed orci Quisque pulvinar commodo nec adipiscing Quisque adipiscing.','',null,null,'[{\"id\":\"10\",\"value\":\"Striped Shirt\"},{\"id\":\"21\",\"value\":\" \\t Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0K8U\"},{\"id\":\"13\",\"value\":\"$275.00\"}]','Striped Shirt  	 Versace Collection NMS10_N0K8U $275.00 ','2010-03-08 08:13:36',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 08:13:36','0000-00-00 00:00:00',0,0,3,0,0,'','','','',3,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(20,'Notched-Collar Suit','notched-collar-suit',6,1,'Mauris velit urna ac tincidunt congue diam mauris sodales amet Aenean. Vitae Suspendisse ornare libero pretium ante Aliquam laoreet elit lorem dolor. Aliquam tincidunt convallis condimentum non id Maecenas aliquam lacinia nulla netus.','',null,null,'[{\"id\":\"10\",\"value\":\"Notched-Collar Suit\"},{\"id\":\"21\",\"value\":\"Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0J9N\"},{\"id\":\"13\",\"value\":\"$995.00\"}]','Notched-Collar Suit Versace Collection NMS10_N0J9N $995.00 ','2010-03-08 08:20:37',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 08:20:37','0000-00-00 00:00:00',0,0,4,0,0,'','','','',2,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(21,'Pinstripe Suit','pinstripe-suit',6,1,'Brown/cream. Includes peak-collar blazer with flap pockets and straight-leg pants with seam pockets. Wool. Imported.','',null,null,'[{\"id\":\"10\",\"value\":\"Pinstripe Suit\"},{\"id\":\"21\",\"value\":\"Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0CHQ\"},{\"id\":\"13\",\"value\":\"$995.00\"}]','Pinstripe Suit Versace Collection NMS10_N0CHQ $995.00 ','2010-03-08 08:21:45',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 08:21:45','0000-00-00 00:00:00',0,0,5,0,0,'','','','',32,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(22,'Basic Stretch Suit','basic-stretch-suit',6,1,'Black. Includes peaked-collar jacket with flap pockets and straight-leg pants. Stretch wool. Imported.','',null,null,'[{\"id\":\"10\",\"value\":\"Basic Stretch Suit\"},{\"id\":\"21\",\"value\":\"Versace Collection\"},{\"id\":\"11\",\"value\":\"NMS10_N0CHN\"},{\"id\":\"13\",\"value\":\"$845.00\"}]','Basic Stretch Suit Versace Collection NMS10_N0CHN $845.00 ','2010-03-08 08:23:18',62,'',0,'0000-00-00 00:00:00','2010-03-17 02:29:07',68,'2010-03-08 08:23:18','0000-00-00 00:00:00',0,0,6,1,1,'','','','',6,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(23,'Sadie Hobo','sadie-hobo',7,1,'Convallis ac ligula Phasellus et pretium Suspendisse sem ut ligula congue. Iaculis at eleifend tristique hendrerit nec velit lacus sed consequat consectetuer. Mus nibh quis nunc turpis convallis id laoreet Nulla enim lorem. Lorem tempor Cum venenatis fringilla ullamcorper ligula Phasellus ut at leo.','',null,null,'[{\"id\":\"22\",\"value\":\"Sadie Hobo\"},{\"id\":\"23\",\"value\":\"$85.00\"},{\"id\":\"24\",\"value\":\"Black | White | Green\"}]','Sadie Hobo $85.00 Black | White | Green ','2010-03-08 08:46:22',62,'',0,'0000-00-00 00:00:00','2010-03-13 07:59:40',62,'2010-03-08 08:46:22','0000-00-00 00:00:00',0,0,1,0,0,'','','','',3,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(24,'Hampton Hobo','hampton-hobo',7,1,'Mauris velit urna ac tincidunt congue diam mauris sodales amet Aenean. Vitae Suspendisse ornare libero pretium ante Aliquam laoreet elit lorem dolor. Aliquam tincidunt convallis condimentum non id Maecenas aliquam lacinia nulla netus. Leo ullamcorper consequat Nullam et Curabitur accumsan est elit faucibus malesuada.','',null,null,'[{\"id\":\"22\",\"value\":\"Hampton Hobo\"},{\"id\":\"23\",\"value\":\"Hampton Hobo\"},{\"id\":\"24\",\"value\":\"Red | White | Black\"}]','Hampton Hobo Hampton Hobo Red | White | Black ','2010-03-08 09:55:02',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 09:55:02','0000-00-00 00:00:00',0,0,2,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(25,'Pretium non netus odio porttitor','pretium-non-netus-odio-porttitor',8,1,'<p>Lorem ipsum dolor sit amet consectetuer facilisis velit Lorem accumsan Lorem. Vestibulum Nulla felis felis nibh sagittis pharetra Phasellus quis Phasellus lorem. Dui eget justo elit at mauris porttitor magnis semper Donec eu. At Quisque tempor Curabitur magnis orci pede orci wisi a congue. Tellus vitae tortor et dignissim id vitae auctor leo nunc dui. </p>\r\n\r\n','\r\n\r\n<p>Pretium non netus odio porttitor interdum nunc Aliquam laoreet lacinia ut. Vestibulum est id Donec elit id Ut Lorem ac enim amet. Amet nec justo consequat pretium pretium condimentum scelerisque Lorem neque et. Urna ut ipsum ipsum eu Nullam libero tincidunt leo Sed facilisis. Semper eleifend sociis tempus nibh ipsum semper Vestibulum id orci.</p>\r\n\r\n<p>Pellentesque enim pellentesque Nullam eget id iaculis laoreet Curabitur rutrum Lorem. Id vitae hendrerit Fusce Curabitur tristique sit urna feugiat Nulla euismod. Adipiscing lacinia Nullam rhoncus accumsan neque In pede tincidunt pellentesque et. Nibh enim pellentesque laoreet volutpat tempus est lobortis ipsum pellentesque convallis. Elit Vestibulum a Vestibulum tincidunt elit dignissim congue eros tincidunt dapibus. Pede velit nibh eu nibh laoreet dui et mauris sem vitae. </p>\r\n\r\n<p>Condimentum wisi fringilla elit ipsum condimentum dui pretium urna tellus quis. Vestibulum dapibus eu pretium ornare rutrum Vivamus quis at tellus Morbi. Enim eget vel facilisi elit est dui tempor augue tellus mattis. Nunc Curabitur orci nec ac penatibus orci elit egestas ligula enim. Libero nascetur pede Nam dui est gravida Vestibulum ut interdum Morbi. Et interdum elit Sed est Vestibulum eget est Fusce.</p>\r\n\r\n<p>Sollicitudin congue risus tellus ut vel gravida molestie Morbi vel Curabitur. Ante feugiat convallis dapibus justo Mauris in felis dui et orci. Orci accumsan augue ac tristique mus faucibus tellus ac Donec Suspendisse. Risus metus felis fringilla Suspendisse id vel arcu laoreet fermentum neque. Phasellus Nam suscipit mauris hendrerit Donec Sed nunc rhoncus mi hendrerit. </p>\r\n\r\n<p>Gravida dui hac et metus amet consequat eget sapien mollis vitae. Elit ut fringilla Morbi turpis rutrum sociis Lorem mauris ut id. Vivamus in et amet amet cursus Nulla mi nibh Nam dolor. Eu Phasellus laoreet Curabitur risus lobortis sem feugiat pede pretium mauris. Consequat quam nisl auctor sem hac vitae mauris vitae nunc iaculis. Magna pede pede.</p>\r\n\r\n<p>Lorem ac et Curabitur ut commodo sagittis mauris lacinia interdum nisl. Quis eget felis semper urna convallis diam lacinia pede sapien ligula. Pretium natoque orci metus cursus natoque mauris malesuada ac Nunc Nulla. Felis adipiscing orci natoque convallis penatibus molestie at enim Donec vitae. Vel dignissim metus vel Sed wisi fringilla Vestibulum Vivamus dictumst id. Vitae tempor venenatis dui condimentum nibh Nulla justo Curabitur Sed convallis. Lobortis sapien.</p>',null,null,'[]','','2010-03-08 10:05:06',62,'',0,'0000-00-00 00:00:00','2010-03-08 10:08:48',62,'2010-03-08 10:05:06','0000-00-00 00:00:00',0,0,1,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(26,'Sollicitudin congue risus tellus ut vel gravida','sollicitudin-congue-risus-tellus-ut-vel-gravida',9,1,'<p>Condimentum wisi fringilla elit ipsum condimentum dui pretium urna tellus quis. Vestibulum dapibus eu pretium ornare rutrum Vivamus quis at tellus Morbi. Enim eget vel facilisi elit est dui tempor augue tellus mattis. Nunc Curabitur orci nec ac penatibus orci elit egestas ligula enim. Libero nascetur pede Nam dui est gravida Vestibulum ut interdum Morbi. Et interdum elit Sed est Vestibulum eget est Fusce.</p>\r\n\r\n','\r\n\r\n<p>Sollicitudin congue risus tellus ut vel gravida molestie Morbi vel Curabitur. Ante feugiat convallis dapibus justo Mauris in felis dui et orci. Orci accumsan augue ac tristique mus faucibus tellus ac Donec Suspendisse. Risus metus felis fringilla Suspendisse id vel arcu laoreet fermentum neque. Phasellus Nam suscipit mauris hendrerit Donec Sed nunc rhoncus mi hendrerit. </p>\r\n\r\n<p>Gravida dui hac et metus amet consequat eget sapien mollis vitae. Elit ut fringilla Morbi turpis rutrum sociis Lorem mauris ut id. Vivamus in et amet amet cursus Nulla mi nibh Nam dolor. Eu Phasellus laoreet Curabitur risus lobortis sem feugiat pede pretium mauris. Consequat quam nisl auctor sem hac vitae mauris vitae nunc iaculis. Magna pede pede.</p>\r\n\r\n<p>Lorem ac et Curabitur ut commodo sagittis mauris lacinia interdum nisl. Quis eget felis semper urna convallis diam lacinia pede sapien ligula. Pretium natoque orci metus cursus natoque mauris malesuada ac Nunc Nulla. Felis adipiscing orci natoque convallis penatibus molestie at enim Donec vitae. Vel dignissim metus vel Sed wisi fringilla Vestibulum Vivamus dictumst id. Vitae tempor venenatis dui condimentum nibh Nulla justo Curabitur Sed convallis. Lobortis sapien.</p>\r\n\r\n<p>Fusce Cras a ligula vitae id et et malesuada tincidunt scelerisque. Tempus facilisi pede ante Nunc vitae vitae amet et dolor elit. Consectetuer et urna Vivamus parturient Curabitur nibh nec nascetur Morbi molestie. Nunc tortor volutpat eget fringilla amet Vestibulum Quisque eu lobortis Vivamus. Dignissim Curabitur dui nec Nullam Phasellus.</p>\r\n\r\n<p>Lacus dictumst congue in sem elit mus mi lacinia quis semper. Dui nibh tincidunt ante nibh eleifend et sit eget Sed tempor. Et Donec felis sodales mattis Cum ipsum sem Curabitur molestie dolor. Euismod adipiscing pharetra porttitor Proin leo tellus adipiscing nibh dolor cursus. Ut nisl ut vitae massa justo quis Curabitur augue non nulla. Amet a eu Curabitur dui velit cursus et et Nulla laoreet. Semper.</p>\r\n\r\n<p>Orci ligula vitae neque tortor velit Curabitur nulla euismod sagittis elit. Tortor Nam Ut wisi Pellentesque In et mauris sit pretium accumsan. Ac semper justo convallis consequat ligula semper tellus nibh congue netus. In vel sem justo dolor sagittis cursus leo augue malesuada ut. Sed nunc convallis ac Curabitur et interdum morbi semper vel consequat. Elit tincidunt pellentesque In tortor.</p>',null,null,'[]','','2010-03-08 10:09:14',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 10:09:14','0000-00-00 00:00:00',0,0,1,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(27,'Pretium non netus odio porttitor','pretium-non-netus-odio-porttitor',9,1,'<p>Pretium non netus odio porttitor interdum nunc Aliquam laoreet lacinia ut. Vestibulum est id Donec elit id Ut Lorem ac enim amet. Amet nec justo consequat pretium pretium condimentum scelerisque Lorem neque et. Urna ut ipsum ipsum eu Nullam libero tincidunt leo Sed facilisis. Semper eleifend sociis tempus nibh ipsum semper Vestibulum id orci.</p>\r\n\r\n','\r\n\r\n<p>Pellentesque enim pellentesque Nullam eget id iaculis laoreet Curabitur rutrum Lorem. Id vitae hendrerit Fusce Curabitur tristique sit urna feugiat Nulla euismod. Adipiscing lacinia Nullam rhoncus accumsan neque In pede tincidunt pellentesque et. Nibh enim pellentesque laoreet volutpat tempus est lobortis ipsum pellentesque convallis. Elit Vestibulum a Vestibulum tincidunt elit dignissim congue eros tincidunt dapibus. Pede velit nibh eu nibh laoreet dui et mauris sem vitae. </p>\r\n\r\n<p>Condimentum wisi fringilla elit ipsum condimentum dui pretium urna tellus quis. Vestibulum dapibus eu pretium ornare rutrum Vivamus quis at tellus Morbi. Enim eget vel facilisi elit est dui tempor augue tellus mattis. Nunc Curabitur orci nec ac penatibus orci elit egestas ligula enim. Libero nascetur pede Nam dui est gravida Vestibulum ut interdum Morbi. Et interdum elit Sed est Vestibulum eget est Fusce.</p>\r\n\r\n<p>Sollicitudin congue risus tellus ut vel gravida molestie Morbi vel Curabitur. Ante feugiat convallis dapibus justo Mauris in felis dui et orci. Orci accumsan augue ac tristique mus faucibus tellus ac Donec Suspendisse. Risus metus felis fringilla Suspendisse id vel arcu laoreet fermentum neque. Phasellus Nam suscipit mauris hendrerit Donec Sed nunc rhoncus mi hendrerit. </p>\r\n\r\n<p>Gravida dui hac et metus amet consequat eget sapien mollis vitae. Elit ut fringilla Morbi turpis rutrum sociis Lorem mauris ut id. Vivamus in et amet amet cursus Nulla mi nibh Nam dolor. Eu Phasellus laoreet Curabitur risus lobortis sem feugiat pede pretium mauris. Consequat quam nisl auctor sem hac vitae mauris vitae nunc iaculis. Magna pede pede.</p>\r\n\r\n<p>Lorem ac et Curabitur ut commodo sagittis mauris lacinia interdum nisl. Quis eget felis semper urna convallis diam lacinia pede sapien ligula. Pretium natoque orci metus cursus natoque mauris malesuada ac Nunc Nulla. Felis adipiscing orci natoque convallis penatibus molestie at enim Donec vitae. Vel dignissim metus vel Sed wisi fringilla Vestibulum Vivamus dictumst id. Vitae tempor venenatis dui condimentum nibh Nulla justo Curabitur Sed convallis. Lobortis sapien.</p>',null,null,'[]','','2010-03-08 10:10:04',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 10:10:04','0000-00-00 00:00:00',0,0,2,0,0,'','','','',2,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(28,'Phasellus Nam suscipit mauris hendrerit','phasellus-nam-suscipit-mauris-hendrerit',9,1,'<p>Pretium non netus odio porttitor interdum nunc Aliquam laoreet lacinia ut. Vestibulum est id Donec elit id Ut Lorem ac enim amet. Amet nec justo consequat pretium pretium condimentum scelerisque Lorem neque et. Urna ut ipsum ipsum eu Nullam libero tincidunt leo Sed facilisis. Semper eleifend sociis tempus nibh ipsum semper Vestibulum id orci.</p>\r\n\r\n','\r\n\r\n<p>Pellentesque enim pellentesque Nullam eget id iaculis laoreet Curabitur rutrum Lorem. Id vitae hendrerit Fusce Curabitur tristique sit urna feugiat Nulla euismod. Adipiscing lacinia Nullam rhoncus accumsan neque In pede tincidunt pellentesque et. Nibh enim pellentesque laoreet volutpat tempus est lobortis ipsum pellentesque convallis. Elit Vestibulum a Vestibulum tincidunt elit dignissim congue eros tincidunt dapibus. Pede velit nibh eu nibh laoreet dui et mauris sem vitae. </p>\r\n\r\n<p>Condimentum wisi fringilla elit ipsum condimentum dui pretium urna tellus quis. Vestibulum dapibus eu pretium ornare rutrum Vivamus quis at tellus Morbi. Enim eget vel facilisi elit est dui tempor augue tellus mattis. Nunc Curabitur orci nec ac penatibus orci elit egestas ligula enim. Libero nascetur pede Nam dui est gravida Vestibulum ut interdum Morbi. Et interdum elit Sed est Vestibulum eget est Fusce.</p>\r\n\r\n<p>Sollicitudin congue risus tellus ut vel gravida molestie Morbi vel Curabitur. Ante feugiat convallis dapibus justo Mauris in felis dui et orci. Orci accumsan augue ac tristique mus faucibus tellus ac Donec Suspendisse. Risus metus felis fringilla Suspendisse id vel arcu laoreet fermentum neque. Phasellus Nam suscipit mauris hendrerit Donec Sed nunc rhoncus mi hendrerit. </p>\r\n\r\n<p>Gravida dui hac et metus amet consequat eget sapien mollis vitae. Elit ut fringilla Morbi turpis rutrum sociis Lorem mauris ut id. Vivamus in et amet amet cursus Nulla mi nibh Nam dolor. Eu Phasellus laoreet Curabitur risus lobortis sem feugiat pede pretium mauris. Consequat quam nisl auctor sem hac vitae mauris vitae nunc iaculis. Magna pede pede.</p>\r\n\r\n<p>Lorem ac et Curabitur ut commodo sagittis mauris lacinia interdum nisl. Quis eget felis semper urna convallis diam lacinia pede sapien ligula. Pretium natoque orci metus cursus natoque mauris malesuada ac Nunc Nulla. Felis adipiscing orci natoque convallis penatibus molestie at enim Donec vitae. Vel dignissim metus vel Sed wisi fringilla Vestibulum Vivamus dictumst id. Vitae tempor venenatis dui condimentum nibh Nulla justo Curabitur Sed convallis. Lobortis sapien.</p>\r\n\r\n<p>Fusce Cras a ligula vitae id et et malesuada tincidunt scelerisque. Tempus facilisi pede ante Nunc vitae vitae amet et dolor elit. Consectetuer et urna Vivamus parturient Curabitur nibh nec nascetur Morbi molestie. Nunc tortor volutpat eget fringilla amet Vestibulum Quisque eu lobortis Vivamus. Dignissim Curabitur dui nec Nullam Phasellus.</p>\r\n\r\n<p>Lacus dictumst congue in sem elit mus mi lacinia quis semper. Dui nibh tincidunt ante nibh eleifend et sit eget Sed tempor. Et Donec felis sodales mattis Cum ipsum sem Curabitur molestie dolor. Euismod adipiscing pharetra porttitor Proin leo tellus adipiscing nibh dolor cursus. Ut nisl ut vitae massa justo quis Curabitur augue non nulla. Amet a eu Curabitur dui velit cursus et et Nulla laoreet. Semper.</p>',null,null,'[]','','2010-03-08 10:10:39',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-08 10:10:39','0000-00-00 00:00:00',0,0,3,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(29,'Van Zeeland Jungle Boogie E/W Satchel','van-zeeland-jungle-boogie-e/w-satchel',7,1,'Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida.','',null,null,'[{\"id\":\"22\",\"value\":\"Van Zeeland Jungle Boogie E\\/W Satchel\"},{\"id\":\"23\",\"value\":\"$99.00\"},{\"id\":\"24\",\"value\":\"Black | Yellow | Blue\"}]','Van Zeeland Jungle Boogie E/W Satchel $99.00 Black | Yellow | Blue ','2010-03-09 01:43:31',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 01:43:31','0000-00-00 00:00:00',0,0,3,0,0,'','','','',1,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(30,'Van Zeeland Jungle Boogie E/W Satchel','kathy-van-zeeland-jungle-boogie-e/w-satchel',7,1,'','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland Jungle Boogie E\\/W Satchel\"},{\"id\":\"23\",\"value\":\"$69.07 - $69.39\"},{\"id\":\"24\",\"value\":\"Black | Latte | Yellow\"}]','KATHY Van Zeeland Jungle Boogie E/W Satchel $69.07 - $69.39 Black | Latte | Yellow ','2010-03-09 01:49:13',62,'',0,'0000-00-00 00:00:00','2010-03-13 08:35:05',62,'2010-03-09 01:49:13','0000-00-00 00:00:00',0,0,4,0,0,'','','','',4,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(31,'Van Zeeland Lady Loop Belt Shopper','kathy-van-zeeland-lady-loop-belt-shopper',7,1,'Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt.','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland Lady Loop Belt Shopper\"},{\"id\":\"23\",\"value\":\"$50.54 - $89.00\"},{\"id\":\"24\",\"value\":\"Ozone | Viola | Black\"}]','KATHY Van Zeeland Lady Loop Belt Shopper $50.54 - $89.00 Ozone | Viola | Black ','2010-03-09 01:51:13',62,'',0,'0000-00-00 00:00:00','2010-03-13 08:34:41',62,'2010-03-09 01:51:13','0000-00-00 00:00:00',0,0,5,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(32,'KATHY Van Zeeland High Life Satchel','kathy-van-zeeland-high-life-satchel',7,1,'Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur.','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland High Life Satchel\"},{\"id\":\"23\",\"value\":\"$56.17\"},{\"id\":\"24\",\"value\":\"Black | Viola\"}]','KATHY Van Zeeland High Life Satchel $56.17 Black | Viola ','2010-03-09 02:06:35',62,'',0,'0000-00-00 00:00:00','2010-03-13 08:25:10',62,'2010-03-09 02:06:35','0000-00-00 00:00:00',0,0,6,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(33,'KATHY Van Zeeland Connect Four Satchel','kathy-van-zeeland-connect-four-satchel',7,1,'','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland Connect Four Satchel\"},{\"id\":\"23\",\"value\":\"$42.32 - $71.24\"},{\"id\":\"24\",\"value\":\"Pepper | Black\"}]','KATHY Van Zeeland Connect Four Satchel $42.32 - $71.24 Pepper | Black ','2010-03-09 02:09:10',62,'',0,'0000-00-00 00:00:00','2010-03-13 08:24:26',62,'2010-03-09 02:09:10','0000-00-00 00:00:00',0,0,7,0,0,'','','','',2,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(34,'KATHY Van Zeeland Poseidon Large Hobo','kathy-van-zeeland-poseidon-large-hobo',7,1,'','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland Poseidon Large Hobo\"},{\"id\":\"23\",\"value\":\"$85.45\"},{\"id\":\"24\",\"value\":\"Zebra | Bronze Zebra\"}]','KATHY Van Zeeland Poseidon Large Hobo $85.45 Zebra | Bronze Zebra ','2010-03-09 02:26:41',62,'',0,'0000-00-00 00:00:00','2010-03-13 08:22:46',62,'2010-03-09 02:26:41','0000-00-00 00:00:00',0,0,8,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(35,'Van Zeeland Knockout Ring Shopper','kathy-van-zeeland-knockout-ring-shopper',7,1,'Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet.','',null,null,'[{\"id\":\"22\",\"value\":\"KATHY Van Zeeland Knockout Ring Shopper\"},{\"id\":\"23\",\"value\":\"$88.90 - $89.00\"},{\"id\":\"24\",\"value\":\"Cork | Pistachio\"}]','KATHY Van Zeeland Knockout Ring Shopper $88.90 - $89.00 Cork | Pistachio ','2010-03-09 02:38:30',62,'',0,'0000-00-00 00:00:00','2010-03-17 02:29:34',68,'2010-03-09 02:38:30','0000-00-00 00:00:00',0,0,9,0,0,'','','','',109,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(36,'Rutrum consequat Mauris Suspendisse','rutrum-consequat-mauris-suspendisse',8,1,'<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n','\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>\r\n\r\n<p>Curabitur condimentum quis consectetuer volutpat Pellentesque nulla Lorem pretium ac dui. Et ligula sagittis eros lacinia consequat habitasse Morbi orci tellus dictumst. Sit in amet pretium vel semper nibh quis pretium facilisis urna. Nisl quis fames sem lacus pellentesque nec Ut Curabitur Sed elit. Ut ac hendrerit vitae Phasellus dis quis leo condimentum dictumst Vestibulum. Fringilla In metus natoque Aenean Fusce et sed tempor libero felis. </p>',null,null,'[]','','2010-03-09 04:39:48',62,'',0,'0000-00-00 00:00:00','2010-03-09 04:41:56',62,'2010-03-09 04:39:48','0000-00-00 00:00:00',0,0,2,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(37,'Rutrum consequat Mauris Suspendisse nibh','rutrum-consequat-mauris-suspendisse-nibh',8,1,'<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n','\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>',null,null,'[]','','2010-03-09 04:41:56',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:41:56','0000-00-00 00:00:00',0,0,3,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(38,'The Beautiful Life of Chanel\'s Peter Philips','the-beautiful-life-of-chanels-peter-philips',8,1,'<img src=\"images/stories/demo/sam-8.jpg\" title=\"Sample image\" alt=\"Sample image\" align=\"left\" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer faucibus vestibulum et at felis. Pretium nec Suspendisse at Aenean tincidunt porta malesuada id id lacinia. Tellus scelerisque Cum euismod Donec id Pellentesque id <a href=\"#\" title=\"Sample link\">justo Phasellus.</a></p>\r\n\r\n','\r\n\r\n<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>',null,null,'[]','','2010-03-09 04:42:28',62,'',0,'0000-00-00 00:00:00','2010-03-17 02:26:40',68,'2010-03-09 04:42:28','0000-00-00 00:00:00',0,0,4,0,0,'','','','',32,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(39,'Off-Screen Action','off-screen-action',9,1,'<img src=\"images/stories/demo/sam-9.jpg\" title=\"Sample image\" alt=\"Sample image\" align=\"left\" />\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc.</p>\r\n\r\n','\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>',null,null,'[]','','2010-03-09 04:43:01',62,'',0,'0000-00-00 00:00:00','2010-03-10 08:43:07',62,'2010-03-09 04:43:01','0000-00-00 00:00:00',0,0,4,0,0,'','','','',12,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(40,'Dignissim ac et tellus Pellentesque wisi','dignissim-ac-et-tellus-pellentesque-wisi',10,1,'<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n','\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>\r\n\r\n<p>Curabitur condimentum quis consectetuer volutpat Pellentesque nulla Lorem pretium ac dui. Et ligula sagittis eros lacinia consequat habitasse Morbi orci tellus dictumst. Sit in amet pretium vel semper nibh quis pretium facilisis urna. Nisl quis fames sem lacus pellentesque nec Ut Curabitur Sed elit. Ut ac hendrerit vitae Phasellus dis quis leo condimentum dictumst Vestibulum. Fringilla In metus natoque Aenean Fusce et sed tempor libero felis. </p>',null,null,'[]','','2010-03-09 04:45:23',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:45:23','0000-00-00 00:00:00',0,0,1,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(41,'hasellus semper tellus semper augue tellus','hasellus-semper-tellus-semper-augue-tellus',10,1,'<p>Lorem ipsum dolor sit amet consectetuer faucibus vestibulum et at felis. Pretium nec Suspendisse at Aenean tincidunt porta malesuada id id lacinia. Tellus scelerisque Cum euismod Donec id Pellentesque id justo Phasellus id. Risus vel id eu libero nibh sem risus egestas hendrerit Aliquam. Congue In nulla sed netus sem et natoque egestas pellentesque pretium. Natoque sodales justo.</p>\r\n\r\n','\r\n\r\n<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>',null,null,'[]','','2010-03-09 04:45:55',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:45:55','0000-00-00 00:00:00',0,0,2,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(42,'Rutrum consequat Mauris Suspendisse','rutrum-consequat-mauris-suspendisse',10,1,'<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n','\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>',null,null,'[]','','2010-03-09 04:46:24',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:46:24','0000-00-00 00:00:00',0,0,3,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(43,'McQueen, The Showman','mcqueen-the-showman',10,1,'<img src=\"images/stories/demo/sam-10.jpg\" title=\"Sample image\" alt=\"Sample image\" align=\"left\" />\r\n\r\n<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna.</p>\r\n\r\n','\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>',null,null,'[]','','2010-03-09 04:46:54',62,'',0,'0000-00-00 00:00:00','2010-03-10 10:06:03',62,'2010-03-09 04:46:54','0000-00-00 00:00:00',0,0,4,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(44,'Dignissim ac et tellus Pellentesque','dignissim-ac-et-tellus-pellentesque',11,1,'<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n','\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>\r\n\r\n<p>Curabitur condimentum quis consectetuer volutpat Pellentesque nulla Lorem pretium ac dui. Et ligula sagittis eros lacinia consequat habitasse Morbi orci tellus dictumst. Sit in amet pretium vel semper nibh quis pretium facilisis urna. Nisl quis fames sem lacus pellentesque nec Ut Curabitur Sed elit. Ut ac hendrerit vitae Phasellus dis quis leo condimentum dictumst Vestibulum. Fringilla In metus natoque Aenean Fusce et sed tempor libero felis. </p>',null,null,'[]','','2010-03-09 04:52:27',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:52:27','0000-00-00 00:00:00',0,0,1,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(45,'Aenean Phasellus semper tellus semper augue','aenean-phasellus-semper-tellus-semper-augue',11,1,'<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n','\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>',null,null,'[]','','2010-03-09 04:52:53',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:52:53','0000-00-00 00:00:00',0,0,2,0,0,'','','','',0,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(46,'Egestas dignissim ac Vestibulum arcu','egestas-dignissim-ac-vestibulum-arcu',11,1,'<p>Lorem ipsum dolor sit amet consectetuer faucibus vestibulum et at felis. Pretium nec Suspendisse at Aenean tincidunt porta malesuada id id lacinia. Tellus scelerisque Cum euismod Donec id Pellentesque id justo Phasellus id. Risus vel id eu libero nibh sem risus egestas hendrerit Aliquam. Congue In nulla sed netus sem et natoque egestas pellentesque pretium. Natoque sodales justo.</p>\r\n\r\n','\r\n\r\n<p>Egestas dignissim ac Vestibulum arcu Fusce fringilla commodo et auctor eget. Pharetra Aliquam vitae at a tellus dolor metus quam id turpis. Turpis ac eros pede condimentum pellentesque gravida Proin iaculis et urna. Penatibus sagittis hendrerit justo consectetuer urna nunc hac quis Phasellus gravida. Vivamus adipiscing In montes vitae ut Phasellus Curabitur Donec Quisque.</p>\r\n\r\n<p>Aenean Phasellus semper tellus semper augue tellus urna tortor lorem quis. Laoreet sem adipiscing metus massa hendrerit id Vestibulum lobortis neque eget. Justo congue nunc convallis tempus tempus nunc tortor nonummy elit pellentesque. Risus non ac et augue wisi sem elit urna elit arcu. Cursus vitae Curabitur Vestibulum metus justo et.</p>\r\n\r\n<p>Rutrum consequat Mauris Suspendisse nibh eget vel Lorem cursus justo nunc. Vestibulum Morbi Lorem orci Donec commodo tellus egestas ornare leo pretium. Morbi lacinia interdum nulla penatibus amet nibh adipiscing semper ligula Nunc. Vestibulum vitae molestie Vestibulum malesuada orci quis libero et adipiscing faucibus. Augue justo ligula est Nam neque Maecenas convallis nibh nisl condimentum. Cursus Morbi Proin convallis hac lorem pede mi ut consequat vitae. </p>\r\n\r\n<p>Et orci nascetur rutrum Aliquam vitae ac eleifend justo ipsum Aenean. Justo enim lobortis libero ullamcorper Vestibulum semper metus egestas porta tellus. Lobortis in id lorem orci quis pede sem mi Curabitur laoreet. Habitasse at et Phasellus Curabitur turpis consequat vel elit eros non. Dui nibh Morbi velit nec elit nibh nec dapibus laoreet libero. Fames laoreet tristique risus enim quis a.</p>\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque Aenean Curabitur non volutpat ut sed et. Nunc orci egestas justo leo Proin sapien lacinia senectus Quisque id. Elit Pellentesque porttitor lobortis dolor lobortis justo elit Nam velit tellus. Ac enim Sed justo.</p>\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>',null,null,'[]','','2010-03-09 04:53:19',62,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2010-03-09 04:53:19','0000-00-00 00:00:00',0,0,3,0,0,'','','','',10,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','',''),
(47,'Vestibulum tellus id nullam gravida sem neque mauris nam','vestibulum-tellus-id-nullam-gravida-sem-neque-mauris-nam',11,1,'<img src=\"images/stories/demo/sam-11.jpg\" title=\"Sample image\" alt=\"Sample image\" align=\"left\" />\r\n\r\n<p>Dignissim ac et tellus Pellentesque wisi sed eget mollis neque Maecenas. Tellus sem et Nunc elit Curabitur laoreet consectetuer Nulla fames ante. Risus habitant justo pellentesque aenean curabitur non...</p>\r\n\r\n','\r\n\r\n<p>Magna convallis Nam consequat urna Aenean at dictumst ut Curabitur Cum. Sagittis et elit Vestibulum tincidunt Sed nibh pellentesque ante Pellentesque nibh. Risus Sed lacus Nam hendrerit netus odio hac nulla hac wisi. Donec facilisi mauris nec parturient In nibh tellus sodales at auctor. Orci turpis Nam nibh neque Nunc eros vel sem ac libero. Elit vitae orci mauris sed pharetra sociis neque orci dolor consectetuer. Ac lobortis.</p>\r\n\r\n<p>Mauris nibh tristique nulla libero tincidunt Pellentesque mollis interdum neque tristique. Nec non Vivamus tincidunt orci Sed ligula nisl eget wisi auctor. A consequat Vestibulum tellus id Nullam gravida sem neque mauris Nam. Quis orci dictum lacus adipiscing Nam Maecenas risus fringilla eget tincidunt. Tincidunt interdum nibh Nam orci turpis nibh Duis nunc ipsum egestas. Commodo Aenean vel volutpat justo id ac at adipiscing eu.</p>\r\n\r\n<p>Nullam ut tempor id elit orci Donec mus magna quam ligula. Vestibulum at pretium Quisque magnis Nulla semper velit Sed malesuada a. Felis tellus dolor at mus ipsum ante Vestibulum nec ut nascetur. Consequat sit Aenean ut metus laoreet risus malesuada hendrerit fames rhoncus. Vitae pede orci Sed ultrices iaculis metus urna elit ante Phasellus. Nunc.</p>\r\n\r\n<p>Curabitur condimentum quis consectetuer volutpat Pellentesque nulla Lorem pretium ac dui. Et ligula sagittis eros lacinia consequat habitasse Morbi orci tellus dictumst. Sit in amet pretium vel semper nibh quis pretium facilisis urna. Nisl quis fames sem lacus pellentesque nec Ut Curabitur Sed elit. Ut ac hendrerit vitae Phasellus dis quis leo condimentum dictumst Vestibulum. Fringilla In metus natoque Aenean Fusce et sed tempor libero felis. </p>',null,null,'[]','','2010-03-09 04:53:49',62,'',0,'0000-00-00 00:00:00','2010-03-10 10:34:54',62,'2010-03-09 04:53:49','0000-00-00 00:00:00',0,0,4,0,0,'','','','',5,'catItemTitle=\ncatItemTitleLinked=\ncatItemFeaturedNotice=\ncatItemAuthor=\ncatItemDateCreated=\ncatItemRating=\ncatItemImage=\ncatItemIntroText=\ncatItemExtraFields=\ncatItemHits=\ncatItemCategory=\ncatItemTags=\ncatItemAttachments=\ncatItemAttachmentsCounter=\ncatItemVideo=\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=\ncatItemImageGallery=\ncatItemDateModified=\ncatItemReadMore=\ncatItemCommentsAnchor=\ncatItemK2Plugins=\nitemDateCreated=\nitemTitle=\nitemFeaturedNotice=\nitemAuthor=\nitemFontResizer=\nitemPrintButton=\nitemEmailButton=\nitemSocialButton=\nitemVideoAnchor=\nitemImageGalleryAnchor=\nitemCommentsAnchor=\nitemRating=\nitemImage=\nitemImgSize=\nitemImageMainCaption=\nitemImageMainCredits=\nitemIntroText=\nitemFullText=\nitemExtraFields=\nitemDateModified=\nitemHits=\nitemTwitterLink=\nitemCategory=\nitemTags=\nitemShareLinks=\nitemAttachments=\nitemAttachmentsCounter=\nitemRelated=\nitemRelatedLimit=\nitemVideo=\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=\nitemVideoCaption=\nitemVideoCredits=\nitemImageGallery=\nitemNavigation=\nitemComments=\nitemAuthorBlock=\nitemAuthorImage=\nitemAuthorDescription=\nitemAuthorURL=\nitemAuthorEmail=\nitemAuthorLatest=\nitemAuthorLatestLimit=\nitemK2Plugins=\n\n','','robots=\nauthor=','','');


DROP TABLE IF EXISTS `#__k2_rating`;
CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_rating` VALUES
(1,4,1,'10.0.0.199'),
(11,9,2,'10.0.0.106'),
(13,5,2,'10.0.0.106'),
(12,9,2,'10.0.0.106'),
(23,3,1,'127.0.0.1'),
(18,8,2,'10.0.0.101'),
(21,14,3,'10.0.0.199'),
(14,4,1,'10.0.0.199'),
(15,20,5,'10.0.0.106'),
(20,5,1,'10.0.0.101'),
(22,8,2,'127.0.0.1'),
(17,5,1,'10.0.0.101'),
(34,9,2,'10.0.0.106'),
(33,8,2,'10.0.0.106'),
(16,4,1,'127.0.0.1'),
(35,9,2,'10.0.0.106'),
(30,5,1,'10.0.0.106'),
(31,4,1,'10.0.0.106'),
(32,1,1,'10.0.0.106');


DROP TABLE IF EXISTS `#__k2_tags`;
CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_tags` VALUES
(1,'Shopping',1),
(2,'Fashion',1),
(3,'Watch',1),
(4,' Man',1),
(5,'Man',1),
(6,'Woman',1),
(7,' Fashion',1),
(8,'Shoes',1),
(9,'Girl',1),
(10,'Gucci',1),
(11,'Suit',1),
(12,' Comple',1),
(13,'Veston',1),
(14,'Italia',1),
(15,'Bag',1),
(16,'Men',1),
(17,'Cool',1);


DROP TABLE IF EXISTS `#__k2_tags_xref`;
CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_tags_xref` VALUES
(1,1,38),
(2,2,38),
(30,4,16),
(29,3,16),
(28,2,16),
(6,3,15),
(7,5,15),
(8,6,15),
(9,7,15),
(10,8,10),
(11,5,10),
(12,9,10),
(13,6,10),
(14,10,10),
(15,11,22),
(16,12,22),
(17,13,22),
(18,2,22),
(19,14,22),
(20,15,35),
(21,6,35),
(22,16,35),
(23,2,35),
(24,17,35);


DROP TABLE IF EXISTS `#__k2_user_groups`;
CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_user_groups` VALUES
(1,'Registered','frontEdit=0\nadd=0\neditOwn=0\neditAll=0\npublish=0\ncomment=1\ninheritance=0\ncategories=all\n\n'),
(2,'Site Owner','frontEdit=1\nadd=1\neditOwn=1\neditAll=1\npublish=1\ncomment=1\ninheritance=1\ncategories=all\n\n');


DROP TABLE IF EXISTS `#__k2_users`;
CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
INSERT INTO `#__k2_users` VALUES
(1,62,'Administrator','m','','trungch.jpg','http://www.cssyeah.com',1,''),
(2,63,'Huynh Hien Duc','m','This is my site : http://www.fastostyle.com','funny_children_278_2.jpg','http://www.fastostyle.com',1,''),
(3,64,'Nguyet Nguyen Do','f','Thanks !','rose.jpg','',1,''),
(4,65,'Hieu Nguyen','m','Welcome to my profile !','av5.jpg','www.nnth.info',1,''),
(5,67,'Dinh Viet Hung','m','','New_Year.jpg','http://www.joom.vn',1,''),
(6,68,'JA Ores Team','m','<h2>Welcome to Our page</h2>\r\n\r\n<p>Non justo mauris ante sem pellentesque Fusce est Sed sollicitudin Pellentesque. Mattis id velit dolor eu tortor Phasellus pharetra Nunc urna augue. Mauris augue ut Proin rutrum nisl Nulla convallis amet hendrerit dui. Elit pretium montes montes Curabitur condimentum sem consequat augue montes purus. Nulla turpis vel vitae ac nec gravida cursus interdum convallis wisi. Mi mauris consequat Duis laoreet pulvinar.</p>\r\n\r\n<p>Et sem sagittis quis leo eu wisi nibh accumsan scelerisque dolor. In mauris enim dapibus id condimentum Vivamus tincidunt nibh volutpat ut. Vel dui est Phasellus augue tortor ipsum eget vitae fermentum netus. Nunc Lorem odio magna dis leo parturient Sed Nam nibh Lorem. Integer Aenean eros egestas enim Pellentesque Morbi ante ornare Integer augue. Urna urna.</p>\r\n\r\n<h3>Chu Huu Trung</h3>\r\n<p class=\"box-grey clearfix\"><img src=\"media/k2/users/rose.jpg\" alt=\"Avatar\" align=\"left\" />Tincidunt sed Vestibulum scelerisque tempor ac a nec augue condimentum cursus. Turpis a gravida quis nibh sollicitudin nunc sed Ut purus ligula. In platea nec vel porttitor Vestibulum et malesuada dis vel et.</p>\r\n\r\n<h3>Duc Huynh Hien</h3>\r\n<p class=\"box-grey clearfix\"><img src=\"media/k2/users/funny_children_278_2.jpg\" alt=\"Avatar\" align=\"left\" style=\"padding: 4px; border: 1px solid #ddd;\" />Gravida orci Nunc lacinia eget sapien elit tincidunt congue elit dui. Tristique lacus Aenean Sed eget tortor turpis tellus Curabitur In risus. Laoreet sagittis eleifend Vivamus a Nam tempus sagittis ut Aliquam elit. Consequat felis pellentesque Morbi quis quis Curabitur dui velit nunc Praesent. Nunc ac eget et fringilla eu Proin Curabitur ante ligula turpis. Magna id Aenean Vestibulum aliquet non porta orci Donec semper.</p>\r\n\r\n<h3>Duc Le</h3>\r\n<p class=\"box-grey clearfix\"><img src=\"media/k2/users/av5.jpg\" alt=\"Avatar\" align=\"left\" />Gravida orci Nunc lacinia eget sapien elit tincidunt congue elit dui. Tristique lacus Aenean Sed eget tortor turpis tellus Curabitur In risus. Laoreet sagittis eleifend Vivamus a Nam tempus sagittis ut Aliquam elit. Consequat felis pellentesque Morbi quis quis Curabitur dui velit nunc Praesent. Nunc ac eget et fringilla eu Proin Curabitur ante ligula turpis. Magna id Aenean Vestibulum aliquet non porta orci Donec semper.</p>\r\n\r\n<h3>Hong Nguyen Thi</h3>\r\n<p class=\"box-grey clearfix\"><img src=\"media/k2/users/teen.jpg\" alt=\"Avatar\" align=\"left\" />Et sem sagittis quis leo eu wisi nibh accumsan scelerisque dolor. In mauris enim dapibus id condimentum Vivamus tincidunt nibh volutpat ut. Vel dui est Phasellus augue tortor ipsum eget vitae fermentum netus. Nunc Lorem odio magna dis leo parturient Sed Nam nibh Lorem. Integer Aenean eros egestas enim Pellentesque Morbi ante ornare Integer augue. Urna urna.</p>\r\n\r\n<h3>Contact information</h3>\r\n<ul class=\"checklist\">\r\n<li><span class=\"icon\">&nbsp;</span><strong>Full Name: </strong>Chu Huu Trung</li>\r\n<li><span class=\"icon\">&nbsp;</span><strong>Position: </strong>Web Designer</li>\r\n<li><span class=\"icon\">&nbsp;</span><strong>Add: </strong>249A Thuy Khue Street - Hanoi - Vietnam</li>\r\n<li><span class=\"icon\">&nbsp;</span><strong>Cell phone: </strong>(+84) 982 555 408</li>\r\n<li><span class=\"icon\">&nbsp;</span><strong>Email: </strong>trungch@joomsolutions.com</li>\r\n<li><span class=\"icon\">&nbsp;</span><strong>Website: </strong>www.joomlart.com</li>\r\n</ul>\r\n\r\n<p class=\"box-download\"><a href=\"#\" title\"My Profile\">Download Our profile</a></p>','trungch.jpg','http://www.cssyeah.com',1,''),
(7,69,'Tester@','f','<p>Hey</p>\r\n<p>Thanks for giving the widget a try !<br />You have to insert you UserID in thecomment options page <br />Then everything will work:-)</p>','giaptnTAST38_5.jpg','',1,''),
(8,70,'OresTest','m','','giaptnTAST38_5.jpg','',1,'');


DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(75) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `link` text,
  `type` varchar(50) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `parent` int(11) unsigned NOT NULL DEFAULT '0',
  `componentid` int(11) unsigned NOT NULL DEFAULT '0',
  `sublevel` int(11) DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `pollid` int(11) NOT NULL DEFAULT '0',
  `browserNav` tinyint(4) DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `utaccess` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `lft` int(11) unsigned NOT NULL DEFAULT '0',
  `rgt` int(11) unsigned NOT NULL DEFAULT '0',
  `home` int(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `componentid` (`componentid`,`menutype`,`published`,`access`),
  KEY `menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=146 DEFAULT CHARSET=utf8;
INSERT INTO `#__menu` VALUES
(86,'mainmenu','Login[modpos=login group=1]','faq','index.php?option=com_content&view=section&id=3','component',-2,0,20,0,26,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=mod\nmega_subcontent-mod-modules=2\n\n',0,0,0),
(85,'mainmenu','Explore','explore','index.php?option=com_content&view=article&id=49','component',-2,0,20,0,29,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(11,'othermenu','Joomla! Home','joomla-home','http://www.joomla.org','url',1,0,0,0,1,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(12,'othermenu','Joomla! Forums','joomla-forums','http://forum.joomla.org','url',1,0,0,0,2,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(13,'othermenu','Joomla! Documentation','joomla-documentation','http://docs.joomla.org','url',1,0,0,0,3,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(14,'othermenu','Joomla! Community','joomla-community','http://community.joomla.org','url',1,0,0,0,4,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(15,'othermenu','Joomla! Magazine','joomla-community-magazine','http://community.joomla.org/magazine.html','url',1,0,0,0,5,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(16,'othermenu','OSM Home','osm-home','http://www.opensourcematters.org','url',1,0,0,0,6,0,'0000-00-00 00:00:00',0,0,0,6,'menu_image=-1\n\n',0,0,0),
(17,'othermenu','Administrator','administrator','administrator/','url',1,0,0,0,7,0,'0000-00-00 00:00:00',0,0,0,3,'menu_image=-1\n\n',0,0,0),
(18,'topmenu','News','news','index.php?option=com_newsfeeds&view=newsfeed&id=1&feedid=1','component',1,0,11,0,3,0,'0000-00-00 00:00:00',0,0,0,3,'show_page_title=1\npage_title=News\npageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_headings=1\nshow_name=1\nshow_articles=1\nshow_link=1\nshow_other_cats=1\nshow_cat_description=1\nshow_cat_items=1\nshow_feed_image=1\nshow_feed_description=1\nshow_item_description=1\nfeed_word_count=0\n\n',0,0,0),
(20,'usermenu','Your Details','your-details','index.php?option=com_user&view=user&task=edit','component',1,0,14,0,1,0,'0000-00-00 00:00:00',0,0,1,3,'',0,0,0),
(24,'usermenu','Logout','logout','index.php?option=com_user&view=login','component',1,0,14,0,4,0,'0000-00-00 00:00:00',0,0,1,3,'',0,0,0),
(38,'keyconcepts','Content Layouts','content-layouts','index.php?option=com_content&view=article&id=24','component',1,0,20,0,2,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(83,'mainmenu','Contact','contact','index.php?option=com_contact&view=contact&id=1','component',1,95,7,2,1,0,'0000-00-00 00:00:00',0,0,0,0,'show_contact_list=0\nshow_category_crumb=0\ncontact_icons=\nicon_address=\nicon_email=\nicon_telephone=\nicon_mobile=\nicon_fax=\nicon_misc=\nshow_headings=\nshow_position=\nshow_email=\nshow_telephone=\nshow_mobile=\nshow_fax=\nallow_vcard=\nbanned_email=\nbanned_subject=\nbanned_text=\nvalidate_session=\ncustom_reply=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(28,'topmenu','About Joomla!','about-joomla','index.php?option=com_content&view=article&id=25','component',1,0,20,0,1,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(29,'topmenu','Features','features','index.php?option=com_content&view=article&id=22','component',1,0,20,0,2,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(30,'topmenu','The Community','the-community','index.php?option=com_content&view=article&id=27','component',1,0,20,0,4,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(82,'mainmenu','Layout','layout','index.php?option=com_content&view=article&id=69','component',-2,0,20,0,36,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(40,'keyconcepts','Extensions','extensions','index.php?option=com_content&view=article&id=26','component',1,0,20,0,1,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(84,'mainmenu','contact-2','contact-2','index.php?option=com_contact&view=category&catid=0','component',-2,0,7,0,30,0,'0000-00-00 00:00:00',0,0,0,0,'display_num=20\nimage=-1\nimage_align=right\nshow_limit=0\nshow_feed_link=1\ncontact_icons=\nicon_address=\nicon_email=\nicon_telephone=\nicon_mobile=\nicon_fax=\nicon_misc=\nshow_headings=\nshow_position=\nshow_email=\nshow_telephone=\nshow_mobile=\nshow_fax=\nallow_vcard=\nbanned_email=\nbanned_subject=\nbanned_text=\nvalidate_session=\ncustom_reply=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(43,'keyconcepts','Example Pages','example-pages','index.php?option=com_content&view=article&id=43','component',1,0,20,0,3,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(44,'ExamplePages','Section Blog','section-blog','index.php?option=com_content&view=section&layout=blog&id=3','component',1,0,20,0,1,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=1\nnum_links=4\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=Example of Section Blog layout (FAQ section)\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(45,'ExamplePages','Section Table','section-table','index.php?option=com_content&view=section&id=3','component',1,0,20,0,2,0,'0000-00-00 00:00:00',0,0,0,0,'show_page_title=1\npage_title=Example of Table Blog layout (FAQ section)\nshow_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\norderby=\nshow_noauth=0\nshow_title=1\nnlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(46,'ExamplePages','Category Blog','categoryblog','index.php?option=com_content&view=category&layout=blog&id=31','component',1,0,20,0,3,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=1\nnum_links=4\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=Example of Category Blog layout (FAQs/General category)\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(47,'ExamplePages','Category Table','category-table','index.php?option=com_content&view=category&id=32','component',1,0,20,0,4,0,'0000-00-00 00:00:00',0,0,0,0,'show_page_title=1\npage_title=Example of Category Table layout (FAQs/Languages category)\nshow_headings=1\nshow_date=0\ndate_format=\nfilter=1\nfilter_type=title\npageclass_sfx=\nmenu_image=-1\nsecure=0\norderby_sec=\nshow_pagination=1\nshow_pagination_limit=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(76,'mainmenu','CSS Menu','css-menu','?ja_menu=css','url',1,75,0,1,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(77,'mainmenu','Split Menu','split-menu','?ja_menu=split','url',1,75,0,1,1,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(78,'mainmenu','Dropline Menu','dropline-menu','?ja_menu=dropline','url',-2,0,0,0,35,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=icon-4.png\n\n',0,0,0),
(79,'mainmenu','Mega menu','mega-menu','?ja_menu=mega','url',1,75,0,1,4,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(80,'mainmenu','Dropline menu','dropline','?ja_menu=dropline','url',1,75,0,1,3,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(81,'mainmenu','Menu showcase','menu-showcase','index.php?option=com_content&view=archive','component',-2,0,20,0,37,0,'0000-00-00 00:00:00',0,0,0,0,'orderby=\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(73,'mainmenu','RTL Languages Demo!','rlt-languages-demo','?direction=rtl','url',1,72,0,1,1,62,'2010-01-07 16:02:45',0,0,0,0,'menu_image=-1\n\n',0,0,0),
(74,'mainmenu','LTR Languages Demo!','ltr-languages-demo','?direction=ltr','url',1,72,0,1,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\n\n',0,0,0),
(75,'mainmenu','Menu showcase','menu-showcase','index.php?option=com_content&view=article&id=20','component',1,0,20,0,9,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(51,'usermenu','Submit an Article','submit-an-article','index.php?option=com_content&view=article&layout=form','component',1,0,20,0,2,0,'0000-00-00 00:00:00',0,0,2,0,'',0,0,0),
(52,'usermenu','Submit a Web Link','submit-a-web-link','index.php?option=com_weblinks&view=weblink&layout=form','component',1,0,4,0,3,0,'0000-00-00 00:00:00',0,0,2,0,'',0,0,0),
(71,'mainmenu','Shop','shop','index.php?option=com_virtuemart','component',-2,0,34,0,34,0,'0000-00-00 00:00:00',0,0,0,0,'product_id=\ncategory_id=\nflypage=\npage=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(72,'mainmenu','RTL Languages','rtl-languages','index.php?option=com_content&view=article&id=26','component',1,0,20,0,14,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(62,'mainmenu','All extra modules','all-extra-modules','index.php?option=com_content&view=article&id=22','component',-2,0,20,0,20,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(70,'mainmenu','Without extra modules','without-extra-modules','index.php?option=com_content&view=article&id=12','component',-2,0,20,0,19,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(53,'mainmenu','Explore','explore','index.php?option=com_content&view=category&layout=blog&id=25','component',-2,0,20,0,33,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=5\nnum_columns=1\nnum_links=3\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=3\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=mod\nmega_subcontent-mod-modules=2\n\n',0,0,0),
(58,'mainmenu','Layouts','layouts','index.php?option=com_content&view=article&id=24','component',1,37,20,1,1,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(59,'mainmenu','Wrapper (full width)','wrapper-full-width','index.php?option=com_wrapper&view=wrapper','component',1,58,17,2,4,0,'0000-00-00 00:00:00',0,0,0,0,'url=www.google.com\nscrolling=auto\nwidth=100%\nheight=500\nheight_auto=0\nadd_scheme=1\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n',0,0,0),
(60,'mainmenu','Default (left + main + right)','default','?main_layout=default','url',-2,0,0,0,25,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(100,'mainmenu','Left + Main + Right (square)','left-main-right-square','?main_layout=left-main-right.square','url',-2,0,0,0,24,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(101,'mainmenu','Left + Right + Main (rounded)','left-right-main-rounded','?main_layout=left-right-main.round','url',-2,0,0,0,23,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(50,'mainmenu','The News','the-news','index.php?option=com_content&view=category&layout=blog&id=1','component',1,95,20,2,9,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=1\nnum_links=4\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=The News\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(49,'mainmenu','News Feeds','news-feeds','index.php?option=com_newsfeeds&view=categories','component',1,95,11,2,8,0,'0000-00-00 00:00:00',0,0,0,0,'show_limit=1\nshow_comp_description=1\ncomp_description=\nimage=-1\nimage_align=right\nshow_headings=1\nshow_name=1\nshow_articles=1\nshow_link=1\nshow_cat_description=1\nshow_cat_items=1\nshow_feed_image=1\nshow_feed_description=1\nshow_item_description=1\nfeed_word_count=0\npage_title=Newsfeeds\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(48,'mainmenu','Web Links','web-links','index.php?option=com_weblinks&view=categories','component',1,95,4,2,5,0,'0000-00-00 00:00:00',0,0,0,0,'image=-1\nimage_align=right\nshow_feed_link=1\nshow_comp_description=1\ncomp_description=\nshow_link_hits=1\nshow_link_description=1\nshow_other_cats=1\nshow_headings=1\ntarget=\nlink_icons=\npage_title=Weblinks\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(37,'mainmenu','About Joomla!','about-joomla','index.php?option=com_content&view=section&id=4','component',1,0,20,0,10,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=3\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(34,'mainmenu','What\'s New in 1.5?','what-is-new-in-1-5','index.php?option=com_content&view=article&id=22','component',-2,0,20,0,31,0,'0000-00-00 00:00:00',0,0,0,0,'pageclass_sfx=\nmenu_image=-1\nsecure=0\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\n\n',0,0,0),
(41,'mainmenu','FAQ','faq','index.php?option=com_content&view=section&id=3','component',1,95,20,2,7,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(1,'mainmenu','Home','home','index.php?option=com_content&view=frontpage','component',1,0,20,0,4,0,'0000-00-00 00:00:00',0,0,0,3,'num_leading_articles=0\nnum_intro_articles=1\nnum_columns=1\nnum_links=0\norderby_pri=\norderby_sec=front\nmulti_column_order=1\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=0\nshow_create_date=0\nshow_modify_date=0\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=0\nshow_pdf_icon=0\nshow_print_icon=0\nshow_email_icon=0\nshow_hits=0\nfeed_summary=\npage_title=Say hello to JA Ores\nshow_page_title=0\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,1),
(27,'mainmenu','Joomla! Overview','joomla-overview','index.php?option=com_content&view=article&id=19','component',1,95,20,2,3,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=0\nshow_title=\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(2,'mainmenu','Joomla! License','joomla-license','index.php?option=com_content&view=article&id=5','component',1,95,20,2,4,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=0\nshow_title=\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=1\nshow_create_date=1\nshow_modify_date=1\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(87,'mainmenu','Demo Content','demo','index.php?option=com_content&view=section&id=1','component',-2,0,20,0,32,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(88,'mainmenu','Typography','typography','index.php?option=com_content&view=article&id=59','component',1,0,20,0,5,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(89,'mainmenu','Colors','colors','index.php?option=com_content&view=article&id=48','component',1,0,20,0,13,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=2\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(90,'mainmenu','Default color','default-color','?ja_color=default&jacomment_theme=ja-ores-dark','url',1,116,0,2,1,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(91,'mainmenu','Blue Color','blue-color','?ja_color=dark-blue&jacomment_theme=ja-ores-dark','url',1,116,0,2,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(92,'mainmenu','Green Color','green-color','?ja_color=dark-green&jacomment_theme=ja-ores-dark','url',1,116,0,2,8,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(93,'mainmenu','Orange Color','orange-color','?ja_color=orange','url',-2,0,0,0,18,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(94,'mainmenu','Cream Color','cream-color','?ja_color=dark-cream&jacomment_theme=ja-ores-dark','url',1,116,0,2,3,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(95,'mainmenu','What\'s New in 1.5','whats-new-in-15','index.php?option=com_content&view=section&id=5','component',1,37,20,1,2,62,'2010-02-01 18:12:03',0,0,0,0,'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(96,'mainmenu','JA Ores other','ja-ores-other','index.php?option=com_content&view=article&id=24','component',-2,0,20,0,27,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(97,'mainmenu','Polls','polls','index.php?option=com_content&view=article&id=20','component',1,37,20,1,3,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=mod\nmega_subcontent-mod-modules=16\n\n',0,0,0),
(98,'mainmenu','Content + 1 Col','content-1-col','index.php?option=com_content&view=article&id=24','component',-2,0,20,0,28,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(99,'mainmenu','Left + Body + Right','leftbodyright','?main_layout=left-body-right','url',-2,0,0,0,22,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(102,'mainmenu','Left + Right + Body','leftrightbody','?main_layout=left-right-body','url',1,58,0,2,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(103,'mainmenu','Left + Right + Main (square)','left-right-main-square','?main_layout=left-right-main.square','url',-2,0,0,0,21,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(104,'mainmenu','Body + Left + Right','bodyleftright','?main_layout=body-left-right','url',-2,0,0,0,17,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(106,'mainmenu','Contact Category','contact-category','index.php?option=com_contact&view=category&catid=0','component',1,95,7,2,2,62,'2010-03-20 01:38:35',0,0,0,0,'display_num=20\nimage=-1\nimage_align=right\nshow_limit=0\nshow_feed_link=1\ncontact_icons=\nicon_address=\nicon_email=\nicon_telephone=\nicon_mobile=\nicon_fax=\nicon_misc=\nshow_headings=\nshow_position=\nshow_email=\nshow_telephone=\nshow_mobile=\nshow_fax=\nallow_vcard=\nbanned_email=\nbanned_subject=\nbanned_text=\nvalidate_session=\ncustom_reply=\npage_title=Contact\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(105,'mainmenu','Left + Body + Right','leftbodyright','?main_layout=left-body-right','url',1,58,0,2,3,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(107,'mainmenu','Right + Body + Left','rightbodyleft','?main_layout=right-body-left','url',-2,0,0,0,15,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(108,'mainmenu','Search','search','index.php?option=com_search&view=search','component',1,95,15,2,6,0,'0000-00-00 00:00:00',0,0,0,0,'search_areas=1\nshow_date=\nenabled=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(109,'mainmenu','Blog layout','blog-layout','index.php?option=com_content&view=category&layout=blog&id=37','component',1,0,20,0,7,0,'0000-00-00 00:00:00',0,0,0,3,'show_description=0\nshow_description_image=0\nnum_leading_articles=0\nnum_intro_articles=3\nnum_columns=1\nnum_links=0\norderby_pri=\norderby_sec=\nmulti_column_order=1\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=0\nshow_noauth=1\nshow_title=1\nlink_titles=1\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=1\nlink_category=1\nshow_author=1\nshow_create_date=1\nshow_modify_date=0\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=1\nshow_pdf_icon=1\nshow_print_icon=1\nshow_email_icon=1\nshow_hits=1\nfeed_summary=\npage_title=\nshow_page_title=0\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(110,'mainmenu','Body + Left + Right','bodyleftright','?main_layout=body-left-right','url',1,58,0,2,1,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(111,'mainmenu','Gray Color','gray-color','?ja_color=dark-gray&jacomment_theme=ja-ores-dark','url',1,116,0,2,4,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(112,'mainmenu','Teal Color','teal-color','?ja_color=dark-teal&jacomment_theme=ja-ores-dark','url',1,116,0,2,5,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(113,'mainmenu','Red Color','red-color','?ja_color=dark-red&jacomment_theme=ja-ores-dark','url',1,116,0,2,6,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(114,'mainmenu','Yellow Color','yellow-color','?ja_color=dark-yellow&jacomment_theme=ja-ores-dark','url',1,116,0,2,7,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(115,'mainmenu','Yellow Color','yellow-color','?ja_color=yellow','url',-2,0,0,0,12,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(116,'mainmenu','Dark','dark','index.php?option=com_content&view=archive','component',1,89,20,1,1,0,'0000-00-00 00:00:00',0,0,0,0,'orderby=\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(117,'mainmenu','Default color','default-color','?ja_color=default','url',-2,0,0,0,8,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(118,'mainmenu','Blue Color','blue-color','?ja_color=light-blue&jacomment_theme=ja-ores-light','url',1,125,0,2,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(119,'mainmenu','Green Color','green-color','?ja_color=light-green&jacomment_theme=ja-ores-light','url',1,125,0,2,8,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(120,'mainmenu','Cream Color','cream-color','?ja_color=light-cream&jacomment_theme=ja-ores-light','url',1,125,0,2,3,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(121,'mainmenu','Gray Color','gray-color','?ja_color=light-gray&jacomment_theme=ja-ores-light','url',1,125,0,2,4,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(122,'mainmenu','Teal Color','teal-color','?ja_color=light-teal&jacomment_theme=ja-ores-light','url',1,125,0,2,5,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(123,'mainmenu','Red Color','red-color','?ja_color=light-red&jacomment_theme=ja-ores-light','url',1,125,0,2,6,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(124,'mainmenu','Yellow Color','yellow-color','?ja_color=light-yellow&jacomment_theme=ja-ores-light','url',1,125,0,2,7,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(125,'mainmenu','Light','light','index.php?option=com_content&view=article&id=28','component',1,89,20,1,2,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=1\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(126,'mainmenu','Orange Color','orang-color','?ja_color=light-orange&jacomment_theme=ja-ores-light','url',1,125,0,2,1,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(127,'mainmenu','K2 Showcase','k2','','separator',-2,0,0,0,2,0,'0000-00-00 00:00:00',0,0,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(128,'mainmenu','Item page','item','index.php?option=com_k2&view=item&layout=item&id=1','component',-2,0,40,1,6,0,'0000-00-00 00:00:00',0,0,0,0,'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(129,'mainmenu','K2 Category','our-products','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3','component',1,140,40,1,1,0,'0000-00-00 00:00:00',0,0,0,0,'categories=3\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(130,'mainmenu','Watch','watch','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=5','component',1,129,40,2,1,0,'0000-00-00 00:00:00',0,0,0,0,'categories=5\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(131,'mainmenu','Shoes','shoes','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4','component',1,129,40,2,2,0,'0000-00-00 00:00:00',0,0,0,0,'categories=4\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(132,'mainmenu','Bag','bag','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=7','component',1,129,40,2,3,0,'0000-00-00 00:00:00',0,0,0,0,'categories=7\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(133,'mainmenu','Man\'s suit','man-suit','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=6','component',1,129,40,2,4,0,'0000-00-00 00:00:00',0,0,0,0,'categories=6\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(134,'mainmenu','Company news','company-news','index.php?option=com_k2&view=itemlist&layout=category','component',-2,0,40,0,3,0,'0000-00-00 00:00:00',0,0,0,0,'categories=8|9|10|11\ncatCatalogMode=0\ntheme=ja_ores\nnum_leading_items=1\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=1\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=3\nnum_links_columns=1\nlinksImgSize=XSmall\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatFeedLink=1\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(135,'mainmenu','K2 Latest item','latest-item','index.php?option=com_k2&view=latest&layout=latest','component',1,140,40,1,2,0,'0000-00-00 00:00:00',0,0,0,0,'source=1\nlatestItemsCols=2\nlatestItemsLimit=4\nlatestItemsDisplayEffect=first\nuserName=1\nuserImage=1\nuserDescription=1\nuserURL=1\nuserEmail=1\nuserFeed=0\ncategoryIDs=8|9|10|11\ncategoryTitle=1\ncategoryDescription=1\ncategoryImage=0\ncategoryFeed=0\nlatestItemTitle=1\nlatestItemTitleLinked=1\nlatestItemDateCreated=1\nlatestItemImage=1\nlatestItemImageSize=Medium\nlatestItemVideo=1\nlatestItemVideoWidth=\nlatestItemVideoHeight=\nlatestItemVideoAutoPlay=0\nlatestItemIntroText=1\nlatestItemCategory=1\nlatestItemTags=1\nlatestItemReadMore=1\nlatestItemCommentsAnchor=1\nlatestItemK2Plugins=0\npage_title=\nshow_page_title=0\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(136,'blogroll','JoomlArt\'s Blog','joomlart-blog','http://www.joomlart.com/blog/','url',1,0,0,0,1,0,'0000-00-00 00:00:00',0,1,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(137,'blogroll','Joomlancers','joomlancers','http://www.joomlancers.com','url',1,0,0,0,2,0,'0000-00-00 00:00:00',0,1,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(138,'blogroll','JoomlArt Website','joomlart-website','http://www.joomlart.com','url',1,0,0,0,3,0,'0000-00-00 00:00:00',0,1,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(139,'blogroll','Joomla','joomla','http://www.joomla.org','url',1,0,0,0,4,0,'0000-00-00 00:00:00',0,1,0,0,'menu_image=-1\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(140,'mainmenu','K2 Showcase','k2-showcase','index.php?option=com_content&view=article&id=70','component',1,0,20,0,11,0,'0000-00-00 00:00:00',0,0,0,0,'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(141,'mainmenu','User blog','user-blog','index.php?option=com_k2&view=itemlist&layout=user&id=68&task=user','component',1,140,40,1,3,0,'0000-00-00 00:00:00',0,0,0,0,'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(142,'mainmenu','K2 Item','k2-item','index.php?option=com_k2&view=item&layout=item&id=35','component',1,140,40,1,4,0,'0000-00-00 00:00:00',0,0,0,0,'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(143,'mainmenu','K2 Tag','k2-tag','index.php?option=com_k2&view=itemlist&layout=generic&tag= Fashion&task=tag','component',1,140,40,1,5,0,'0000-00-00 00:00:00',0,0,0,0,'categoriesFilter=5|4|6|7\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(144,'mainmenu','abc','abc','index.php?option=com_content&view=section&layout=blog&id=4','component',-2,0,20,0,1,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0),
(145,'mainmenu','Article Category in Blog','article-category-in-blog','index.php?option=com_content&view=category&layout=blog&id=37','component',0,0,20,0,16,0,'0000-00-00 00:00:00',0,0,0,0,'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=1\nnum_links=4\norderby_pri=\norderby_sec=\nmulti_column_order=0\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\nmega_showtitle=1\nmega_desc=\nmega_cols=1\nmega_group=0\nmega_width=\nmega_colw=\nmega_colxw=\nmega_class=\nmega_subcontent=0\n\n',0,0,0);


DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(75) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL DEFAULT '',
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
INSERT INTO `#__menu_types` VALUES
(1,'mainmenu','Main Menu','The main menu for the site'),
(2,'usermenu','User Menu','A Menu for logged in Users'),
(3,'topmenu','Top Menu','Top level navigation'),
(4,'othermenu','Resources','Additional links'),
(5,'ExamplePages','Example Pages','Example Pages'),
(6,'keyconcepts','Key Concepts','This describes some critical information for new Users.'),
(7,'blogroll','Blogroll','Blogroll');


DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` int(10) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` int(11) NOT NULL DEFAULT '0',
  `priority` int(1) unsigned NOT NULL DEFAULT '0',
  `subject` text NOT NULL,
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__migration_backlinks`;
CREATE TABLE `#__migration_backlinks` (
  `itemid` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `url` text NOT NULL,
  `sefurl` text NOT NULL,
  `newurl` text NOT NULL,
  PRIMARY KEY (`itemid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` text NOT NULL,
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) DEFAULT NULL,
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `numnews` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `iscore` tinyint(4) NOT NULL DEFAULT '0',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `control` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`)
) ENGINE=MyISAM AUTO_INCREMENT=93 DEFAULT CHARSET=utf8;
INSERT INTO `#__modules` VALUES
(1,'Main menu','',1,'left',0,'0000-00-00 00:00:00',1,'mod_mainmenu',0,0,1,'menutype=mainmenu\nmenu_style=list\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=\nmoduleclass_sfx=_menu\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nmenu_images_link=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\n\n',1,0,''),
(2,'Login','',1,'login',0,'0000-00-00 00:00:00',1,'mod_login',0,0,1,'',1,1,''),
(3,'Popular','',3,'cpanel',0,'0000-00-00 00:00:00',1,'mod_popular',0,2,1,'',0,1,''),
(4,'Recent added Articles','',4,'cpanel',0,'0000-00-00 00:00:00',1,'mod_latest',0,2,1,'ordering=c_dsc\nuser_id=0\ncache=0\n\n',0,1,''),
(5,'Menu Stats','',5,'cpanel',0,'0000-00-00 00:00:00',1,'mod_stats',0,2,1,'',0,1,''),
(6,'Unread Messages','',1,'header',0,'0000-00-00 00:00:00',1,'mod_unread',0,2,1,'',1,1,''),
(7,'Online Users','',2,'header',0,'0000-00-00 00:00:00',1,'mod_online',0,2,1,'',1,1,''),
(8,'Toolbar','',1,'toolbar',0,'0000-00-00 00:00:00',1,'mod_toolbar',0,2,1,'',1,1,''),
(9,'Quick Icons','',1,'icon',0,'0000-00-00 00:00:00',1,'mod_quickicon',0,2,1,'',1,1,''),
(10,'Logged in Users','',2,'cpanel',0,'0000-00-00 00:00:00',1,'mod_logged',0,2,1,'',0,1,''),
(11,'Footer','',0,'footer',0,'0000-00-00 00:00:00',1,'mod_footer',0,0,1,'',1,1,''),
(12,'Admin Menu','',1,'menu',0,'0000-00-00 00:00:00',1,'mod_menu',0,2,1,'',0,1,''),
(13,'Admin SubMenu','',1,'submenu',0,'0000-00-00 00:00:00',1,'mod_submenu',0,2,1,'',0,1,''),
(14,'User Status','',1,'status',0,'0000-00-00 00:00:00',1,'mod_status',0,2,1,'',0,1,''),
(15,'Title','',1,'title',0,'0000-00-00 00:00:00',1,'mod_title',0,2,1,'',0,1,''),
(16,'Polls','',0,'polls',0,'0000-00-00 00:00:00',1,'mod_poll',0,0,0,'id=14\nmoduleclass_sfx=_blank\ncache=1\ncache_time=900\n\n',0,0,''),
(17,'User Menu','',7,'left',0,'0000-00-00 00:00:00',0,'mod_mainmenu',0,1,1,'menutype=usermenu\nmoduleclass_sfx=_menu\ncache=1',1,0,''),
(20,'Statistics','',4,'left',0,'0000-00-00 00:00:00',1,'mod_stats',0,0,1,'serverinfo=0\nsiteinfo=1\ncounter=1\nincrease=0\nmoduleclass_sfx=\ncache=0\ncache_time=900\n\n',0,0,''),
(21,'Who\'s Online','',12,'right',0,'0000-00-00 00:00:00',1,'mod_whosonline',0,0,1,'cache=0\nshowmode=0\nmoduleclass_sfx=\n\n',0,0,''),
(23,'Archive','',9,'left',0,'0000-00-00 00:00:00',0,'mod_archive',0,0,1,'cache=1',1,0,''),
(24,'Sections','',10,'left',0,'0000-00-00 00:00:00',0,'mod_sections',0,0,1,'cache=1',1,0,''),
(25,'Newsflash','',1,'top',0,'0000-00-00 00:00:00',0,'mod_newsflash',0,0,1,'catid=3\r\nstyle=random\r\nitems=\r\nmoduleclass_sfx=',0,0,''),
(26,'Related Items','',11,'left',0,'0000-00-00 00:00:00',0,'mod_related_items',0,0,1,'',0,0,''),
(27,'Search','',0,'search',0,'0000-00-00 00:00:00',1,'mod_search',0,0,0,'moduleclass_sfx=\nwidth=20\ntext=Enter the keyword\nbutton=1\nbutton_pos=right\nimagebutton=\nbutton_text=\nset_itemid=\ncache=0\ncache_time=900\n\n',0,0,''),
(28,'Random Image','',7,'right',0,'0000-00-00 00:00:00',0,'mod_random_image',0,0,1,'type=jpg\nfolder=\nlink=\nwidth=\nheight=\nmoduleclass_sfx=\ncache=0\ncache_time=900\n\n',0,0,''),
(29,'Top Menu','',0,'footnav',0,'0000-00-00 00:00:00',1,'mod_mainmenu',0,0,0,'menutype=topmenu\nmenu_style=list_flat\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=-nav\nmoduleclass_sfx=\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nmenu_images_link=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=-1\nindent_image2=-1\nindent_image3=-1\nindent_image4=-1\nindent_image5=-1\nindent_image6=-1\nspacer=\nend_spacer=\n\n',1,0,''),
(30,'Banners','',2,'footer',0,'0000-00-00 00:00:00',0,'mod_banners',0,0,0,'target=1\ncount=1\ncid=1\ncatid=33\ntag_search=0\nordering=random\nheader_text=\nfooter_text=\nmoduleclass_sfx=\ncache=1\ncache_time=15\n\n',1,0,''),
(31,'Resources','',6,'left',0,'0000-00-00 00:00:00',0,'mod_mainmenu',0,0,1,'menutype=othermenu\nmenu_style=list\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=\nmoduleclass_sfx=_menu\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\n\n',0,0,''),
(32,'Wrapper','',12,'left',0,'0000-00-00 00:00:00',0,'mod_wrapper',0,0,1,'',0,0,''),
(33,'Footer','',1,'footer',0,'0000-00-00 00:00:00',1,'mod_footer',0,0,0,'cache=1\n\n',1,0,''),
(34,'Feed Display','',13,'left',0,'0000-00-00 00:00:00',0,'mod_feed',0,0,1,'',1,0,''),
(35,'Breadcrumbs','',1,'breadcrumb',0,'0000-00-00 00:00:00',1,'mod_breadcrumbs',0,0,1,'moduleclass_sfx=\ncache=0\nshowHome=1\nhomeText=Home\nshowComponent=1\nseparator=\n\n',1,0,''),
(36,'Syndication','',3,'syndicate',0,'0000-00-00 00:00:00',1,'mod_syndicate',0,0,0,'',1,0,''),
(39,'Example Pages','',8,'left',0,'0000-00-00 00:00:00',0,'mod_mainmenu',0,0,1,'cache=1\nclass_sfx=\nmoduleclass_sfx=_menu\nmenutype=ExamplePages\nmenu_style=list_flat\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nfull_active_id=0\nmenu_images=0\nmenu_images_align=0\nexpand_menu=0\nactivate_parent=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\nwindow_open=\n\n',0,0,''),
(40,'Key Concepts','',2,'left',0,'0000-00-00 00:00:00',1,'mod_mainmenu',0,0,1,'menutype=keyconcepts\nmenu_style=list\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=\nmoduleclass_sfx=_menu\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nmenu_images_link=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\n\n',0,0,''),
(41,'Welcome to Joomla!','<div style=\"padding: 5px\">  <p>   Congratulations on choosing Joomla! as your content management system. To   help you get started, check out these excellent resources for securing your   server and pointers to documentation and other helpful resources. </p> <p>   <strong>Security</strong><br /> </p> <p>   On the Internet, security is always a concern. For that reason, you are   encouraged to subscribe to the   <a href=\"http://feedburner.google.com/fb/a/mailverify?uri=JoomlaSecurityNews\" target=\"_blank\">Joomla!   Security Announcements</a> for the latest information on new Joomla! releases,   emailed to you automatically. </p> <p>   If this is one of your first Web sites, security considerations may   seem complicated and intimidating. There are three simple steps that go a long   way towards securing a Web site: (1) regular backups; (2) prompt updates to the   <a href=\"http://www.joomla.org/download.html\" target=\"_blank\">latest Joomla! release;</a> and (3) a <a href=\"http://docs.joomla.org/Security_Checklist_2_-_Hosting_and_Server_Setup\" target=\"_blank\" title=\"good Web host\">good Web host</a>. There are many other important security considerations that you can learn about by reading the <a href=\"http://docs.joomla.org/Category:Security_Checklist\" target=\"_blank\" title=\"Joomla! Security Checklist\">Joomla! Security Checklist</a>. </p> <p>If you believe your Web site was attacked, or you think you have discovered a security issue in Joomla!, please do not post it in the Joomla! forums. Publishing this information could put other Web sites at risk. Instead, report possible security vulnerabilities to the <a href=\"http://developer.joomla.org/security/contact-the-team.html\" target=\"_blank\" title=\"Joomla! Security Task Force\">Joomla! Security Task Force</a>.</p><p><strong>Learning Joomla!</strong> </p> <p>   A good place to start learning Joomla! is the   \"<a href=\"http://docs.joomla.org/beginners\" target=\"_blank\">Absolute Beginner\'s   Guide to Joomla!.</a>\" There, you will find a Quick Start to Joomla!   <a href=\"http://help.joomla.org/ghop/feb2008/task048/joomla_15_quickstart.pdf\" target=\"_blank\">guide</a>   and <a href=\"http://help.joomla.org/ghop/feb2008/task167/index.html\" target=\"_blank\">video</a>,   amongst many other tutorials. The   <a href=\"http://community.joomla.org/magazine/view-all-issues.html\" target=\"_blank\">Joomla!   Community Magazine</a> also has   <a href=\"http://community.joomla.org/magazine/article/522-introductory-learning-joomla-using-sample-data.html\" target=\"_blank\">articles   for new learners</a> and experienced users, alike. A great place to look for   answers is the   <a href=\"http://docs.joomla.org/Category:FAQ\" target=\"_blank\">Frequently Asked   Questions (FAQ)</a>. If you are stuck on a particular screen in the   Administrator (which is where you are now), try clicking the Help toolbar   button to get assistance specific to that page. </p> <p>   If you still have questions, please feel free to use the   <a href=\"http://forum.joomla.org/\" target=\"_blank\">Joomla! Forums.</a> The forums   are an incredibly valuable resource for all levels of Joomla! users. Before   you post a question, though, use the forum search (located at the top of each   forum page) to see if the question has been asked and answered. </p> <p>   <strong>Getting Involved</strong> </p> <p>   <a name=\"twjs\" title=\"twjs\"></a> If you want to help make Joomla! better, consider getting   involved. There are   <a href=\"http://www.joomla.org/about-joomla/contribute-to-joomla.html\" target=\"_blank\">many ways   you can make a positive difference.</a> Have fun using Joomla!.</p></div>',0,'cpanel',0,'0000-00-00 00:00:00',1,'mod_custom',0,2,1,'moduleclass_sfx=\n\n',1,1,''),
(42,'Joomla! Security Newsfeed','',6,'cpanel',62,'2008-10-25 20:15:17',1,'mod_feed',0,0,1,'cache=1\ncache_time=15\nmoduleclass_sfx=\nrssurl=http://feeds.joomla.org/JoomlaSecurityNews\nrssrtl=0\nrsstitle=1\nrssdesc=0\nrssimage=1\nrssitems=1\nrssitemdesc=1\nword_count=0\n\n',0,1,''),
(46,'Twitter','',5,'left',62,'2010-03-23 00:15:23',1,'mod_jatwitter',0,0,1,'moduleclass_sfx=\ntaccount=joomlart\nusername=admin\npassword=admin\ntwitter_method=user_timeline\nshow_username=1\nshow_icon=0\nicon_size=30\nshow_limit=2\ntweets_cachetime=30\nshow_source=0\nshowtextheading=0\nheadingtext=My Twitter Updates\nshowfollowlink=1\nuse_display_taccount=0\nsize_iconaccount=48\nuse_friends=0\nsize_iconfriend=24\nmax_friends=10\nenable_cache=1\ncache_time=5\nuse_legacy=1\ndisplayitem=1\n\n',0,0,''),
(45,'Popular Entries','',4,'right',0,'0000-00-00 00:00:00',1,'mod_jabulletin',0,0,1,'type=mostread\nmoduleclass_sfx=_havecolor\ncategory=25\ncount=5\nshow_front=1\nshow_date=1\nshow_image=1\nthumbnail_mode=crop\nthumbnail_mode-resize-use_ratio=1\nwidth=0\nheight=0\ncache=1\ncache_time=30\n\n',0,0,''),
(69,'Testimonials','',0,'col-mass1',0,'0000-00-00 00:00:00',1,'mod_ja_contentslide',0,0,1,'moduleclass_sfx=_havecolor blockquoteslide\ncatid=\nsort_order_field=created\nsort_order=DESC\nnumElem=1\nmaxitems=3\nlink_titles=1\nnumchar=130\nxheight=60\nxwidth=410\nshowimages=0\niheight=90\niwidth=130\nauto=1\ndirection=left\nmode=horizontal\ndelaytime=5000\nanimationtime=1000\nshowtitle=1\nshowbutton=1\nshowreadmore=0\nshowintrotext=1\nenable_cache=1\ncache_time=300\nmootools=0\nsource-articles-images-thumbnail_mode=crop\nsource-articles-images-thumbnail_mode-resize-use_ratio=0\n\n',0,0,''),
(70,'Testimonials','',10,'right',62,'2010-03-04 07:15:16',0,'mod_ja_contentslide',0,0,1,'moduleclass_sfx=\ncatid=1\nsort_order_field=created\nsort_order=DESC\nnumElem=3\nmaxitems=10\nlink_titles=1\nnumchar=50\nxheight=170\nxwidth=140\nshowimages=0\niheight=90\niwidth=130\nauto=1\ndirection=left\nmode=horizontal\ndelaytime=5000\nanimationtime=1000\nshowtitle=1\nshowbutton=1\nshowreadmore=0\nshowintrotext=1\nenable_cache=1\ncache_time=300\nmootools=0\nsource-articles-images-thumbnail_mode=crop\nsource-articles-images-thumbnail_mode-resize-use_ratio=0\n\n',0,0,''),
(48,'From Our Blog','',0,'content-mass-bottom',0,'0000-00-00 00:00:00',1,'mod_jasidenews',0,0,1,'moduleclass_sfx=\ndisplay_model=modcats\ndisplay_model-modcats-category=34\nsort_order_field=created\nsort_order=DESC\nmax_items=2\ntitle_max_chars=200\nmaxchars=70\nthumbnail_mode=crop\nthumbnail_mode-resize-use_ratio=1\niwidth=152\niheight=200\nimage_alignment=left\nlayout=default\nlayout-default-showdate=1\nlayout-default-show_moredetail=0\nlayout-default-showimage=0\nlayout-sidenews-height=200\nlayout-sidenews-textcolor=FFFFFF\nlayout-sidenews-bgcolor=008800\nlayout-sidenews-transparent=80\nlayout-sidenews-element_apply_side=content\nlayout-sidenews-play_mode=caption\nlayout-sidenews-play_mode-caption-expandheight=150\nlayout-sidenews-play_mode-caption-collapseheight=30\nlayout-sidenews-animation_transition=Fx.Transitions.Expo.easeOut\nenable_cache=0\ncache_time=30\n\n',0,0,''),
(51,'Our Clients','<div class=\"ja-gallery clearfix\">\r\n<div class=\"ja-thumb\"><a href=\"#\" title=\"Sample link\"><img src=\"images/stories/demo/gallery/thumb-1.jpg\" border=\"0\" alt=\"Sample image\" /></a></div>\r\n<div class=\"ja-thumb last\"><a href=\"#\" title=\"Sample link\"><img class=\"last-image\" src=\"images/stories/demo/gallery/thumb-2.jpg\" border=\"0\" alt=\"Sample image\" /></a></div>\r\n<div class=\"ja-thumb\"><a href=\"#\" title=\"Sample link\"><img src=\"images/stories/demo/gallery/thumb-3.jpg\" border=\"0\" alt=\"Sample image\" /></a></div>\r\n<div class=\"ja-thumb last\"><a href=\"#\" title=\"Sample link\"><img class=\"last-image\" src=\"images/stories/demo/gallery/thumb-4.jpg\" border=\"0\" alt=\"Sample image\" /></a></div>\r\n</div>',9,'right',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(77,'ja-cpanel','',1,'ja-cpanel',0,'0000-00-00 00:00:00',1,'mod_jacpanel',0,0,1,'moduleclass_sfx=\ncpanelid=ja-cpanel\nwidth=0\nheight=0\ntiptext=Show/hide Control panel\n\n',0,0,''),
(72,'Resources','<ul>\r\n<li><a href=\"#\">About us</a></li>\r\n<li><a href=\"#\">FAQ</a></li>\r\n<li><a href=\"#\">Blog</a></li>\r\n<li><a href=\"#\">Contact</a></li>\r\n<li><a href=\"#\">Careers</a></li>\r\n</ul>',0,'user9',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=_linkWhite\n\n',0,0,''),
(73,'Statistics','<p>OS : Linux J<br /> PHP : 5.2.6-3ubuntu4<br /> MySQL : 5.0.75-0ubuntu10<br /> Oubuntu10<br /> Time : 03:27<br /> Caching : Disabled<br /> GZIP : Disabled<br /> Members : 4</p>',0,'user10',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=_colorGrey\n\n',0,0,''),
(53,'Multi Menu','<p>Rhoncus sed. Lectus vitae augue, mauris tincidunt. Ut nec fermentum.</p>\r\n<div class=\"clearfix\">\r\n<div style=\"width: 48%; float: left;\">\r\n<ul>\r\n<li><a href=\"?ja_menu=split\">Split Menu</a></li>\r\n<li><a href=\"?ja_menu=dropline\">Dropline Menu</a></li>\r\n</ul>\r\n</div>\r\n<div style=\"width: 48%; float: right;\">\r\n<ul>\r\n<li><a href=\"?ja_menu=css\">CSS Menu</a></li>\r\n<li><a href=\"?ja_menu=mega\">Mega Menu</a></li>\r\n</ul>\r\n</div>\r\n</div>',0,'user7',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx= testimonialModule\n\n',0,0,''),
(78,'Bright Business ','',0,'slideshow',0,'0000-00-00 00:00:00',1,'mod_jaslideshow2',0,0,1,'moduleclass_sfx=\nsource=articles\nsource-articles-display_model=modcats\nsource-articles-display_model-modarts-with_keyword=featured\nsource-articles-display_model-modcats-category=36\nsource-articles-sort_order_field=ordering\nsource-articles-sort_order=ASC\nsource-articles-max_items=3\nsource-images-orderby=0\nsource-images-sort=0\nfolder=images/stories/fruit\ndescription=\nautoplay=0\nmainWidth=580\nmainHeight=350\nstartItem=0\nanimation=move\ncontainer=0\nduration=700\neffect=Fx.Transitions.Quad.easeInOut\ninterval=5000\nanimationRepeat=yes\nshowdesc=desc\nreadmoretext=Readmore\ntitle_max_chars=200\nmaxchars=250\ndescOpacity=1\nshowdescwhen=load\nmasker-alignment=left\nmasker-width=auto\nmasker-height=auto\nmasker-transition-style=style\nmarker-transition=Fx.Transitions.Quad.easeOut\nnavigation=thumbs\nsource-articles-navwidth=240\nsource-articles-navheight=100\nnavigation-alignment=vertical_right\nshowItem=3\nnav_showthumb=1\nthumbWidth=60\nthumbHeight=60\nthumbSpace=3:3\nthumbOpacity=0.8\nsource-articles-nav_showdate=0\nsource-articles-nav_showdesc=1\nsource-articles-nav_descmaxlength=50\ncontrol=0\noverlapOpacity=0.4\nenable_cache=0\ncache_time=30\nopen_target=parent\nsource-articles-images-thumbnail_mode=crop\nsource-articles-images-thumbnail_mode-resize-use_ratio=1\n\n',0,0,''),
(54,'T3 Framework','<p>Integer nec adipiscing nibh dui tellus ivamus leo et eget metus. Amet urna el incidunt pellentesque Praesent lacus convallis urna vel incidunt pellentesque Praesent lacus convallis...</p>',0,'user5',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(57,'License','<p class=\"text\">Condimentum dolor eu magna egestas neque vitae laoreet sed Sed purus. Phasellus Vestibulum velit elit nulla Lorem scelerisque vestibulum. Turpis lobortis Nam velit ac Integer pretium enim natoque tempus mauris. Ut nulla nec sollicitudin est tortor Aenean vel est netus phasellus. <a href=\"#\">More info</a></p>',0,'user11',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(75,'What is Joomla?','<a href=\"#\" title=\"Joomla\">Joomla</a> is an award-winning content management system (CMS), which enables you to build Web sites and powerful online applications ...<br /><br />\r\n\r\nPellentesque Praesent lacus convallis...',0,'user8',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(59,'About us','<img src=\"images/stories/demo/sam-1.jpg\" border=\"0\" alt=\"Joomla! Community Portal\" title=\"About JA Ores\" align=\"right\" />\r\n\r\n<a href=\"http://joomla.org\" target=\"_blank\" title=\"Joomla! Events\">Eros magna erat ut</a>, id libero pede in a. Quam dolor in nisl eleifend, vestibulum frin lorem isphum...',0,'top',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=\n\n',0,0,''),
(65,'Planning','<img class=\"caption\" src=\"images/stories/demo/sam-1.jpg\" border=\"0\" alt=\"planning\" align=\"left\" />\r\n<h3 class=\"clearfix\"><span>Planning</span></h3>\r\n<p>Sed et odio libero. Vestibulum aliquet aliquet blandit. Sed non orci ut enim <a href=\"#\">mattis placerat</a>. Enean ultrices massa id magna scelerisque quis accumsan lorem interdum lorem.</p>\r\n<p><a class=\"readon\" href=\"#\" title=\"New Idea: Massive Mac Desktop\"><span>+ More info...</span></a></p>',0,'user1',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=\n\n',0,0,''),
(63,'Login Form','',0,'login',0,'0000-00-00 00:00:00',1,'mod_login',0,0,0,'cache=0\nmoduleclass_sfx=\npretext=\nposttext=\nlogin=\nlogout=\ngreeting=1\nname=0\nusesecure=0\n\n',0,0,''),
(66,'Drawing by hand','<img class=\"caption\" src=\"images/stories/demo/sam-2.jpg\" border=\"0\" alt=\"planning\" align=\"left\" />\r\n<h3 class=\"clearfix\"><span>Drawing by hand</span></h3>\r\n<p>Fusce euismod consequat ante. Lorem ipsum dolor sit met, consectetuer adipiscing elitelue sed dolor. <a href=\"#\" title=\"Sample link\">Aliquam congue</a> fermentum nisl. Mauris...</p>\r\n<p><a class=\"readon\" href=\"#\" title=\"New Idea: Massive Mac Desktop\"><span>+ More info...</span></a></p>',0,'user2',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=\n\n',0,0,''),
(67,'Comments','<img class=\"caption\" src=\"images/stories/demo/sam-3.jpg\" border=\"0\" alt=\"planning\" align=\"left\" />\r\n<h3 class=\"clearfix\"><span>Comments</span></h3>\r\n<p><a href=\"#\" title=\"Sample link\">Pellentesque sed dolor.</a> Aliquam congue fermentum nisla ris accumsan nulla vel diam. Sed in lacus ut enim adipiscing aliquet. Nulla venenatis. In pede mi.</p>\r\n<p><a class=\"readon\" href=\"#\" title=\"New Idea: Massive Mac Desktop\"> <span>+ More info...</span> </a></p>',0,'user3',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=\n\n',0,0,''),
(68,'Collaboration','<img class=\"caption\" src=\"images/stories/demo/sam-4.jpg\" border=\"0\" alt=\"planning\" align=\"left\" />\r\n<h3 class=\"clearfix\"><span>Collaboration</span></h3>\r\n<p>Sed in lacus ut enim adipiscing aliquet. Nulla venenatis. <a href=\"#\">In pede mi</a>, aliquet sit amet, euismod in, auctor ut, ligula. Aliquam dapibus tincidunt metusra esent...</p>\r\n<p><a class=\"readon\" href=\"#\" title=\"New Idea: Massive Mac Desktop\"> <span>+ More info...</span> </a></p>',0,'user4',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=\n\n',0,0,''),
(71,'16 Preset Styles','<p>Rhoncus sed. Lectus vitae augue, mauris tincidunt. Ut nec fermentum, dolor vestibulum.</p>\r\n<p>Orange, Blue, Cream, Gray, Teal, Red, Yellow, Green</p>',0,'user6',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(74,'Support Center','Eros magna erat ut, id libero pede in a. Quam dolor in nisl eleifend, vestibulum fringilla ultrices sed vivamus.<br />\r\n\r\n<ul class=\"address\">\r\n<li><strong>Tel:</strong> (+844) 2212820</li>\r\n<li><strong>Fax:</strong> (+844) 2212820</li>\r\n<li><strong>Email:</strong> <a href=\"mailto:contact@joomlart.com\">contact@joomlart.com</a></li>\r\n<li><strong>Website:</strong> <a href=\"http://www.joomlart.com\">www.joomlart.com</a></li>\r\n</ul>',0,'user12',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=\n\n',0,0,''),
(79,'About Static','<p>Bright Business Solutions & Ideas</p>',0,'slideshow',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,0,'moduleclass_sfx=_about\n\n',0,0,''),
(80,'Our Designers','<div class=\"ja-gallery clearfix\">\r\n<div class=\"ja-thumb\"><img src=\"images/stories/demo/gallery/image-1.jpg\" border=\"0\" alt=\"Sample image\" /></div>\r\n<div class=\"ja-thumb last\"><img class=\"last-image\" src=\"images/stories/demo/gallery/image-2.jpg\" border=\"0\" alt=\"Sample image\" /></div>\r\n<div class=\"ja-thumb\"><img src=\"images/stories/demo/gallery/image-3.jpg\" border=\"0\" alt=\"Sample image\" /></div>\r\n<div class=\"ja-thumb last\"><img class=\"last-image\" src=\"images/stories/demo/gallery/image-4.jpg\" border=\"0\" alt=\"Sample image\" /></div>\r\n</div>',3,'right',0,'0000-00-00 00:00:00',1,'mod_custom',0,0,1,'moduleclass_sfx=_havecolor\n\n',0,0,''),
(92,'Hot news','',0,'hotnews',0,'0000-00-00 00:00:00',1,'mod_janewsticker',0,0,1,'moduleclass_sfx=\nusing_mode=categories_selected\ncategory=1\nsort_order_field=created\nsort_order=DESC\nmax_items=10\ntitle_max_chars=200\nanimation_type=opacity\nanimation_speed=3000\nanimation_interval=3000\nanimation_transition=Fx.Transitions.Circ.easeIn\nshow_headtext=0\nheadtext=Headlines:\nshow_buttons_control=1\nenable_cache=1\ncache_time=30\n\n',0,0,''),
(89,'Blogroll','',11,'right',0,'0000-00-00 00:00:00',1,'mod_mainmenu',0,0,1,'menutype=blogroll\nmenu_style=list\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=\nmoduleclass_sfx=\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nmenu_images_link=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\n\n',0,0,''),
(81,'Recent comments','<ul class=\"recent-comments clearfix\">\r\n<li> <span class=\"user_comment\">Dzuc on </span> <a class=\"item-comment\" href=\"#\">Id iaculis id, pulvinar ut imperdiet</a> </li>\r\n<li> <span class=\"user_comment\">Sasuka on </span> <a class=\"item-comment\" href=\"#\">Lorem ispum dolo siamet</a> </li>\r\n<li> <span class=\"user_comment\">Mihiro on </span> <a class=\"item-comment\" href=\"#\">Gravida scelerisque, ispum</a> </li>\r\n<li> <span class=\"user_comment\">Mihiro on </span> <a class=\"item-comment\" href=\"#\">Cras ante eros</a> </li>\r\n</ul>',8,'right',0,'0000-00-00 00:00:00',0,'mod_custom',0,0,1,'moduleclass_sfx=_havecolor\n\n',0,0,''),
(82,'Latest Comments','',2,'right',0,'0000-00-00 00:00:00',1,'mod_k2_comments',0,0,1,'moduleclass_sfx=\nmodule_usage=0\ncatfilter=0\ncomments_limit=2\ncomments_word_limit=10\ncommenterName=0\ncommentAvatar=1\ncommentDate=0\ncommentDateFormat=absolute\ncommentLink=1\nitemTitle=1\nitemCategory=0\nfeed=0\ncommenters_limit=5\ncommenterAvatar=1\ncommenterLink=1\ncommenterCommentsCounter=1\ncommenterLatestComment=1\ncache=1\ncache_time=900\n\n',0,0,''),
(83,'Featured products','',0,'right',0,'0000-00-00 00:00:00',1,'mod_k2_content',0,0,1,'moduleclass_sfx=\ngetTemplate=Default\nsource=filter\ncatfilter=0\ngetChildren=0\nitems_limit=10\nitemsOrdering=\nFeaturedItems=2\npopularityRange=\nitem=0\nitemTitle=1\nitemAuthor=0\nitemAuthorAvatar=0\nitemIntroText=1\nitemIntroTextWordLimit=20\nitemImage=1\nitemImgSize=XSmall\nitemVideo=0\nitemVideoCaption=0\nitemVideoCredits=0\nitemAttachments=1\nitemTags=1\nitemCategory=0\nitemDateCreated=0\nitemHits=1\nitemReadMore=1\nitemExtraFields=0\nitemCommentsCounter=0\nfeed=1\nitemPreText=\nitemCustomLink=0\nitemCustomLinkURL=http://\nitemCustomLinkTitle=\ncache=1\ncache_time=900\n\n',0,0,''),
(84,'K2 Login','',6,'right',0,'0000-00-00 00:00:00',1,'mod_k2_login',0,0,1,'moduleclass_sfx=\npretext=\nposttext=\ngreeting=1\nname=1\nuserAvatar=0\nlogin=\nlogout=\nusesecure=0\ncache=0\ncache_time=900\n\n',0,0,''),
(85,'All Category','',5,'right',0,'0000-00-00 00:00:00',1,'mod_k2_tools',0,0,1,'moduleclass_sfx=\nmodule_usage=4\narchiveItemsCounter=1\narchiveCategory=3\nauthors_module_category=3\nauthorItemsCounter=1\nauthorAvatar=1\nauthorLatestItem=1\ncalendarCategory=3\nhome=\nseperator=\nroot_id=0\nend_level=\ncategoriesListOrdering=\ncategoriesListItemsCounter=1\nroot_id2=0\nwidth=20\ntext=\nbutton=\nimagebutton=\nbutton_text=\nmin_size=75\nmax_size=300\ncloud_limit=30\ncache=1\ncache_time=900\n\n',0,0,''),
(86,'K2 QuickIcons (admin)','',99,'icon',0,'0000-00-00 00:00:00',1,'mod_k2_quickicons',0,2,1,'modCSSStyling=1\nmodLogo=1\n',0,1,''),
(90,'Login','',3,'left',0,'0000-00-00 00:00:00',1,'mod_login',0,0,1,'cache=0\nmoduleclass_sfx=\npretext=\nposttext=\nlogin=\nlogout=\ngreeting=1\nname=0\nusesecure=0\n\n',0,0,''),
(91,'JA News Sticker Module','',14,'left',0,'0000-00-00 00:00:00',0,'mod_janewsticker',0,0,1,'',0,0,'');


DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__modules_menu` VALUES
(1,2),
(1,11),
(1,12),
(1,13),
(1,14),
(1,15),
(1,16),
(1,17),
(1,18),
(1,20),
(1,24),
(1,27),
(1,28),
(1,29),
(1,30),
(1,38),
(1,40),
(1,41),
(1,43),
(1,44),
(1,45),
(1,46),
(1,47),
(1,48),
(1,49),
(1,50),
(1,51),
(1,52),
(1,72),
(1,73),
(1,74),
(1,75),
(1,76),
(1,77),
(1,79),
(1,80),
(1,83),
(1,88),
(1,89),
(1,90),
(1,91),
(1,92),
(1,94),
(1,95),
(1,97),
(16,0),
(17,0),
(20,88),
(21,109),
(21,140),
(25,0),
(27,0),
(28,109),
(29,0),
(30,0),
(31,1),
(32,0),
(33,0),
(34,0),
(35,0),
(36,0),
(39,43),
(39,44),
(39,45),
(39,46),
(39,47),
(40,88),
(45,109),
(46,1),
(46,44),
(46,72),
(46,73),
(46,74),
(46,88),
(46,89),
(46,90),
(46,91),
(46,92),
(46,94),
(48,1),
(51,1),
(51,73),
(51,74),
(51,89),
(51,90),
(51,91),
(51,92),
(51,94),
(53,1),
(53,2),
(53,11),
(53,12),
(53,13),
(53,14),
(53,15),
(53,16),
(53,17),
(53,18),
(53,20),
(53,24),
(53,27),
(53,28),
(53,29),
(53,30),
(53,37),
(53,38),
(53,40),
(53,41),
(53,43),
(53,44),
(53,45),
(53,46),
(53,47),
(53,48),
(53,49),
(53,50),
(53,51),
(53,52),
(53,58),
(53,59),
(53,72),
(53,73),
(53,74),
(53,75),
(53,76),
(53,77),
(53,79),
(53,80),
(53,83),
(53,89),
(53,90),
(53,91),
(53,92),
(53,94),
(53,95),
(53,97),
(53,102),
(53,105),
(53,108),
(53,109),
(53,110),
(53,111),
(53,112),
(53,113),
(53,114),
(53,116),
(53,118),
(53,119),
(53,120),
(53,121),
(53,122),
(53,123),
(53,124),
(53,125),
(53,126),
(53,129),
(53,130),
(53,131),
(53,132),
(53,133),
(53,135),
(54,1),
(54,2),
(54,11),
(54,12),
(54,13),
(54,14),
(54,15),
(54,16),
(54,17),
(54,18),
(54,20),
(54,24),
(54,27),
(54,28),
(54,29),
(54,30),
(54,37),
(54,38),
(54,40),
(54,41),
(54,43),
(54,44),
(54,45),
(54,46),
(54,47),
(54,48),
(54,49),
(54,50),
(54,51),
(54,52),
(54,58),
(54,59),
(54,72),
(54,73),
(54,74),
(54,75),
(54,76),
(54,77),
(54,79),
(54,80),
(54,83),
(54,89),
(54,90),
(54,91),
(54,92),
(54,94),
(54,95),
(54,97),
(54,102),
(54,105),
(54,108),
(54,109),
(54,110),
(54,111),
(54,112),
(54,113),
(54,114),
(54,116),
(54,118),
(54,119),
(54,120),
(54,121),
(54,122),
(54,123),
(54,124),
(54,125),
(54,126),
(54,129),
(54,130),
(54,131),
(54,132),
(54,133),
(54,135),
(57,1),
(57,2),
(57,11),
(57,12),
(57,13),
(57,14),
(57,15),
(57,16),
(57,17),
(57,18),
(57,20),
(57,24),
(57,27),
(57,28),
(57,29),
(57,30),
(57,37),
(57,38),
(57,40),
(57,41),
(57,43),
(57,44),
(57,45),
(57,46),
(57,47),
(57,48),
(57,49),
(57,50),
(57,51),
(57,52),
(57,58),
(57,59),
(57,72),
(57,73),
(57,74),
(57,75),
(57,76),
(57,77),
(57,79),
(57,80),
(57,83),
(57,89),
(57,90),
(57,91),
(57,92),
(57,94),
(57,95),
(57,97),
(57,102),
(57,105),
(57,108),
(57,109),
(57,110),
(57,111),
(57,112),
(57,113),
(57,114),
(57,116),
(57,118),
(57,119),
(57,120),
(57,121),
(57,122),
(57,123),
(57,124),
(57,125),
(57,126),
(57,129),
(57,130),
(57,131),
(57,132),
(57,133),
(57,135),
(59,0),
(63,0),
(65,1),
(65,2),
(65,27),
(65,38),
(65,40),
(65,41),
(65,43),
(65,45),
(65,47),
(65,48),
(65,49),
(65,50),
(65,58),
(65,59),
(65,72),
(65,73),
(65,74),
(65,75),
(65,76),
(65,77),
(65,79),
(65,80),
(65,83),
(65,89),
(65,90),
(65,91),
(65,92),
(65,94),
(65,97),
(65,102),
(65,105),
(65,106),
(65,108),
(65,110),
(65,111),
(65,112),
(65,113),
(65,114),
(65,116),
(65,118),
(65,119),
(65,120),
(65,121),
(65,122),
(65,123),
(65,124),
(65,125),
(65,126),
(66,1),
(66,2),
(66,27),
(66,38),
(66,40),
(66,41),
(66,43),
(66,45),
(66,47),
(66,48),
(66,49),
(66,50),
(66,58),
(66,59),
(66,72),
(66,73),
(66,74),
(66,75),
(66,76),
(66,77),
(66,79),
(66,80),
(66,83),
(66,89),
(66,90),
(66,91),
(66,92),
(66,94),
(66,97),
(66,102),
(66,105),
(66,106),
(66,108),
(66,110),
(66,111),
(66,112),
(66,113),
(66,114),
(66,116),
(66,118),
(66,119),
(66,120),
(66,121),
(66,122),
(66,123),
(66,124),
(66,125),
(66,126),
(67,1),
(67,2),
(67,27),
(67,38),
(67,40),
(67,41),
(67,43),
(67,45),
(67,47),
(67,48),
(67,49),
(67,50),
(67,58),
(67,59),
(67,72),
(67,73),
(67,74),
(67,75),
(67,76),
(67,77),
(67,79),
(67,80),
(67,83),
(67,89),
(67,90),
(67,91),
(67,92),
(67,94),
(67,97),
(67,102),
(67,105),
(67,106),
(67,108),
(67,110),
(67,111),
(67,112),
(67,113),
(67,114),
(67,116),
(67,118),
(67,119),
(67,120),
(67,121),
(67,122),
(67,123),
(67,124),
(67,125),
(67,126),
(68,1),
(68,2),
(68,27),
(68,38),
(68,40),
(68,41),
(68,43),
(68,45),
(68,47),
(68,48),
(68,49),
(68,50),
(68,58),
(68,59),
(68,72),
(68,73),
(68,74),
(68,75),
(68,76),
(68,77),
(68,79),
(68,80),
(68,83),
(68,89),
(68,90),
(68,91),
(68,92),
(68,94),
(68,97),
(68,102),
(68,105),
(68,106),
(68,108),
(68,110),
(68,111),
(68,112),
(68,113),
(68,114),
(68,116),
(68,118),
(68,119),
(68,120),
(68,121),
(68,122),
(68,123),
(68,124),
(68,125),
(68,126),
(69,1),
(69,73),
(69,74),
(69,89),
(69,90),
(69,91),
(69,92),
(69,94),
(70,0),
(71,1),
(71,2),
(71,11),
(71,12),
(71,13),
(71,14),
(71,15),
(71,16),
(71,17),
(71,18),
(71,20),
(71,24),
(71,27),
(71,28),
(71,29),
(71,30),
(71,37),
(71,38),
(71,40),
(71,41),
(71,43),
(71,44),
(71,45),
(71,46),
(71,47),
(71,48),
(71,49),
(71,50),
(71,51),
(71,52),
(71,58),
(71,59),
(71,72),
(71,73),
(71,74),
(71,75),
(71,76),
(71,77),
(71,79),
(71,80),
(71,83),
(71,89),
(71,90),
(71,91),
(71,92),
(71,94),
(71,95),
(71,97),
(71,102),
(71,105),
(71,108),
(71,109),
(71,110),
(71,111),
(71,112),
(71,113),
(71,114),
(71,116),
(71,118),
(71,119),
(71,120),
(71,121),
(71,122),
(71,123),
(71,124),
(71,125),
(71,126),
(71,129),
(71,130),
(71,131),
(71,132),
(71,133),
(71,135),
(72,1),
(72,2),
(72,11),
(72,12),
(72,13),
(72,14),
(72,15),
(72,16),
(72,17),
(72,18),
(72,20),
(72,24),
(72,27),
(72,28),
(72,29),
(72,30),
(72,37),
(72,38),
(72,40),
(72,41),
(72,43),
(72,44),
(72,45),
(72,46),
(72,47),
(72,48),
(72,49),
(72,50),
(72,51),
(72,52),
(72,58),
(72,59),
(72,72),
(72,73),
(72,74),
(72,75),
(72,76),
(72,77),
(72,79),
(72,80),
(72,83),
(72,89),
(72,90),
(72,91),
(72,92),
(72,94),
(72,95),
(72,97),
(72,102),
(72,105),
(72,108),
(72,109),
(72,110),
(72,111),
(72,112),
(72,113),
(72,114),
(72,116),
(72,118),
(72,119),
(72,120),
(72,121),
(72,122),
(72,123),
(72,124),
(72,125),
(72,126),
(72,129),
(72,130),
(72,131),
(72,132),
(72,133),
(72,135),
(73,1),
(73,2),
(73,11),
(73,12),
(73,13),
(73,14),
(73,15),
(73,16),
(73,17),
(73,18),
(73,20),
(73,24),
(73,27),
(73,28),
(73,29),
(73,30),
(73,37),
(73,38),
(73,40),
(73,41),
(73,43),
(73,44),
(73,45),
(73,46),
(73,47),
(73,48),
(73,49),
(73,50),
(73,51),
(73,52),
(73,58),
(73,59),
(73,72),
(73,73),
(73,74),
(73,75),
(73,76),
(73,77),
(73,79),
(73,80),
(73,83),
(73,89),
(73,90),
(73,91),
(73,92),
(73,94),
(73,95),
(73,97),
(73,102),
(73,105),
(73,108),
(73,109),
(73,110),
(73,111),
(73,112),
(73,113),
(73,114),
(73,116),
(73,118),
(73,119),
(73,120),
(73,121),
(73,122),
(73,123),
(73,124),
(73,125),
(73,126),
(73,129),
(73,130),
(73,131),
(73,132),
(73,133),
(73,135),
(74,1),
(74,2),
(74,11),
(74,12),
(74,13),
(74,14),
(74,15),
(74,16),
(74,17),
(74,18),
(74,20),
(74,24),
(74,27),
(74,28),
(74,29),
(74,30),
(74,37),
(74,38),
(74,40),
(74,41),
(74,43),
(74,44),
(74,45),
(74,46),
(74,47),
(74,48),
(74,49),
(74,50),
(74,51),
(74,52),
(74,58),
(74,59),
(74,72),
(74,73),
(74,74),
(74,75),
(74,76),
(74,77),
(74,79),
(74,80),
(74,83),
(74,89),
(74,90),
(74,91),
(74,92),
(74,94),
(74,95),
(74,97),
(74,102),
(74,105),
(74,108),
(74,109),
(74,110),
(74,111),
(74,112),
(74,113),
(74,114),
(74,116),
(74,118),
(74,119),
(74,120),
(74,121),
(74,122),
(74,123),
(74,124),
(74,125),
(74,126),
(74,129),
(74,130),
(74,131),
(74,132),
(74,133),
(74,135),
(75,1),
(75,2),
(75,11),
(75,12),
(75,13),
(75,14),
(75,15),
(75,16),
(75,17),
(75,18),
(75,20),
(75,24),
(75,27),
(75,28),
(75,29),
(75,30),
(75,37),
(75,38),
(75,40),
(75,41),
(75,43),
(75,44),
(75,45),
(75,46),
(75,47),
(75,48),
(75,49),
(75,50),
(75,51),
(75,52),
(75,58),
(75,59),
(75,72),
(75,73),
(75,74),
(75,75),
(75,76),
(75,77),
(75,79),
(75,80),
(75,83),
(75,89),
(75,90),
(75,91),
(75,92),
(75,94),
(75,95),
(75,97),
(75,102),
(75,105),
(75,108),
(75,109),
(75,110),
(75,111),
(75,112),
(75,113),
(75,114),
(75,116),
(75,118),
(75,119),
(75,120),
(75,121),
(75,122),
(75,123),
(75,124),
(75,125),
(75,126),
(75,129),
(75,130),
(75,131),
(75,132),
(75,133),
(75,135),
(77,0),
(78,1),
(79,44),
(79,46),
(79,109),
(80,44),
(80,46),
(80,109),
(81,44),
(81,46),
(81,109),
(82,130),
(82,131),
(82,132),
(82,133),
(82,135),
(82,141),
(82,142),
(82,143),
(83,130),
(83,131),
(83,132),
(83,133),
(83,135),
(83,140),
(84,109),
(84,132),
(85,130),
(85,131),
(85,132),
(85,133),
(85,135),
(85,140),
(85,141),
(85,142),
(85,143),
(86,0),
(89,109),
(90,88),
(91,0),
(92,0);


DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `link` text NOT NULL,
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(11) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(11) unsigned NOT NULL DEFAULT '3600',
  `checked_out` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
INSERT INTO `#__newsfeeds` VALUES
(4,1,'Joomla! Announcements','joomla-official-news','http://feeds.joomla.org/JoomlaAnnouncements','',1,5,3600,0,'0000-00-00 00:00:00',1,0),
(4,2,'Joomla! Core Team Blog','joomla-core-team-blog','http://feeds.joomla.org/JoomlaCommunityCoreTeamBlog','',1,5,3600,0,'0000-00-00 00:00:00',2,0),
(4,3,'Joomla! Community Magazine','joomla-community-magazine','http://feeds.joomla.org/JoomlaMagazine','',1,20,3600,0,'0000-00-00 00:00:00',3,0),
(4,4,'Joomla! Developer News','joomla-developer-news','http://feeds.joomla.org/JoomlaDeveloper','',1,5,3600,0,'0000-00-00 00:00:00',4,0),
(4,5,'Joomla! Security News','joomla-security-news','http://feeds.joomla.org/JoomlaSecurityNews','',1,5,3600,0,'0000-00-00 00:00:00',5,0),
(5,6,'Free Software Foundation Blogs','free-software-foundation-blogs','http://www.fsf.org/blogs/RSS',null,1,5,3600,0,'0000-00-00 00:00:00',4,0),
(5,7,'Free Software Foundation','free-software-foundation','http://www.fsf.org/news/RSS',null,1,5,3600,62,'2008-09-14 00:24:25',3,0),
(5,8,'Software Freedom Law Center Blog','software-freedom-law-center-blog','http://www.softwarefreedom.org/feeds/blog/',null,1,5,3600,0,'0000-00-00 00:00:00',2,0),
(5,9,'Software Freedom Law Center News','software-freedom-law-center','http://www.softwarefreedom.org/feeds/news/',null,1,5,3600,0,'0000-00-00 00:00:00',1,0),
(5,10,'Open Source Initiative Blog','open-source-initiative-blog','http://www.opensource.org/blog/feed',null,1,5,3600,0,'0000-00-00 00:00:00',5,0),
(6,11,'PHP News and Announcements','php-news-and-announcements','http://www.php.net/feed.atom',null,1,5,3600,62,'2008-09-14 00:25:37',1,0),
(6,12,'Planet MySQL','planet-mysql','http://www.planetmysql.org/rss20.xml',null,1,5,3600,62,'2008-09-14 00:25:51',2,0),
(6,13,'Linux Foundation Announcements','linux-foundation-announcements','http://www.linuxfoundation.org/press/rss20.xml',null,1,5,3600,62,'2008-09-14 00:26:11',3,0),
(6,14,'Mootools Blog','mootools-blog','http://feeds.feedburner.com/mootools-blog',null,1,5,3600,62,'2008-09-14 00:26:51',4,0);


DROP TABLE IF EXISTS `#__plugins`;
CREATE TABLE `#__plugins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `element` varchar(100) NOT NULL DEFAULT '',
  `folder` varchar(100) NOT NULL DEFAULT '',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(3) NOT NULL DEFAULT '0',
  `iscore` tinyint(3) NOT NULL DEFAULT '0',
  `client_id` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_folder` (`published`,`client_id`,`access`,`folder`)
) ENGINE=MyISAM AUTO_INCREMENT=59 DEFAULT CHARSET=utf8;
INSERT INTO `#__plugins` VALUES
(1,'Authentication - Joomla','joomla','authentication',0,1,1,1,0,0,'0000-00-00 00:00:00',''),
(2,'Authentication - LDAP','ldap','authentication',0,2,0,1,0,0,'0000-00-00 00:00:00','host=\nport=389\nuse_ldapV3=0\nnegotiate_tls=0\nno_referrals=0\nauth_method=bind\nbase_dn=\nsearch_string=\nusers_dn=\nusername=\npassword=\nldap_fullname=fullName\nldap_email=mail\nldap_uid=uid\n\n'),
(3,'Authentication - GMail','gmail','authentication',0,4,0,0,0,0,'0000-00-00 00:00:00',''),
(4,'Authentication - OpenID','openid','authentication',0,3,0,0,0,0,'0000-00-00 00:00:00',''),
(5,'User - Joomla!','joomla','user',0,0,1,0,0,0,'0000-00-00 00:00:00','autoregister=1\n\n'),
(6,'Search - Content','content','search',0,1,1,1,0,0,'0000-00-00 00:00:00','search_limit=50\nsearch_content=1\nsearch_uncategorised=1\nsearch_archived=1\n\n'),
(7,'Search - Contacts','contacts','search',0,3,1,1,0,0,'0000-00-00 00:00:00','search_limit=50\n\n'),
(8,'Search - Categories','categories','search',0,4,1,0,0,0,'0000-00-00 00:00:00','search_limit=50\n\n'),
(9,'Search - Sections','sections','search',0,5,1,0,0,0,'0000-00-00 00:00:00','search_limit=50\n\n'),
(10,'Search - Newsfeeds','newsfeeds','search',0,6,1,0,0,0,'0000-00-00 00:00:00','search_limit=50\n\n'),
(11,'Search - Weblinks','weblinks','search',0,2,1,1,0,0,'0000-00-00 00:00:00','search_limit=50\n\n'),
(12,'Content - Pagebreak','pagebreak','content',0,10000,1,1,0,0,'0000-00-00 00:00:00','enabled=1\ntitle=1\nmultipage_toc=1\nshowall=1\n\n'),
(13,'Content - Rating','vote','content',0,4,1,1,0,0,'0000-00-00 00:00:00',''),
(14,'Content - Email Cloaking','emailcloak','content',0,5,1,0,0,0,'0000-00-00 00:00:00','mode=1\n\n'),
(15,'Content - Code Hightlighter (GeSHi)','geshi','content',0,5,0,0,0,0,'0000-00-00 00:00:00',''),
(16,'Content - Load Module','loadmodule','content',0,6,1,0,0,0,'0000-00-00 00:00:00','enabled=1\nstyle=0\n\n'),
(17,'Content - Page Navigation','pagenavigation','content',0,2,1,1,0,0,'0000-00-00 00:00:00','position=1\n\n'),
(18,'Editor - No Editor','none','editors',0,0,1,1,0,0,'0000-00-00 00:00:00',''),
(19,'Editor - TinyMCE','tinymce','editors',0,0,1,1,0,0,'0000-00-00 00:00:00','mode=advanced\nskin=0\ncompressed=0\ncleanup_startup=0\ncleanup_save=2\nentity_encoding=raw\nlang_mode=0\nlang_code=en\ntext_direction=ltr\ncontent_css=1\ncontent_css_custom=\nrelative_urls=1\nnewlines=0\ninvalid_elements=applet\nextended_elements=\ntoolbar=top\ntoolbar_align=left\nhtml_height=550\nhtml_width=750\nelement_path=1\nfonts=1\npaste=1\nsearchreplace=1\ninsertdate=1\nformat_date=%Y-%m-%d\ninserttime=1\nformat_time=%H:%M:%S\ncolors=1\ntable=1\nsmilies=1\nmedia=1\nhr=1\ndirectionality=1\nfullscreen=1\nstyle=1\nlayer=1\nxhtmlxtras=1\nvisualchars=1\nnonbreaking=1\ntemplate=0\nadvimage=1\nadvlink=1\nautosave=1\ncontextmenu=1\ninlinepopups=1\nsafari=1\ncustom_plugin=\ncustom_button=\n\n'),
(20,'Editor - XStandard Lite 2.0','xstandard','editors',0,0,0,1,0,0,'0000-00-00 00:00:00',''),
(21,'Editor Button - Image','image','editors-xtd',0,0,1,0,0,0,'0000-00-00 00:00:00',''),
(22,'Editor Button - Pagebreak','pagebreak','editors-xtd',0,0,1,0,0,0,'0000-00-00 00:00:00',''),
(23,'Editor Button - Readmore','readmore','editors-xtd',0,0,1,0,0,0,'0000-00-00 00:00:00',''),
(24,'XML-RPC - Joomla','joomla','xmlrpc',0,7,0,1,0,0,'0000-00-00 00:00:00',''),
(25,'XML-RPC - Blogger API','blogger','xmlrpc',0,7,0,1,0,0,'0000-00-00 00:00:00','catid=1\nsectionid=0\n\n'),
(27,'System - SEF','sef','system',0,1,1,0,0,62,'2010-01-25 23:57:16',''),
(28,'System - Debug','debug','system',0,2,1,0,0,62,'2010-01-25 23:57:05','queries=1\nmemory=1\nlangauge=1\n\n'),
(29,'System - Legacy','legacy','system',0,3,0,1,0,0,'0000-00-00 00:00:00','route=0\n\n'),
(30,'System - Cache','cache','system',0,4,0,1,0,0,'0000-00-00 00:00:00','browsercache=0\ncachetime=15\n\n'),
(31,'System - Log','log','system',0,5,0,1,0,0,'0000-00-00 00:00:00',''),
(32,'System - Remember Me','remember','system',0,6,1,1,0,0,'0000-00-00 00:00:00',''),
(33,'System - Backlink','backlink','system',0,7,0,1,0,0,'0000-00-00 00:00:00',''),
(34,'JA Popup','plg_japopup','system',0,0,1,0,0,0,'0000-00-00 00:00:00','group1=fancybox\ngroup1-fancybox-centerOnScroll=1\ngroup1-fancybox-image_scale=1\ngroup1-fancybox-speed_in=500\ngroup1-fancybox-speed_out=500\ngroup1-highslide-outline=drop-shadow\ngroup1-highslide-speed_in=250\ngroup1-highslide-speed_out=250\ngroup1-shadowbox-animateFade=1\ngroup1-shadowbox-animate=1\ngroup1-shadowbox-animSequence=wh\ngroup1-shadowbox-overlayColor=#000\ngroup1-shadowbox-viewportPadding=20\ngroup1-multibox-contentColor=#FFF\ngroup1-multibox-showControls=1\nwidth=600\nheight=400\noverlay=1\noverlay_opacity=0.7\nadd_title=1\nadd_desc=1\nimage_slideshow=one\n'),
(36,'JA Menu Parameters','plg_jamenuparams','system',0,0,1,0,0,0,'0000-00-00 00:00:00',''),
(37,'Content - JA Thumbnail','plg_jathumbnail','content',0,0,1,0,0,62,'2010-03-04 01:42:44','content_mode=0\ncontent_mode-auto-content_position=0\ncontent_mode-auto-manual-content_width=200\ncontent_mode-auto-manual-content_height=200\ncontent_mode-auto-manual-crop_image=1\ncontent_mode-auto-manual-content_align=left\nblog_mode=1\nblog_mode-1-blog_frontpage=1\nblog_mode-1-blog_leading_width=200\nblog_mode-1-blog_leading_height=100\nblog_mode-1-blog_intro_width=200\nblog_mode-1-blog_intro_height=100\nblog_mode-1-crop_image=1\n\n'),
(49,'Search - K2','k2','search',0,0,1,0,0,0,'0000-00-00 00:00:00','search_limit=50\n'),
(50,'System - K2','k2','system',0,0,1,0,0,0,'0000-00-00 00:00:00',''),
(51,'User - K2','k2','user',0,0,1,0,0,62,'2010-03-12 11:44:03',''),
(55,'Azrul System Mambot','azrul.system','system',0,0,1,0,0,0,'0000-00-00 00:00:00','');


DROP TABLE IF EXISTS `#__poll_data`;
CREATE TABLE `#__poll_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pollid` int(11) NOT NULL DEFAULT '0',
  `text` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `pollid` (`pollid`,`text`(1))
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;
INSERT INTO `#__poll_data` VALUES
(1,14,'Community Sites',2),
(2,14,'Public Brand Sites',3),
(3,14,'eCommerce',1),
(4,14,'Blogs',0),
(5,14,'Intranets',0),
(6,14,'Photo and Media Sites',4),
(7,14,'All of the Above!',4),
(8,14,'',0),
(9,14,'',0),
(10,14,'',0),
(11,14,'',0),
(12,14,'',0);


DROP TABLE IF EXISTS `#__poll_date`;
CREATE TABLE `#__poll_date` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `vote_id` int(11) NOT NULL DEFAULT '0',
  `poll_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `poll_id` (`poll_id`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
INSERT INTO `#__poll_date` VALUES
(1,'2006-10-09 13:01:58',1,14),
(2,'2006-10-10 15:19:43',7,14),
(3,'2006-10-11 11:08:16',7,14),
(4,'2006-10-11 15:02:26',2,14),
(5,'2006-10-11 15:43:03',7,14),
(6,'2006-10-11 15:43:38',7,14),
(7,'2006-10-12 00:51:13',2,14),
(8,'2007-05-10 19:12:29',3,14),
(9,'2007-05-14 14:18:00',6,14),
(10,'2007-06-10 15:20:29',6,14),
(11,'2007-07-03 12:37:53',2,14),
(12,'2010-02-01 21:05:57',6,14),
(13,'2010-03-18 20:27:33',6,14),
(14,'2010-03-19 22:10:34',7,14);


DROP TABLE IF EXISTS `#__poll_menu`;
CREATE TABLE `#__poll_menu` (
  `pollid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`pollid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__polls`;
CREATE TABLE `#__polls` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `voters` int(9) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `lag` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
INSERT INTO `#__polls` VALUES
(14,'Joomla! is used for?','joomla-is-used-for',14,0,'0000-00-00 00:00:00',1,0,86400);


DROP TABLE IF EXISTS `#__sections`;
CREATE TABLE `#__sections` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `image` text NOT NULL,
  `scope` varchar(50) NOT NULL DEFAULT '',
  `image_position` varchar(30) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_scope` (`scope`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
INSERT INTO `#__sections` VALUES
(1,'News','','news','articles.jpg','content','right','Select a news topic from the list below, then select a news article to read.',1,0,'0000-00-00 00:00:00',3,0,3,''),
(3,'FAQs','','faqs','key.jpg','content','left','From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.',1,0,'0000-00-00 00:00:00',5,0,23,''),
(4,'About Joomla!','','about-joomla','','content','left','',1,0,'0000-00-00 00:00:00',2,0,14,''),
(5,'Demo section','','demo-section','','content','left','Gravida Phasellus tellus justo libero id Lorem lobortis Curabitur cursus eros. Tempus consequat laoreet auctor Quisque fringilla sit pretium tincidunt tincidunt nec. Sit Phasellus Integer ultrices tempus adipiscing Aliquam Curabitur leo odio elit. Sodales Aliquam convallis tellus venenatis sociis elit Sed Nullam id Vestibulum.',1,0,'0000-00-00 00:00:00',6,0,7,'');


DROP TABLE IF EXISTS `#__session`;
CREATE TABLE `#__session` (
  `username` varchar(150) DEFAULT '',
  `time` varchar(14) DEFAULT '',
  `session_id` varchar(200) NOT NULL DEFAULT '0',
  `guest` tinyint(4) DEFAULT '1',
  `userid` int(11) DEFAULT '0',
  `usertype` varchar(50) DEFAULT '',
  `gid` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `data` longtext,
  PRIMARY KEY (`session_id`(64)),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__session` VALUES
('','1270808109','0db2a2c0a332a16e4cc8a86592726e5a',1,0,'',0,0,'__default|a:11:{s:15:\"session.counter\";i:9;s:19:\"session.timer.start\";i:1270807887;s:18:\"session.timer.last\";i:1270808081;s:17:\"session.timer.now\";i:1270808109;s:22:\"session.client.browser\";s:88:\"Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.3) Gecko/20100401 Firefox/3.6.3\";s:8:\"registry\";O:9:\"JRegistry\":3:{s:17:\"_defaultNameSpace\";s:7:\"session\";s:9:\"_registry\";a:1:{s:7:\"session\";a:1:{s:4:\"data\";O:8:\"stdClass\":0:{}}}s:7:\"_errors\";a:0:{}}s:4:\"user\";O:5:\"JUser\":19:{s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";N;s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:3:\"gid\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:3:\"aid\";i:0;s:5:\"guest\";i:1;s:7:\"_params\";O:10:\"JParameter\":7:{s:4:\"_raw\";s:0:\"\";s:4:\"_xml\";N;s:9:\"_elements\";a:0:{}s:12:\"_elementPath\";a:1:{i:0;s:90:\"/home/www/jadev_data/sites/auto/qs.ores.1270807862/libraries/joomla/html/parameter/element\";}s:17:\"_defaultNameSpace\";s:8:\"_default\";s:9:\"_registry\";a:1:{s:8:\"_default\";a:1:{s:4:\"data\";O:8:\"stdClass\":0:{}}}s:7:\"_errors\";a:0:{}}s:9:\"_errorMsg\";N;s:7:\"_errors\";a:0:{}}s:10:\"afterlogin\";s:42:\"/jadev_data/sites/auto/qs.ores.1270807862/\";s:13:\"session.token\";s:32:\"2f51c4e1b6cb8fa5983c74a68bd86735\";s:10:\"commenturl\";s:108:\"index.php?option=com_content&view=article&id=50:marketing-solutions-company&catid=35:demo-category&Itemid=95\";s:12:\"totalComment\";s:1:\"4\";}JAC_LAST_VISITED|i:1270486800;'),
('admin','1270808072','a426f128fabdcbee897d99d5fd9aad82',0,62,'Super Administrator',25,1,'__default|a:10:{s:15:\"session.counter\";i:11;s:19:\"session.timer.start\";i:1270807893;s:18:\"session.timer.last\";i:1270808072;s:17:\"session.timer.now\";i:1270808072;s:22:\"session.client.browser\";s:88:\"Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.3) Gecko/20100401 Firefox/3.6.3\";s:8:\"registry\";O:9:\"JRegistry\":3:{s:17:\"_defaultNameSpace\";s:7:\"session\";s:9:\"_registry\";a:2:{s:7:\"session\";a:1:{s:4:\"data\";O:8:\"stdClass\":0:{}}s:11:\"application\";a:1:{s:4:\"data\";O:8:\"stdClass\":1:{s:4:\"lang\";s:0:\"\";}}}s:7:\"_errors\";a:0:{}}s:4:\"user\";O:5:\"JUser\":19:{s:2:\"id\";s:2:\"62\";s:4:\"name\";s:13:\"Administrator\";s:8:\"username\";s:5:\"admin\";s:5:\"email\";s:25:\"khanhlh@joomsolutions.com\";s:8:\"password\";s:65:\"98f4b078307c3afc92dbe0c7a5c5c396:tAYSEasTtbkYH3q79xHzn3my7pOXoskI\";s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";s:19:\"Super Administrator\";s:5:\"block\";s:1:\"0\";s:9:\"sendEmail\";s:1:\"1\";s:3:\"gid\";s:2:\"25\";s:12:\"registerDate\";s:19:\"2010-04-09 17:11:20\";s:13:\"lastvisitDate\";s:19:\"0000-00-00 00:00:00\";s:10:\"activation\";s:0:\"\";s:6:\"params\";s:0:\"\";s:3:\"aid\";i:2;s:5:\"guest\";i:0;s:7:\"_params\";O:10:\"JParameter\":7:{s:4:\"_raw\";s:0:\"\";s:4:\"_xml\";N;s:9:\"_elements\";a:0:{}s:12:\"_elementPath\";a:1:{i:0;s:90:\"/home/www/jadev_data/sites/auto/qs.ores.1270807862/libraries/joomla/html/parameter/element\";}s:17:\"_defaultNameSpace\";s:8:\"_default\";s:9:\"_registry\";a:1:{s:8:\"_default\";a:1:{s:4:\"data\";O:8:\"stdClass\":0:{}}}s:7:\"_errors\";a:0:{}}s:9:\"_errorMsg\";N;s:7:\"_errors\";a:0:{}}s:10:\"afterlogin\";s:112:\"/jadev_data/sites/auto/qs.ores.1270807862/administrator/index.php?option=com_jacomment&view=configs&group=layout\";s:13:\"session.token\";s:32:\"e8d7fcffbc2dc9df858142e94e89f1f5\";s:12:\"totalComment\";s:1:\"7\";}JATOOLBAR_VERIFY_PASSED|i:0;menuId|s:32:\"544d655d7be328972bb46bcfd4e39c79\";');


DROP TABLE IF EXISTS `#__stats_agents`;
CREATE TABLE `#__stats_agents` (
  `agent` varchar(255) NOT NULL DEFAULT '',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hits` int(11) unsigned NOT NULL DEFAULT '1'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__templates_menu`;
CREATE TABLE `#__templates_menu` (
  `template` varchar(255) NOT NULL DEFAULT '',
  `menuid` int(11) NOT NULL DEFAULT '0',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`menuid`,`client_id`,`template`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `#__templates_menu` VALUES
('ja_ores',0,0),
('khepri',0,1);


DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `catid` (`catid`,`published`,`archived`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
INSERT INTO `#__weblinks` VALUES
(1,2,0,'Joomla!','joomla','http://www.joomla.org','Home of Joomla!','2005-02-14 15:19:02',3,1,0,'0000-00-00 00:00:00',1,0,1,'target=0'),
(2,2,0,'php.net','php','http://www.php.net','The language that Joomla! is developed in','2004-07-07 11:33:24',6,1,0,'0000-00-00 00:00:00',3,0,1,''),
(3,2,0,'MySQL','mysql','http://www.mysql.com','The database that Joomla! uses','2004-07-07 10:18:31',1,1,0,'0000-00-00 00:00:00',5,0,1,''),
(4,2,0,'OpenSourceMatters','opensourcematters','http://www.opensourcematters.org','Home of OSM','2005-02-14 15:19:02',11,1,0,'0000-00-00 00:00:00',2,0,1,'target=0'),
(5,2,0,'Joomla! - Forums','joomla-forums','http://forum.joomla.org','Joomla! Forums','2005-02-14 15:19:02',4,1,0,'0000-00-00 00:00:00',4,0,1,'target=0'),
(6,2,0,'Ohloh Tracking of Joomla!','ohloh-tracking-of-joomla','http://www.ohloh.net/projects/20','Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.','2007-07-19 09:28:31',1,1,0,'0000-00-00 00:00:00',6,0,1,'target=0\n\n');


